import React from 'react';
// 240-479 pixels
export function getDeviceKindByWidth(width) {
  if (width >= 992) return 'desktop';
  if (width >= 768) return 'tablet';
  if (width >= 480) return 'large-phone';
  return 'phone';
}
var DeviceKindContext = React.createContext(undefined);
export function DeviceKindProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/React.createElement(DeviceKindContext.Provider, {
    value: value
  }, children);
}
export function useDeviceKind() {
  var deviceKind = React.useContext(DeviceKindContext);
  return deviceKind;
}