import React from 'react';
import IconText from './IconText';

var createIcon = function createIcon(fontFamily, fontFileName, glyphMap) {
  return function Icon(_ref) {
    var name = _ref.name,
        style = _ref.style;
    var glyph = glyphMap[name] || '?';

    if (typeof glyph === 'number') {
      glyph = String.fromCharCode(glyph);
    }

    var styleProps = {
      $fontFamilyValue: fontFamily,
      style: style
    };
    return /*#__PURE__*/React.createElement(IconText, styleProps, glyph);
  };
};

export default createIcon;