import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  font-size: ", "px;\n  color: white;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  background-color: ", ";\n  border-radius: ", "px;\n  height: ", "px;\n  width: ", "px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import * as React from 'react';
import Colors from '../../apis/Colors';
import { styled } from '../../apis/Style';
import Text from '../../primitives/Text';
import View from '../../primitives/View';
import Badge from '../Badge';
import Icon from '../Icon';
import { SizeToRadius, getInitials } from './helpers';
export default function Avatar(_ref) {
  var _ref$backgroundColor = _ref.backgroundColor,
      backgroundColor = _ref$backgroundColor === void 0 ? Colors.GREY : _ref$backgroundColor,
      className = _ref.className,
      icon = _ref.icon,
      style = _ref.style,
      badge = _ref.badge,
      testID = _ref.testID,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '?' : _ref$name,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size;
  return /*#__PURE__*/React.createElement(AvatarContainer, {
    $avatarBgColor: backgroundColor,
    className: className,
    $size: size,
    style: style,
    testID: testID
  }, icon ? /*#__PURE__*/React.createElement(Icon, {
    name: icon,
    color: "white",
    size: size
  }) : /*#__PURE__*/React.createElement(StyledText, {
    $size: size
  }, getInitials(name)), badge && /*#__PURE__*/React.createElement(Badge, {
    number: badge
  }));
}
var AvatarContainer = styled(View)(_templateObject(), function (_ref2) {
  var $avatarBgColor = _ref2.$avatarBgColor;
  return $avatarBgColor;
}, function (_ref3) {
  var $size = _ref3.$size;
  return SizeToRadius[$size];
}, function (_ref4) {
  var $size = _ref4.$size;
  return 2 * SizeToRadius[$size];
}, function (_ref5) {
  var $size = _ref5.$size;
  return 2 * SizeToRadius[$size];
});
var StyledText = styled(Text)(_templateObject2(), function (_ref6) {
  var $size = _ref6.$size;
  return SizeToRadius[$size];
});