import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import React from 'react';
import styled from 'styled-components';
import ButtonSpinner from './ButtonSpinner';
import { ButtonLabel, StyledIcon, buttonContainerStyle } from './styles';

var createButton = function createButton(containerComponent, getContainerProps) {
  var StyledContainer = styled(containerComponent).withConfig({
    displayName: "createButton__StyledContainer",
    componentId: "sc-1ti3i60-0"
  })(["", ";"], buttonContainerStyle);

  function Button(props) {
    var className = props.className,
        disabled = props.disabled,
        icon = props.icon,
        iconStyle = props.iconStyle,
        loading = props.loading,
        onPress = props.onPress,
        style = props.style,
        textStyle = props.textStyle,
        testID = props.testID,
        text = props.text,
        _props$type = props.type,
        type = _props$type === void 0 ? 'primary' : _props$type;
    var styleProps = {
      // pass the original value of `disabled` so that we know if button is
      // disabled because it's loading
      hasDisabledStyle: disabled,
      loading: loading,
      type: type
    };

    var containerStyleProps = _objectSpread(_objectSpread({}, styleProps), {}, {
      className: className,
      icon: icon,
      style: style,
      text: text
    });

    return /*#__PURE__*/React.createElement(StyledContainer, Object.assign({}, getContainerProps && getContainerProps(props) || {}, containerStyleProps, {
      disabled: disabled || loading,
      onPress: onPress,
      testID: testID
    }), icon && /*#__PURE__*/React.createElement(StyledIcon, Object.assign({}, styleProps, {
      name: icon,
      style: iconStyle
    })), text && /*#__PURE__*/React.createElement(ButtonLabel, Object.assign({}, styleProps, {
      style: textStyle
    }), text), loading && /*#__PURE__*/React.createElement(ButtonSpinner, styleProps));
  }

  return Button;
};

export default createButton;