import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  ", ";\n\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import { css } from '../../apis/Style';
import { ButtonLabel, SpinnerContainer, StyledIcon, buttonContainerStyle, buttonTextStyle } from './common-styles';
import { getActiveBackgroundColor, getActiveBorderColor, getActiveTextColor, getFocusedBackgroundColor, getFocusedBorderColor, getFocusedTextColor } from './helpers';
var webButtonContainerStyle = css(_templateObject(), buttonContainerStyle, function (_ref) {
  var disabled = _ref.disabled,
      type = _ref.type;
  return !disabled && "\n    &:hover,\n    &:focus {\n      background-color: ".concat(getFocusedBackgroundColor({
    type: type
  }), ";\n      border-color: ").concat(getFocusedBorderColor({
    type: type
  }), ";\n      * {\n        color: ").concat(getFocusedTextColor({
    type: type
  }), ";\n      }\n    }\n\n    &:active {\n      background-color: ").concat(getActiveBackgroundColor({
    type: type
  }), ";\n      border-color: ").concat(getActiveBorderColor({
    type: type
  }), ";\n      * {\n        color: ").concat(getActiveTextColor({
    type: type
  }), ";\n      }\n    }\n  ");
});
export { webButtonContainerStyle as buttonContainerStyle, buttonTextStyle, ButtonLabel, SpinnerContainer, StyledIcon };