import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import moment from 'moment';
import * as React from 'react';
import { DatePickerIOS } from 'react-native';
import PickerNative from '../../../internals/Picker.native';
import { DEFAULT_DATE_DISPLAY_FORMAT, DEFAULT_DATE_VALUE_FORMAT } from '../constants';
import { PlaceholderText, ValueText } from '../StyledComponents';

var getDefaultDate = function getDefaultDate() {
  return new Date();
};

var DatePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  var _super = _createSuper(DatePicker);

  _createClass(DatePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }]);

  function DatePicker(props) {
    var _this;

    _classCallCheck(this, DatePicker);

    _this = _super.call(this, props);

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._onDateChange = function (date) {
      _this.setState({
        selectedDate: date
      });
    };

    _this._renderPopup = function () {
      return /*#__PURE__*/React.createElement(DatePickerIOS, {
        date: _this.state.selectedDate || getDefaultDate(),
        mode: "date",
        onDateChange: _this._onDateChange
      });
    };

    _this._renderValue = function () {
      var _this$props = _this.props,
          displayFormat = _this$props.displayFormat,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          valueFormat = _this$props.valueFormat;
      var date = moment(value || '', valueFormat);
      var dateStr = date.isValid() ? date.format(displayFormat) : '';

      if (!dateStr) {
        return /*#__PURE__*/React.createElement(PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(ValueText, null, dateStr);
    };

    _this._selectDate = function (date) {
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          valueFormat = _this$props2.valueFormat;

      _this.blur();

      _this.setState({
        selectedDate: date
      });

      if (onValueChange) {
        var dateMoment = moment(date);

        if (dateMoment.isValid()) {
          onValueChange(dateMoment.format(valueFormat));
        } else {
          onValueChange(null);
        }
      }
    };

    var _this$props3 = _this.props,
        _value = _this$props3.value,
        _valueFormat = _this$props3.valueFormat;
    var initialDate = moment(_value || '', _valueFormat);

    if (!initialDate.isValid()) {
      initialDate = moment();
    }

    _this.state = {
      selectedDate: initialDate.toDate()
    };
    return _this;
  }

  _createClass(DatePicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          accessibilityLabel = _this$props4.accessibilityLabel,
          autoFocus = _this$props4.autoFocus,
          clearable = _this$props4.clearable,
          clearValueText = _this$props4.clearValueText,
          onBlur = _this$props4.onBlur,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly,
          renderDropdownIcon = _this$props4.renderDropdownIcon,
          style = _this$props4.style,
          testID = _this$props4.testID;
      var styleProps = {
        style: style
      };
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onClear: function onClear() {
          return _this2._selectDate(null);
        },
        onConfirm: function onConfirm() {
          return _this2._selectDate(_this2.state.selectedDate || getDefaultDate());
        },
        onFocus: onFocus,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopup: this._renderPopup,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/React.createElement(PickerNative, Object.assign({}, styleProps, props));
    }
  }]);

  return DatePicker;
}(React.Component);

DatePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: DEFAULT_DATE_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: DEFAULT_DATE_VALUE_FORMAT
};
DatePicker.displayName = 'DatePicker';
export default DatePicker;