import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import * as React from 'react';
import View from '../../primitives/View';
import Icon from '../Icon'; // Note that this is not the Modal we export. It has a slide animation on native.

import Modal from './Modal';
import { ActionRow, BackLink, Label, LinkContainer, LinkInner, ModalContainer } from './StyledComponents.native';
export default function Dropdown(_ref) {
  var actions = _ref.actions,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'more-vert' : _ref$icon,
      children = _ref.children,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? 'black' : _ref$iconColor;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var close = function close() {
    return setActive(false);
  };

  var renderAction = function renderAction(action) {
    return /*#__PURE__*/React.createElement(ActionRow, {
      key: action.label,
      onPress: function onPress() {
        close();
        action.onPress();
      }
    }, action.icon && /*#__PURE__*/React.createElement(Icon, {
      name: action.icon
    }), /*#__PURE__*/React.createElement(Label, null, action.label));
  };

  return /*#__PURE__*/React.createElement(LinkContainer, null, /*#__PURE__*/React.createElement(LinkInner, {
    onPress: function onPress() {
      return setActive(true);
    }
  }, children || /*#__PURE__*/React.createElement(Icon, {
    name: icon,
    color: iconColor
  })), /*#__PURE__*/React.createElement(Modal, {
    onRequestClose: close,
    visible: active
  }, /*#__PURE__*/React.createElement(ModalContainer, null, /*#__PURE__*/React.createElement(BackLink, {
    onPress: close
  }, /*#__PURE__*/React.createElement(View, {
    pointerEvents: 'none'
  }, /*#__PURE__*/React.createElement(Icon, {
    name: "arrow-back-ios"
  }))), actions.map(renderAction))));
}