import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from 'react';
import { styled } from '../../apis/Style';
import TouchableView from '../../primitives/TouchableView';
import Icon from '../Icon';

var IconButton = function IconButton(_ref) {
  var className = _ref.className,
      color = _ref.color,
      disabled = _ref.disabled,
      name = _ref.name,
      onPress = _ref.onPress,
      style = _ref.style,
      tooltip = _ref.tooltip,
      size = _ref.size,
      testID = _ref.testID;
  var iconProps = {
    color: color,
    name: name,
    size: size
  };
  return /*#__PURE__*/React.createElement(StyledTouchableView, {
    className: className,
    disabled: disabled,
    onPress: onPress,
    style: style,
    tooltip: tooltip,
    size: size,
    testID: testID || "iconButton-".concat(name)
  }, /*#__PURE__*/React.createElement(Icon, iconProps));
};

export default IconButton;
var StyledTouchableView = styled(TouchableView)(_templateObject(), function (_ref2) {
  var size = _ref2.size;
  var containerSizeString;
  var sizes = {
    small: 16,
    medium: 32,
    large: 48
  }; // If use input is number then use number
  // Else if use input is nothing return default 16, and the container should be 24x24 to keep a space between two Icons
  // If user input small, medium or large then return the relevent one

  if (typeof size === 'number' && Number.isFinite(size) && size > 0) {
    containerSizeString = size;
  } else if (size === 'small' || size === 'medium' || size === 'large') {
    containerSizeString = sizes[size];
  } else {
    return "height: 24px;\n              width: 24px;";
  }

  return "height: ".concat(containerSizeString, "px;\n          width: ").concat(containerSizeString, "px;");
});