import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import chunk from 'lodash/chunk';
import React, { useMemo, useState } from 'react';
import styled from 'styled-components';
import MateriIcon from '../../../../glyphmaps/MaterialIcons.json';
import TextField from '../../../components/input-fields/TextField';
import FlatList from '../../../primitives/FlatList';
import View from '../../../primitives/View';
import IconButton from '../../IconButton';
import Modal from '../../Modal';
var iconList = Object.keys(MateriIcon);

var IconModal = function IconModal(_ref) {
  var modalVisable = _ref.modalVisable,
      setModalVisable = _ref.setModalVisable,
      setIconName = _ref.setIconName;
  var ARRAY_SIZE = 23;

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      input = _useState2[0],
      setInput = _useState2[1]; // filter the list and generate 2D array for flatList


  var resultArray = useMemo(function () {
    return chunk(iconList.filter(function (icon) {
      return input ? icon.includes(input) : true;
    }), ARRAY_SIZE);
  }, [input]);
  return /*#__PURE__*/React.createElement(Modal, {
    onRequestClose: function onRequestClose() {
      return setModalVisable(false);
    },
    visible: modalVisable,
    title: "Please choose your Icon"
  }, /*#__PURE__*/React.createElement(IconsContainer, null, /*#__PURE__*/React.createElement(TextField, {
    value: input,
    onValueChange: setInput,
    placeholder: "Type to search Icon",
    reserveErrorSpace: false
  }), /*#__PURE__*/React.createElement(FlatListContainer, null, /*#__PURE__*/React.createElement(FlatList, {
    horizontal: false,
    data: resultArray,
    renderItem: function renderItem(_ref2) {
      var item = _ref2.item;
      return /*#__PURE__*/React.createElement(FlatListRow, {
        key: item[0]
      }, item.map(function (icon) {
        return /*#__PURE__*/React.createElement(IconButton, {
          key: icon,
          name: icon,
          onPress: function onPress() {
            setIconName(icon);
            setModalVisable(false);
          },
          tooltip: icon
        });
      }));
    }
  }))));
};

var IconsContainer = styled(View).withConfig({
  displayName: "IconModalweb__IconsContainer",
  componentId: "sc-17qn6fz-0"
})(["padding:0px 8px;"]);
var FlatListContainer = styled(View).withConfig({
  displayName: "IconModalweb__FlatListContainer",
  componentId: "sc-17qn6fz-1"
})(["align-items:center;height:145px;"]);
var FlatListRow = styled(View).withConfig({
  displayName: "IconModalweb__FlatListRow",
  componentId: "sc-17qn6fz-2"
})(["flex-direction:row;"]);
export default IconModal;