import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import * as React from 'react';
import Colors from '../../apis/Colors';
import Icon from '../Icon';
import { Context, useMenuContext } from './MenuContext'; // Note that this is not the Modal we export. It has a slide animation on native.

import Modal from './Modal';
import { ActionRow, MenuItemIcon, MenuItemLabel, ModalContainer, TriggerContainer } from './StyledComponents.native';
export default function Menu(_ref) {
  var children = _ref.children,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'menu' : _ref$icon,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? Colors.BLACK : _ref$iconColor,
      testID = _ref.testID,
      trigger = _ref.trigger,
      triggerStyle = _ref.triggerStyle;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var close = function close() {
    return setActive(false);
  };

  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      close: close,
      active: active
    }
  }, /*#__PURE__*/React.createElement(TriggerContainer, {
    onPress: function onPress() {
      return setActive(true);
    },
    style: triggerStyle,
    testID: testID
  }, typeof trigger === 'function' ? trigger(active) : trigger || /*#__PURE__*/React.createElement(Icon, {
    name: icon,
    color: iconColor
  })), /*#__PURE__*/React.createElement(Modal, {
    onRequestClose: close,
    visible: active
  }, /*#__PURE__*/React.createElement(ModalContainer, null, children)));
}

var Item = function Item(_ref2) {
  var children = _ref2.children,
      icon = _ref2.icon,
      numberOfLines = _ref2.numberOfLines,
      _onPress = _ref2.onPress;
  var context = useMenuContext();
  return /*#__PURE__*/React.createElement(ActionRow, {
    onPress: function onPress() {
      context.close();
      _onPress === null || _onPress === void 0 ? void 0 : _onPress();
    }
  }, typeof children === 'string' ? /*#__PURE__*/React.createElement(React.Fragment, null, icon ? /*#__PURE__*/React.createElement(MenuItemIcon, {
    name: icon
  }) : null, /*#__PURE__*/React.createElement(MenuItemLabel, {
    numberOfLines: numberOfLines,
    $hasIcon: !!icon
  }, children)) : children);
};

Menu.Item = Item;