import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import { SafeAreaView } from 'react-native';
import styled from 'styled-components';
import Overlay from '../../../primitives/Overlay';
import Text from '../../../primitives/Text';
import { ModalFormHeader, ModalFormTitleText } from '../../ModalForm/FormBody/FormBody.native';
import { ModalFormHeaderCancelButton, ModalFormTitleContainer } from '../../ModalForm/StyledComponents';

var Modal = /*#__PURE__*/function (_React$Component) {
  _inherits(Modal, _React$Component);

  var _super = _createSuper(Modal);

  function Modal() {
    _classCallCheck(this, Modal);

    return _super.apply(this, arguments);
  }

  _createClass(Modal, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          onRequestClose = _this$props.onRequestClose,
          visible = _this$props.visible,
          title = _this$props.title,
          hideHeader = _this$props.hideHeader;
      return /*#__PURE__*/React.createElement(Overlay, {
        onPress: onRequestClose,
        visible: visible
      }, /*#__PURE__*/React.createElement(ModalOuterContainer, null, title || !hideHeader ? /*#__PURE__*/React.createElement(ModalFormHeader, null, /*#__PURE__*/React.createElement(ModalFormHeaderCancelButton, {
        onPress: onRequestClose
      }), /*#__PURE__*/React.createElement(ModalFormTitleContainer, null, /*#__PURE__*/React.createElement(ModalFormTitleText, null, title))) : null, /*#__PURE__*/React.createElement(ModalSafeArea, null, /*#__PURE__*/React.createElement(ModalContentContainer, null, children))));
    }
  }]);

  return Modal;
}(React.Component);

Modal.defaultProps = {
  hideHeader: false
};
export default Modal;
var ModalOuterContainer = styled.SafeAreaView.withConfig({
  displayName: "Modal__ModalOuterContainer",
  componentId: "xqv4ld-0"
})(["flex:1;"]);
var ModalSafeArea = styled.View.withConfig({
  displayName: "Modal__ModalSafeArea",
  componentId: "xqv4ld-1"
})(["flex:1;"]);
var ModalContentContainer = styled.View.withConfig({
  displayName: "Modal__ModalContentContainer",
  componentId: "xqv4ld-2"
})(["background-color:white;position:absolute;top:0;bottom:0;left:0;right:0;"]);