import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  ", ";\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from 'react';
import { View } from 'react-native';
import { KeyboardAwareScrollView } from 'react-native-keyboard-aware-scroll-view';
import styled from 'styled-components';
import { FormConfigContext } from '../../../primitives/Form/Form.native/FormConfigContext';
import Text from '../../../primitives/Text';
import Button from '../../Button';
import { ModalFormHeaderCancelButton, ModalFormHeaderSubmitButton, ModalFormTitleContainer, modalFormContentStyle, modalFormMobileHeaderContainerStyle, modalFormMobileHeaderStyle, modalFormMobileTitleTextStyle } from '../StyledComponents';

var FormBody = function FormBody(_ref) {
  var children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      onCancel = _ref.onCancel,
      onDelete = _ref.onDelete,
      onSubmit = _ref.onSubmit,
      _ref$submitButtonText = _ref.submitButtonText,
      submitButtonText = _ref$submitButtonText === void 0 ? 'Submit' : _ref$submitButtonText,
      testID = _ref.testID,
      title = _ref.title;
  return /*#__PURE__*/React.createElement(FormConfigContext.Provider, {
    value: {
      onSubmit: onSubmit
    }
  }, /*#__PURE__*/React.createElement(StyledForm, {
    testID: testID
  }, /*#__PURE__*/React.createElement(ModalFormHeader, null, /*#__PURE__*/React.createElement(ModalFormHeaderCancelButton, {
    onPress: onCancel
  }), /*#__PURE__*/React.createElement(ModalFormHeaderSubmitButton, {
    text: submitButtonText
  }), /*#__PURE__*/React.createElement(ModalFormTitleContainer, null, /*#__PURE__*/React.createElement(ModalFormTitleText, null, title))), /*#__PURE__*/React.createElement(ModalFormContent, {
    contentContainerStyle: contentContainerStyle,
    extraScrollHeight: 100
  }, children, onDelete && /*#__PURE__*/React.createElement(ModalFormDeleteButton, {
    onPress: onDelete,
    text: "Delete"
  }))));
};

export default FormBody;
var StyledForm = styled(View).withConfig({
  displayName: "FormBodynative__StyledForm",
  componentId: "sc-1c0pb26-0"
})(["flex:1;"]);
export var ModalFormTitleText = styled(Text).attrs(function (props) {
  return {
    numberOfLines: 2
  };
}).withConfig({
  displayName: "FormBodynative__ModalFormTitleText",
  componentId: "sc-1c0pb26-1"
})(["", ";"], modalFormMobileTitleTextStyle);
var ModalFormHeaderContainer = styled.SafeAreaView(_templateObject(), modalFormMobileHeaderContainerStyle);
var ModalFormHeaderInnerContainer = styled.View(_templateObject2(), modalFormMobileHeaderStyle);
export var ModalFormHeader = function ModalFormHeader(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement(ModalFormHeaderContainer, null, /*#__PURE__*/React.createElement(ModalFormHeaderInnerContainer, null, children));
};
var ModalFormContent = styled(KeyboardAwareScrollView).withConfig({
  displayName: "FormBodynative__ModalFormContent",
  componentId: "sc-1c0pb26-2"
})(["", ";"], modalFormContentStyle);
var ModalFormDeleteButton = styled(Button).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodynative__ModalFormDeleteButton",
  componentId: "sc-1c0pb26-3"
})([""]);