import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import * as React from 'react';
import useMountedState from 'react-use/lib/useMountedState';
import styled from 'styled-components';
import { useDeviceKind } from '../../../apis/DeviceKind';
import Icon from '../../../components/Icon';
import FlexDiv from '../../../internals/web/FlexDiv';
import FlexForm from '../../../internals/web/FlexForm';
import Text from '../../../primitives/Text';
import TouchableView from '../../../primitives/TouchableView';
import Button from '../../Button';
import SubmitButton from '../../SubmitButton';
import { ModalFormHeaderCancelButton, ModalFormHeaderSubmitButton, ModalFormTitleContainer, modalFormContentStyle, modalFormMobileHeaderContainerStyle, modalFormMobileHeaderStyle, modalFormMobileTitleTextStyle } from '../StyledComponents';

function FormBody(_ref) {
  var children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      onCancel = _ref.onCancel,
      onDelete = _ref.onDelete,
      onSubmit = _ref.onSubmit,
      _ref$submitButtonText = _ref.submitButtonText,
      submitButtonText = _ref$submitButtonText === void 0 ? 'Submit' : _ref$submitButtonText,
      testID = _ref.testID,
      title = _ref.title;
  var deviceKind = useDeviceKind();
  var isMounted = useMountedState();

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      deleting = _React$useState2[0],
      setDeleting = _React$useState2[1];

  var handleDelete = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!onDelete) {
                _context.next = 8;
                break;
              }

              setDeleting(true);
              _context.prev = 2;
              _context.next = 5;
              return onDelete();

            case 5:
              _context.prev = 5;

              if (isMounted()) {
                setDeleting(false);
              }

              return _context.finish(5);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[2,, 5, 8]]);
    }));

    return function handleDelete() {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleSubmit = function handleSubmit(event) {
    event.preventDefault();
    event.stopPropagation();
    onSubmit && onSubmit();
  };

  return /*#__PURE__*/React.createElement(StyledForm, {
    "data-testid": testID,
    onSubmit: handleSubmit
  }, /*#__PURE__*/React.createElement(ModalFormHeader, {
    $deviceKind: deviceKind
  }, deviceKind === 'tablet' || deviceKind === 'desktop' ? /*#__PURE__*/React.createElement(ModalFormCloseButton, {
    onPress: onCancel
  }) : /*#__PURE__*/React.createElement(ModalFormHeaderMobileContainer, null, /*#__PURE__*/React.createElement(ModalFormHeaderCancelButton, {
    onPress: onCancel
  }), /*#__PURE__*/React.createElement(ModalFormHeaderSubmitButton, {
    text: submitButtonText
  })), /*#__PURE__*/React.createElement(ModalFormTitleContainer, null, /*#__PURE__*/React.createElement(ModalFormTitleText, {
    $deviceKind: deviceKind
  }, title))), /*#__PURE__*/React.createElement(ModalFormContent, {
    $deviceKind: deviceKind,
    style: contentContainerStyle
  }, children, (deviceKind === 'phone' || deviceKind === 'large-phone') && onDelete ? /*#__PURE__*/React.createElement(ModalFormMobileDeleteButton, {
    loading: deleting,
    onPress: handleDelete,
    text: "Delete"
  }) : null), deviceKind === 'tablet' || deviceKind === 'desktop' ? /*#__PURE__*/React.createElement(ModalFormFooter, null, /*#__PURE__*/React.createElement(ModalFormRow, null, onDelete && /*#__PURE__*/React.createElement(ModalFormFooterDeleteButton, {
    loading: deleting,
    onPress: handleDelete,
    text: "Delete"
  })), /*#__PURE__*/React.createElement(ModalFormRow, null, /*#__PURE__*/React.createElement(ModalFormFooterCancelButton, {
    onPress: onCancel,
    text: "Cancel",
    testID: "modalForm-footer-cancel-button"
  }), /*#__PURE__*/React.createElement(SubmitButton, {
    text: submitButtonText,
    testID: "modalForm-footer-submit-button"
  }))) : null);
}

export default FormBody;
var StyledForm = styled(FlexForm).withConfig({
  displayName: "FormBodyweb__StyledForm",
  componentId: "sc-1ohi38h-0"
})(["flex:1;"]);
var ModalFormTitleText = styled(Text).attrs(function (props) {
  return {
    numberOfLines: 2
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormTitleText",
  componentId: "sc-1ohi38h-1"
})(["font-size:20px;color:#2b2826;", ""], function (props) {
  return props.$deviceKind === 'phone' || props.$deviceKind === 'large-phone' ? modalFormMobileTitleTextStyle : '';
});
var ModalFormHeader = styled(FlexDiv).withConfig({
  displayName: "FormBodyweb__ModalFormHeader",
  componentId: "sc-1ohi38h-2"
})(["flex:none;flex-direction:row;justify-content:space-between;background-color:white;border-bottom:1px solid #dddbda;height:55px;", ""], function (props) {
  return props.$deviceKind === 'phone' || props.$deviceKind === 'large-phone' ? "".concat(modalFormMobileHeaderStyle, ";\n      ").concat(modalFormMobileHeaderContainerStyle, ";\n      ") : '';
});
var ModalFormCloseButtonContainer = styled(TouchableView).withConfig({
  displayName: "FormBodyweb__ModalFormCloseButtonContainer",
  componentId: "sc-1ohi38h-3"
})(["align-items:center;justify-content:center;margin-left:auto;padding:20px;"]);

var ModalFormCloseButton = function ModalFormCloseButton(props) {
  return /*#__PURE__*/React.createElement(ModalFormCloseButtonContainer, props, /*#__PURE__*/React.createElement(Icon, {
    name: "clear"
  }));
};

var ModalFormHeaderMobileContainer = styled(FlexDiv).withConfig({
  displayName: "FormBodyweb__ModalFormHeaderMobileContainer",
  componentId: "sc-1ohi38h-4"
})(["display:flex;flex:1;flex-direction:row;justify-content:space-between;"]);
var ModalFormMobileDeleteButton = styled(Button).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormMobileDeleteButton",
  componentId: "sc-1ohi38h-5"
})([""]);
var ModalFormContent = styled(FlexDiv).withConfig({
  displayName: "FormBodyweb__ModalFormContent",
  componentId: "sc-1ohi38h-6"
})(["flex:1;background-color:white;overflow-y:auto;padding:38px 38px 20px 38px;", ""], function (props) {
  return props.$deviceKind === 'phone' || props.$deviceKind === 'large-phone' ? modalFormContentStyle : '';
});
var ModalFormFooter = styled(FlexDiv).withConfig({
  displayName: "FormBodyweb__ModalFormFooter",
  componentId: "sc-1ohi38h-7"
})(["flex:none;flex-direction:row;justify-content:space-between;background-color:#f1f1f0;border-top:1px solid #dddbda;height:64px;padding:16px;"]);
var ModalFormRow = styled(FlexDiv).withConfig({
  displayName: "FormBodyweb__ModalFormRow",
  componentId: "sc-1ohi38h-8"
})(["display:flex;flex-direction:row;"]);
var ModalFormFooterCancelButton = styled(Button).attrs(function (props) {
  return {
    type: 'tertiary'
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormFooterCancelButton",
  componentId: "sc-1ohi38h-9"
})(["margin-right:16px;"]);
var ModalFormFooterDeleteButton = styled(Button).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormFooterDeleteButton",
  componentId: "sc-1ohi38h-10"
})([""]);