import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React from 'react';
import Alert from '../../apis/Alert';
import { FormState } from '../../primitives/Form';
import ModalFormBody from './FormBody'; // Note that this is not the Modal we export. It has a slide animation on native.

import Modal from './Modal';

function ModalForm(_ref) {
  var children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      initialValues = _ref.initialValues,
      onDelete = _ref.onDelete,
      onRequestClose = _ref.onRequestClose,
      onSubmit = _ref.onSubmit,
      placement = _ref.placement,
      submitButtonText = _ref.submitButtonText,
      testID = _ref.testID,
      title = _ref.title,
      visible = _ref.visible,
      onCancel = _ref.onCancel;

  var handleCancel = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(_ref2) {
      var dirty, values, handleCancelClose, _handleCancelClose;

      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _handleCancelClose = function _handleCancelClose3() {
                _handleCancelClose = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                  return _regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!onCancel) {
                            _context.next = 3;
                            break;
                          }

                          _context.next = 3;
                          return onCancel(values);

                        case 3:
                          onRequestClose();

                        case 4:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));
                return _handleCancelClose.apply(this, arguments);
              };

              handleCancelClose = function _handleCancelClose2() {
                return _handleCancelClose.apply(this, arguments);
              };

              dirty = _ref2.dirty, values = _ref2.values;

              if (dirty) {
                Alert.alert({
                  title: 'You have unsaved changes',
                  actions: {
                    confirm: {
                      text: 'Discard',
                      destructive: true,
                      onPress: function onPress() {
                        return handleCancelClose();
                      }
                    },
                    cancel: {
                      text: 'Keep'
                    }
                  }
                });
              } else {
                handleCancelClose();
              }

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function handleCancel(_x) {
      return _ref3.apply(this, arguments);
    };
  }();

  var handleDelete = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(_ref4) {
      var values, res;
      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              values = _ref4.values;
              _context3.t0 = onDelete;

              if (!_context3.t0) {
                _context3.next = 6;
                break;
              }

              _context3.next = 5;
              return onDelete(values);

            case 5:
              _context3.t0 = _context3.sent;

            case 6:
              res = _context3.t0;
              onRequestClose();
              return _context3.abrupt("return", res);

            case 9:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function handleDelete(_x2) {
      return _ref5.apply(this, arguments);
    };
  }();

  var handleSubmit = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5(_ref6) {
      var actions, fieldErrors, values;
      return _regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              actions = _ref6.actions, fieldErrors = _ref6.fieldErrors, values = _ref6.values;
              actions.touchAll();

              if (!(Object.keys(fieldErrors).length === 0)) {
                _context5.next = 5;
                break;
              }

              _context5.next = 5;
              return actions.submit( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
                return _regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        if (!onSubmit) {
                          _context4.next = 3;
                          break;
                        }

                        _context4.next = 3;
                        return onSubmit(values);

                      case 3:
                        onRequestClose();

                      case 4:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              })));

            case 5:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function handleSubmit(_x3) {
      return _ref7.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement(FormState, {
    initialValues: initialValues
  }, function (formStateAndActions) {
    var actions = formStateAndActions.actions,
        formState = _objectWithoutProperties(formStateAndActions, ["actions"]);

    var formContent = typeof children === 'function' ? children(formStateAndActions) : children;
    return /*#__PURE__*/React.createElement(Modal, {
      hideHeader: true,
      onRequestClose: function onRequestClose() {
        return handleCancel(formStateAndActions);
      },
      placement: placement,
      visible: visible
    }, /*#__PURE__*/React.createElement(ModalFormBody, {
      contentContainerStyle: contentContainerStyle,
      onCancel: function onCancel() {
        return handleCancel(formStateAndActions);
      },
      onDelete: onDelete && function () {
        return handleDelete(formStateAndActions);
      },
      onSubmit: function onSubmit() {
        return handleSubmit(formStateAndActions);
      },
      submitButtonText: typeof submitButtonText === 'function' ? submitButtonText(formState) : submitButtonText,
      submitting: formState.submitting,
      testID: testID,
      title: title
    }, formContent));
  });
}

export default ModalForm;