import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  margin-left: 16px;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  margin-left: 16px;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  background-color: #fafafa;\n  align-items: center;\n  flex-direction: row;\n  justify-content: flex-end;\n  ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  font-size: 18px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from 'react';
import { styled } from '../../apis/Style';
import Text from '../../primitives/Text';
import View from '../../primitives/View';
import Button from '../Button';
import Modal from '../Modal';
import SubmitButton from '../SubmitButton';
import { BodyContainer, footerStyle, headingStyle } from './styles';
export default function ModalWizard(_ref) {
  var startFromStep = _ref.startFromStep,
      onFinish = _ref.onFinish,
      onRequestClose = _ref.onRequestClose,
      screens = _ref.screens,
      submitButtonText = _ref.submitButtonText,
      _ref$canSubmit = _ref.canSubmit,
      canSubmit = _ref$canSubmit === void 0 ? true : _ref$canSubmit,
      placement = _ref.placement,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? true : _ref$visible,
      testID = _ref.testID;

  var _React$useState = React.useState({
    step: startFromStep || 0,
    submitting: false,
    formValues: {}
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var isLastStep = state.step + 1 === screens.length;

  var handleSubmit = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setState(_objectSpread(_objectSpread({}, state), {}, {
                submitting: true
              }));

              if (!(typeof onFinish === 'function')) {
                _context.next = 4;
                break;
              }

              _context.next = 4;
              return onFinish();

            case 4:
              onRequestClose();

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleSubmit() {
      return _ref2.apply(this, arguments);
    };
  }();

  var renderCommonFooterButtons = function renderCommonFooterButtons() {
    return /*#__PURE__*/React.createElement(React.Fragment, null, state.step > 0 && /*#__PURE__*/React.createElement(FooterButton, {
      type: "tertiary",
      text: "Back",
      onPress: function onPress() {
        return setState(function (_ref3) {
          var step = _ref3.step;
          return _objectSpread(_objectSpread({}, state), {}, {
            step: step - 1
          });
        });
      }
    }), /*#__PURE__*/React.createElement(FooterButton, {
      type: "tertiary",
      text: "Cancel",
      onPress: onRequestClose
    }));
  };

  var renderForm = function renderForm() {
    var currentScreen = screens[state.step]; // Make the form aware/controllable of steps

    var FormElement = currentScreen.render();
    var initialValues = state.formValues[state.step];
    return /*#__PURE__*/React.createElement(FormElement.type, Object.assign({
      style: {
        flex: 1
      },
      initialValues: initialValues
    }, FormElement.props, {
      onSubmit: /*#__PURE__*/function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(filledFormValues) {
          return _regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  // save in state
                  setState(function (_ref5) {
                    var formValues = _ref5.formValues,
                        step = _ref5.step;

                    var updatedFormValues = _objectSpread({}, formValues);

                    updatedFormValues[state.step] = filledFormValues;
                    return _objectSpread(_objectSpread({}, state), {}, {
                      formValues: updatedFormValues,
                      step: isLastStep ? step : step + 1
                    });
                  }); // invoke user's onSubmit callback

                  _context2.next = 3;
                  return FormElement.props.onSubmit(filledFormValues);

                case 3:
                  // handling steps
                  if (isLastStep) {
                    handleSubmit();
                  }

                case 4:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        return function (_x) {
          return _ref4.apply(this, arguments);
        };
      }()
    }), function (formState) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(BodyContainer, null, typeof FormElement.props.children === 'function' ? FormElement.props.children(formState) : FormElement.props.children), /*#__PURE__*/React.createElement(Footer, null, renderCommonFooterButtons(), isLastStep ? /*#__PURE__*/React.createElement(FormSubmitButton, {
        text: submitButtonText || 'Submit',
        type: "primary"
      }) : /*#__PURE__*/React.createElement(FormSubmitButton, {
        text: "Next",
        type: "tertiary"
      })));
    });
  };

  var renderNonForm = function renderNonForm() {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(BodyContainer, null, screens[state.step].render()), /*#__PURE__*/React.createElement(Footer, null, renderCommonFooterButtons(), isLastStep ? /*#__PURE__*/React.createElement(FooterButton, {
      type: "primary",
      text: submitButtonText || 'Submit',
      onPress: handleSubmit,
      loading: state.submitting,
      disabled: !canSubmit
    }) : /*#__PURE__*/React.createElement(FooterButton, {
      type: "tertiary",
      text: "Next",
      onPress: function onPress() {
        return setState(function (_ref6) {
          var step = _ref6.step;
          return _objectSpread(_objectSpread({}, state), {}, {
            step: step + 1
          });
        });
      }
    })));
  };

  var currentScreen = screens[state.step];
  return /*#__PURE__*/React.createElement(Modal, {
    visible: visible,
    onRequestClose: onRequestClose,
    placement: placement,
    hideHeader: true,
    "data-testid": testID
  }, /*#__PURE__*/React.createElement(HeadingContainer, null, /*#__PURE__*/React.createElement(Heading, null, currentScreen.title || 'Wizard')), currentScreen.isForm ? renderForm() : renderNonForm());
}
var HeadingContainer = styled(View)(_templateObject(), headingStyle);
var Heading = styled(Text)(_templateObject2());
var Footer = styled(View)(_templateObject3(), footerStyle);
var FooterButton = styled(Button)(_templateObject4());
var FormSubmitButton = styled(SubmitButton)(_templateObject5());