import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React from 'react';
import Form from '../../../primitives/Form/Form.web';
import Text from '../../../primitives/Text';
import View from '../../../primitives/View';
import Button from '../../Button';
import SelectField from '../../input-fields/SelectField';
import TextField from '../../input-fields/TextField';
import ModalWizard from '..';
export default function ModalWizardTest() {
  var _React$useState = React.useState({
    showModal: false,
    formValues: {}
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var renderFirstScreen = function renderFirstScreen() {
    return /*#__PURE__*/React.createElement(Form, {
      onSubmit: function onSubmit(formValues) {
        return setState(_objectSpread(_objectSpread({}, state), {}, {
          formValues: formValues
        }));
      }
    }, function (_ref) {
      var getFieldValue = _ref.getFieldValue;
      var requireAge = getFieldValue('requireAge');
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Form.Field, {
        name: "name",
        label: "Name",
        component: TextField,
        validate: function validate(value) {
          return value ? undefined : 'Required';
        }
      }), /*#__PURE__*/React.createElement(Form.Field, {
        name: "requireAge",
        label: "Require Age",
        component: SelectField,
        props: {
          options: [{
            value: 'yes',
            label: 'Yes'
          }, {
            value: 'no',
            label: 'No'
          }]
        }
      }), requireAge === 'yes' && /*#__PURE__*/React.createElement(Form.Field, {
        name: "age",
        label: "Age",
        component: TextField
      }));
    });
  };

  var renderSecondScreen = function renderSecondScreen() {
    var formValues = state.formValues;
    return /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(Text, null, "Summary"), /*#__PURE__*/React.createElement(Text, null, "Selected values are:"), /*#__PURE__*/React.createElement(Text, null, "Name: ", formValues.name), /*#__PURE__*/React.createElement(Text, null, "Age: ", formValues.age));
  };

  return /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(Button, {
    onPress: function onPress() {
      return setState(_objectSpread(_objectSpread({}, state), {}, {
        showModal: true
      }));
    },
    text: "Open Wizard"
  }), state.showModal && /*#__PURE__*/React.createElement(ModalWizard, {
    testID: "test",
    visible: true,
    onRequestClose: function onRequestClose() {
      return setState(_objectSpread(_objectSpread({}, state), {}, {
        showModal: false
      }));
    },
    screens: [{
      title: 'First Step',
      render: renderFirstScreen,
      isForm: true
    }, {
      title: 'Second Step',
      render: renderSecondScreen
    }],
    onFinish: function onFinish() {
      return console.log('Submitting the wizard, values are: ', state.formValues);
    }
  }));
}