import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  font-size: 20px;\n  opacity: ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  align-items: center;\n  flex-direction: row;\n  height: ", "px;\n  padding: 0 10px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  flex: 1;\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import * as React from 'react';
import { styled } from '../../../apis/Style';
import FlatList from '../../../primitives/FlatList';
import Text from '../../../primitives/Text';
import TouchableView from '../../../primitives/TouchableView';
import View from '../../../primitives/View';
var ROW_HEIGHT = 50;

var Menu = /*#__PURE__*/function (_React$Component) {
  _inherits(Menu, _React$Component);

  var _super = _createSuper(Menu);

  function Menu() {
    var _this;

    _classCallCheck(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._defaultGetItemLayout = function (item, index) {
      return {
        length: ROW_HEIGHT,
        offset: ROW_HEIGHT * index,
        index: index
      };
    };

    _this._defaultRenderOption = function (_ref) {
      var option = _ref.option,
          isSelected = _ref.isSelected;
      var optionLabel = option[_this.props.labelKey];
      return /*#__PURE__*/React.createElement(Row, {
        testID: "select-option-".concat(optionLabel)
      }, /*#__PURE__*/React.createElement(Label, {
        numberOfLines: 2,
        $isDisabled: option.disabled
      }, optionLabel), /*#__PURE__*/React.createElement(SelectedIcon, {
        $show: isSelected
      }, "\u2713"));
    };

    _this._keyExtractor = function (option) {
      return option[_this.props.valueKey];
    };

    _this._renderItem = function (_ref2) {
      var option = _ref2.item,
          index = _ref2.index;
      var _this$props = _this.props,
          onItemSelect = _this$props.onItemSelect,
          selectedOptions = _this$props.selectedOptions;
      var renderOption = _this.props.renderOption || _this._defaultRenderOption;
      var isSelected = selectedOptions.indexOf(option) > -1;
      return /*#__PURE__*/React.createElement(TouchableView, {
        disabled: option.disabled,
        onPress: function onPress() {
          return onItemSelect(option);
        }
      }, renderOption({
        option: option,
        index: index,
        isSelected: isSelected
      }));
    };

    return _this;
  }

  _createClass(Menu, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          getItemLayout = _this$props2.getItemLayout,
          onEndReached = _this$props2.onEndReached,
          onEndReachedThreshold = _this$props2.onEndReachedThreshold,
          options = _this$props2.options;
      return /*#__PURE__*/React.createElement(FlatList, {
        data: options,
        getItemLayout: getItemLayout || this._defaultGetItemLayout,
        keyExtractor: this._keyExtractor,
        onEndReached: onEndReached,
        onEndReachedThreshold: onEndReachedThreshold,
        renderItem: this._renderItem
      });
    }
  }]);

  return Menu;
}(React.Component);

export default Menu;
var Label = styled(Text)(_templateObject(), function (_ref3) {
  var $isDisabled = _ref3.$isDisabled;
  return $isDisabled && "\n    color: #ccc;\n  ";
});
var Row = styled(View)(_templateObject2(), ROW_HEIGHT);
var SelectedIcon = styled(Text)(_templateObject3(), function (props) {
  return props.$show ? '1' : '0';
});