import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  opacity: ", ";\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  align-items: center;\n  flex-direction: row;\n  height: ", "px;\n  padding: 0 5px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  flex: 1;\n  ", ";\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  border-radius: inherit;\n  max-height: 198px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from 'react';
import { styled } from '../../../apis/Style';
import FlatList from '../../../primitives/FlatList';
import Text from '../../../primitives/Text';
import View from '../../../primitives/View';
import Icon from '../../Icon';
import OptionContainer from './OptionContainer';
import SearchBar from './SearchBar';
var ROW_HEIGHT = 35;

var _defaultGetItemLayout = function _defaultGetItemLayout(item, index) {
  return {
    length: ROW_HEIGHT,
    offset: ROW_HEIGHT * index,
    index: index
  };
};

function Menu(_ref) {
  var focusedOption = _ref.focusedOption,
      focusedOptionRef = _ref.focusedOptionRef,
      getItemLayout = _ref.getItemLayout,
      isSearchable = _ref.isSearchable,
      listRef = _ref.listRef,
      labelKey = _ref.labelKey,
      noResults = _ref.noResults,
      onEndReached = _ref.onEndReached,
      onEndReachedThreshold = _ref.onEndReachedThreshold,
      onInputBlur = _ref.onInputBlur,
      onInputChange = _ref.onInputChange,
      onItemFocus = _ref.onItemFocus,
      onItemSelect = _ref.onItemSelect,
      options = _ref.options,
      renderOption = _ref.renderOption,
      searchText = _ref.searchText,
      selectedOptions = _ref.selectedOptions,
      testID = _ref.testID,
      valueKey = _ref.valueKey;
  var extraData = React.useMemo(function () {
    return {
      focusedOption: focusedOption,
      selectedOptions: selectedOptions
    };
  }, [focusedOption, selectedOptions]);

  var _defaultRenderOption = function _defaultRenderOption(_ref2) {
    var option = _ref2.option,
        isSelected = _ref2.isSelected;
    return /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Label, {
      numberOfLines: 2,
      $isDisabled: option.disabled
    }, option[labelKey]), /*#__PURE__*/React.createElement(SelectedIcon, {
      name: "check",
      $show: isSelected
    }));
  };

  var _keyExtractor = function _keyExtractor(option) {
    return option[valueKey];
  };

  var _renderItem = function _renderItem(_ref3) {
    var option = _ref3.item,
        index = _ref3.index;
    var finalRenderOption = renderOption || _defaultRenderOption;
    var isFocused = option === focusedOption;
    var isSelected = selectedOptions.indexOf(option) > -1;
    return /*#__PURE__*/React.createElement(OptionContainer, {
      innerRef: function innerRef(ref) {
        return focusedOptionRef === null || focusedOptionRef === void 0 ? void 0 : focusedOptionRef(ref, isFocused);
      },
      isDisabled: option.disabled,
      index: index,
      isFocused: isFocused,
      isSelected: isSelected,
      onFocus: onItemFocus,
      onSelect: onItemSelect,
      option: option
    }, finalRenderOption({
      option: option,
      index: index,
      isSelected: isSelected
    }));
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, isSearchable ? /*#__PURE__*/React.createElement(SearchBar, {
    autoFocus: true,
    onInputBlur: onInputBlur,
    onInputChange: onInputChange,
    searchText: searchText
  }) : null, options.length > 0 ? /*#__PURE__*/React.createElement(StyledFlatList, {
    data: options,
    extraData: extraData,
    getItemLayout: getItemLayout || _defaultGetItemLayout,
    ref: listRef,
    keyExtractor: _keyExtractor,
    onEndReached: onEndReached,
    onEndReachedThreshold: onEndReachedThreshold,
    renderItem: _renderItem,
    testID: "".concat(testID, "-list")
  }) : noResults);
}

export default Menu;
var StyledFlatList = styled(FlatList)(_templateObject());
var Label = styled(Text)(_templateObject2(), function (_ref4) {
  var $isDisabled = _ref4.$isDisabled;
  return $isDisabled && "\n    color: #ccc;\n  ";
});
var Row = styled(View)(_templateObject3(), ROW_HEIGHT);
var SelectedIcon = styled(Icon)(_templateObject4(), function (props) {
  return props.$show ? '1' : '0';
});