import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  background-color: #fff;\n  cursor: pointer;\n\n  ", " ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from 'react';
import { styled } from '../../../apis/Style';
import { DivViewBase } from '../../../internals/web/ViewBase';

var blockEvent = function blockEvent(event) {
  event.preventDefault();
  event.stopPropagation();
};

var OptionContainer = /*#__PURE__*/function (_React$Component) {
  _inherits(OptionContainer, _React$Component);

  var _super = _createSuper(OptionContainer);

  function OptionContainer() {
    var _this;

    _classCallCheck(this, OptionContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this._dragging = void 0;

    _this._onClick = function (event) {
      event.preventDefault();
      event.stopPropagation();
      var _this$props = _this.props,
          index = _this$props.index,
          onSelect = _this$props.onSelect,
          option = _this$props.option;
      onSelect(option, event, index);
    };

    _this._onFocus = function (event) {
      var _this$props2 = _this.props,
          index = _this$props2.index,
          isFocused = _this$props2.isFocused,
          onFocus = _this$props2.onFocus,
          option = _this$props2.option;

      if (!isFocused && onFocus) {
        onFocus(option, event, index);
      }
    };

    _this._onMouseEnter = function (event) {
      _this._onFocus(event);
    };

    _this._onMouseMove = function (event) {
      _this._onFocus(event);
    };

    _this._onTouchEnd = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return;

      _this._onClick(event);
    };

    _this._onTouchMove = function () {
      // Set a flag that the view is being dragged
      _this._dragging = true;
    };

    _this._onTouchStart = function () {
      // Set a flag that the view is not being dragged
      _this._dragging = false;
    };

    return _this;
  }

  _createClass(OptionContainer, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          children = _this$props3.children,
          innerRef = _this$props3.innerRef,
          isDisabled = _this$props3.isDisabled,
          isFocused = _this$props3.isFocused;
      return isDisabled ? /*#__PURE__*/React.createElement(Container, {
        $isDisabled: isDisabled,
        onMouseDown: blockEvent,
        onClick: blockEvent
      }, children) : /*#__PURE__*/React.createElement(Container, {
        ref: innerRef,
        $isFocused: isFocused,
        onClick: this._onClick,
        onMouseEnter: this._onMouseEnter,
        onMouseMove: this._onMouseMove,
        onTouchEnd: this._onTouchEnd,
        onTouchStart: this._onTouchStart,
        onTouchMove: this._onTouchMove,
        role: "option"
      }, children);
    }
  }]);

  return OptionContainer;
}(React.Component);

export default OptionContainer;
var Container = styled(DivViewBase)(_templateObject(), function (props) {
  return props.$isFocused && "\n    background-color: #f9f9f9;\n  ";
}, function (props) {
  return props.$isDisabled && "\n    color: #ccc;\n    cursor: default;\n  ";
});