import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import styled from 'styled-components';
import InputBase from '../../../internals/web/InputBase';
import Text from '../../../primitives/Text';

var TextInputAutoSize = /*#__PURE__*/function (_React$Component) {
  _inherits(TextInputAutoSize, _React$Component);

  var _super = _createSuper(TextInputAutoSize);

  function TextInputAutoSize() {
    var _this;

    _classCallCheck(this, TextInputAutoSize);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      inputWidth: _this.props.minWidth
    };

    _this.inputRef = function (el) {
      _this.input = el;

      if (typeof _this.props.inputRef === 'function') {
        _this.props.inputRef(el);
      }
    };

    _this.placeHolderSizerRef = function (el) {
      _this.placeHolderSizer = el;
    };

    _this.sizerRef = function (el) {
      _this.sizer = el;
    };

    _this.copyInputStyles = function () {
      if (!_this.mounted || !window.getComputedStyle || !_this.sizer) {
        return;
      }

      var inputStyle = _this.input && window.getComputedStyle(_this.input);

      if (!inputStyle) {
        return;
      }

      var widthNode = _this.sizer;
      widthNode.style.fontSize = inputStyle.fontSize;
      widthNode.style.fontFamily = inputStyle.fontFamily;
      widthNode.style.fontWeight = inputStyle.fontWeight;
      widthNode.style.fontStyle = inputStyle.fontStyle;
      widthNode.style.letterSpacing = inputStyle.letterSpacing;
      widthNode.style.textTransform = inputStyle.textTransform;

      if (_this.props.placeholder && _this.placeHolderSizer) {
        var placeholderNode = _this.placeHolderSizer;
        placeholderNode.style.fontSize = inputStyle.fontSize;
        placeholderNode.style.fontFamily = inputStyle.fontFamily;
        placeholderNode.style.fontWeight = inputStyle.fontWeight;
        placeholderNode.style.fontStyle = inputStyle.fontStyle;
        placeholderNode.style.letterSpacing = inputStyle.letterSpacing;
        placeholderNode.style.textTransform = inputStyle.textTransform;
      }
    };

    _this.updateInputWidth = function () {
      if (!_this.mounted || !_this.sizer || typeof _this.sizer.scrollWidth === 'undefined') {
        return;
      }

      var _this$props = _this.props,
          minWidth = _this$props.minWidth,
          placeholder = _this$props.placeholder;
      var newInputWidth = _this.state.inputWidth;

      if (placeholder) {
        if (_this.placeHolderSizer) {
          newInputWidth = Math.max(_this.sizer.scrollWidth, _this.placeHolderSizer.scrollWidth) + 2;
        }
      } else {
        newInputWidth = _this.sizer.scrollWidth + 2;
      }

      if (newInputWidth < minWidth) {
        newInputWidth = minWidth;
      }

      if (newInputWidth !== _this.state.inputWidth) {
        _this.setState({
          inputWidth: newInputWidth
        });
      }
    };

    _this.getInput = function () {
      return _this.input;
    };

    _this.focus = function () {
      _this.input && _this.input.focus();
    };

    _this.blur = function () {
      _this.input && _this.input.blur();
    };

    _this.select = function () {
      _this.input && _this.input.select();
    };

    return _this;
  }

  _createClass(TextInputAutoSize, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
      this.copyInputStyles();
      this.updateInputWidth();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updateInputWidth();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          defaultValue = _this$props2.defaultValue,
          inputRef = _this$props2.inputRef,
          minWidth = _this$props2.minWidth,
          value = _this$props2.value,
          inputProps = _objectWithoutProperties(_this$props2, ["className", "defaultValue", "inputRef", "minWidth", "value"]);

      var sizerValue = [defaultValue, value, ''].reduce(function (previousValue, currentValue) {
        if (previousValue !== null && previousValue !== undefined) {
          return previousValue;
        }

        return currentValue;
      });
      return /*#__PURE__*/React.createElement(Container, {
        className: className
      }, /*#__PURE__*/React.createElement(Input, Object.assign({}, inputProps, {
        ref: this.inputRef,
        value: value,
        $width: this.state.inputWidth
      })), /*#__PURE__*/React.createElement(Sizer, {
        ref: this.sizerRef
      }, sizerValue), this.props.placeholder ? /*#__PURE__*/React.createElement(Sizer, {
        ref: this.placeHolderSizerRef
      }, /*#__PURE__*/React.createElement(Text, null, this.props.placeholder)) : null);
    }
  }]);

  return TextInputAutoSize;
}(React.Component);

TextInputAutoSize.defaultProps = {
  minWidth: 1
};
export default TextInputAutoSize;
var Container = styled.div.withConfig({
  displayName: "TextInputAutoSize__Container",
  componentId: "sc-12v07qb-0"
})(["display:inline-block;"]);
var Input = styled(InputBase).withConfig({
  displayName: "TextInputAutoSize__Input",
  componentId: "sc-12v07qb-1"
})(["box-sizing:content-box;width:", "px;"], function (props) {
  return props.$width;
});
var Sizer = styled.div.withConfig({
  displayName: "TextInputAutoSize__Sizer",
  componentId: "sc-12v07qb-2"
})(["position:absolute;top:0;left:0;height:0;visibility:hidden;overflow:scroll;white-space:pre;"]);