import React from 'react';
import { Form } from '../../primitives/Form';
import { useFormStateStrict } from '../../primitives/Form/FormState';
import createButton from '../Button/createButton';
var Button = createButton(Form.SubmitButton);

var SubmitButton = function SubmitButton(_ref) {
  var className = _ref.className,
      disabled = _ref.disabled,
      icon = _ref.icon,
      iconStyle = _ref.iconStyle,
      style = _ref.style,
      textStyle = _ref.textStyle,
      testID = _ref.testID,
      text = _ref.text,
      type = _ref.type;

  var _useFormStateStrict = useFormStateStrict(),
      submitting = _useFormStateStrict.submitting;

  var props = {
    className: className,
    disabled: disabled,
    icon: icon,
    iconStyle: iconStyle,
    style: style,
    textStyle: textStyle,
    testID: testID,
    text: text,
    type: type
  };
  return /*#__PURE__*/React.createElement(Button, Object.assign({}, props, {
    loading: submitting
  }));
};

export default SubmitButton;