import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  min-width: 50px;\n  height: 40px;\n  padding-left: 10px;\n  padding-right: 10px;\n  background-color: ", ";\n  border-top-left-radius: ", ";\n  border-top-right-radius: ", ";\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  margin-bottom: 1px;\n  align-items: center;\n  justify-content: center;\n  ", ";\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  flex-direction: column;\n  max-width: 400px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import * as React from 'react';
import { styled } from '../../apis/Style';
import Text from '../../primitives/Text';
import TouchableView from '../../primitives/TouchableView';
import View from '../../primitives/View';
import { ButtonCSS } from './styles';
export default function Picker(_ref) {
  var options = _ref.options,
      _ref$selected = _ref.selected,
      selected = _ref$selected === void 0 ? [] : _ref$selected,
      onChange = _ref.onChange,
      optionToString = _ref.optionToString,
      _ref$multi = _ref.multi,
      multi = _ref$multi === void 0 ? false : _ref$multi,
      testID = _ref.testID;
  return /*#__PURE__*/React.createElement(StyledView, {
    testID: testID
  }, options.map(function (option, i) {
    var isSelected;
    if (multi) isSelected = selected.includes(option);else isSelected = selected === option;
    return /*#__PURE__*/React.createElement(TabButton, {
      key: i,
      $isSelected: isSelected,
      $position: getPosition(i, options.length),
      onPress: function onPress() {
        var output;

        if (!multi) {
          output = option;
        } else {
          if (selected.includes(option)) {
            output = selected.filter(function (item) {
              return item !== option;
            });
          } else {
            output = [].concat(_toConsumableArray(selected), [option]);
          }
        }

        onChange(output);
      }
    }, /*#__PURE__*/React.createElement(Text, {
      key: option.value
    }, optionToString(option)));
  }));
}
var StyledView = styled(View)(_templateObject());
var TabButton = styled(TouchableView)(_templateObject2(), function (_ref2) {
  var $isSelected = _ref2.$isSelected;
  return $isSelected ? 'orange' : '#f8f8f8';
}, function (_ref3) {
  var $position = _ref3.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref4) {
  var $position = _ref4.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref5) {
  var $position = _ref5.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (_ref6) {
  var $position = _ref6.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (props) {
  return ButtonCSS(props);
});

var getPosition = function getPosition(pos, length) {
  if (pos === 0) {
    return 'first';
  }

  if (pos === length - 1) {
    return 'last';
  }

  return 'middle';
};