import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import moment from 'moment';
import * as React from 'react';
import { TimePickerAndroid } from 'react-native';
import PickerNative from '../../../internals/Picker.native';
import { DEFAULT_TIME_DISPLAY_FORMAT, DEFAULT_TIME_VALUE_FORMAT } from '../constants';
import { PlaceholderText, ValueText } from '../StyledComponents';

var TimePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(TimePicker, _React$Component);

  var _super = _createSuper(TimePicker);

  function TimePicker() {
    var _this;

    _classCallCheck(this, TimePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._openPicker = function () {
      var onFocus = _this.props.onFocus;
      onFocus && onFocus();
      TimePickerAndroid.open({
        hour: _this._time.hour(),
        minute: _this._time.minute()
      }).then(_this._onTimeSelect);
    };

    _this._onTimeSelect = function (_ref) {
      var action = _ref.action,
          hour = _ref.hour,
          minute = _ref.minute;

      if (action !== TimePickerAndroid.dismissedAction) {
        var time = moment({
          hour: hour,
          minute: minute
        });

        _this._selectTime(time);
      } else {
        _this.blur();
      }
    };

    _this._renderValue = function () {
      var placeholder = _this.props.placeholder;

      if (!_this._timeStr) {
        return /*#__PURE__*/React.createElement(PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(ValueText, null, _this._timeStr);
    };

    _this._selectTime = function (time) {
      var _this$props = _this.props,
          onValueChange = _this$props.onValueChange,
          valueFormat = _this$props.valueFormat;

      _this.blur();

      onValueChange && onValueChange(time.format(valueFormat));
    };

    return _this;
  }

  _createClass(TimePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          accessibilityLabel = _this$props2.accessibilityLabel,
          autoFocus = _this$props2.autoFocus,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          displayFormat = _this$props2.displayFormat,
          onBlur = _this$props2.onBlur,
          readOnly = _this$props2.readOnly,
          renderDropdownIcon = _this$props2.renderDropdownIcon,
          style = _this$props2.style,
          testID = _this$props2.testID,
          value = _this$props2.value,
          valueFormat = _this$props2.valueFormat;
      var styleProps = {
        style: style
      };

      if (value) {
        this._time = moment(value, valueFormat);
        this._timeStr = this._time.format(displayFormat);
      } else {
        this._time = moment();
        this._timeStr = '';
      }

      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onFocus: this._openPicker,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/React.createElement(PickerNative, Object.assign({}, styleProps, props));
    }
  }]);

  return TimePicker;
}(React.Component);

TimePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: DEFAULT_TIME_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: DEFAULT_TIME_VALUE_FORMAT
};
TimePicker.displayName = 'TimePicker';
export default TimePicker;