import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import moment from 'moment';
import * as React from 'react';
import PickerWeb from '../../../internals/Picker.web';
import { DEFAULT_TIME_DISPLAY_FORMAT, DEFAULT_TIME_VALUE_FORMAT } from '../constants';
import { PlaceholderText, ValueText } from './StyledComponents';
import WheelPicker from './WheelPicker';

var TimePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(TimePicker, _React$Component);

  var _super = _createSuper(TimePicker);

  function TimePicker() {
    var _this;

    _classCallCheck(this, TimePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._renderPopover = function () {
      return /*#__PURE__*/React.createElement(WheelPicker, {
        displayRight: _this.props.displayRight,
        initialTime: _this._time,
        onSelect: _this._selectTime
      });
    };

    _this._renderValue = function () {
      var placeholder = _this.props.placeholder;

      if (!_this._timeStr) {
        return /*#__PURE__*/React.createElement(PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(ValueText, null, _this._timeStr);
    };

    _this._selectTime = function (time) {
      var _this$props = _this.props,
          onValueChange = _this$props.onValueChange,
          valueFormat = _this$props.valueFormat;

      _this.blur();

      onValueChange && onValueChange(time.format(valueFormat));
    };

    return _this;
  }

  _createClass(TimePicker, [{
    key: "blur",
    value: function blur() {
      var picker = this._picker;
      picker && setTimeout(function () {
        return picker.blur();
      }, 10); // the timeout is to counter some focus event that occurs after setting the value
      // not an elegant fix, will need to fix this properly, Hernus
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          accessibilityLabel = _this$props2.accessibilityLabel,
          autoFocus = _this$props2.autoFocus,
          className = _this$props2.className,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          displayFormat = _this$props2.displayFormat,
          modal = _this$props2.modal,
          onBlur = _this$props2.onBlur,
          onFocus = _this$props2.onFocus,
          onValueChange = _this$props2.onValueChange,
          readOnly = _this$props2.readOnly,
          renderDropdownIcon = _this$props2.renderDropdownIcon,
          style = _this$props2.style,
          testID = _this$props2.testID,
          value = _this$props2.value,
          valueFormat = _this$props2.valueFormat;
      var styleProps = {
        className: className,
        style: style
      };

      if (value) {
        this._time = moment(value, valueFormat);
        this._timeStr = this._time.format(displayFormat);
      } else {
        this._time = moment();
        this._timeStr = '';
      }

      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        modal: modal,
        onBlur: onBlur,
        onFocus: onFocus,
        onValueChange: onValueChange,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopover: this._renderPopover,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/React.createElement(PickerWeb, Object.assign({}, styleProps, props));
    }
  }]);

  return TimePicker;
}(React.Component);

TimePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: DEFAULT_TIME_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: DEFAULT_TIME_VALUE_FORMAT,
  displayRight: undefined
};
TimePicker.displayName = 'TimePicker';
export default TimePicker;