import React from 'react';
import Paragraph from '../../Paragraph';
import FieldContainer from '../FieldContainer';
import FieldLabel from '../FieldLabel';
import { FieldInputContainer, FieldLabelAsterisk, FieldLabelContainer } from '../StyledComponents';
import TouchToFocusArea from '../TouchToFocusArea';

function InputFieldWrapper(props) {
  var children = props.children,
      className = props.className,
      fieldState = props.fieldState,
      focusInput = props.focusInput,
      label = props.label,
      required = props.required,
      style = props.style,
      testID = props.testID,
      _props$reserveErrorSp = props.reserveErrorSpace,
      reserveErrorSpace = _props$reserveErrorSp === void 0 ? true : _props$reserveErrorSp;
  return /*#__PURE__*/React.createElement(FieldContainer, {
    className: className,
    style: style,
    testID: testID
  }, /*#__PURE__*/React.createElement(TouchToFocusArea, {
    onPress: focusInput,
    testID: testID && "".concat(testID, "-control")
  }, label && /*#__PURE__*/React.createElement(FieldLabelContainer, null, /*#__PURE__*/React.createElement(FieldLabel, {
    testID: testID && "".concat(testID, "-label")
  }, label), required && /*#__PURE__*/React.createElement(FieldLabelAsterisk, null)), /*#__PURE__*/React.createElement(FieldInputContainer, {
    $hasError: fieldState.touched && fieldState.error
  }, children)), reserveErrorSpace && /*#__PURE__*/React.createElement(Paragraph, {
    type: "error"
  }, fieldState.touched ? fieldState.error : ''));
}

export default InputFieldWrapper;