import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  margin-left: 2px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  align-self: stretch;\n  flex-direction: row;\n  justify-content: space-between;\n  align-items: center;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from 'react';
import { styled } from '../../../apis/Style';
import View from '../../../primitives/View';
import Paragraph from '../../Paragraph';
import FieldContainer from '../FieldContainer';
import FieldLabel from '../FieldLabel';
import TouchToFocusArea from '../TouchToFocusArea';

function SwitchFieldWrapper(props) {
  var children = props.children,
      className = props.className,
      fieldState = props.fieldState,
      label = props.label,
      onValueChange = props.onValueChange,
      style = props.style,
      testID = props.testID,
      _props$reserveErrorSp = props.reserveErrorSpace,
      reserveErrorSpace = _props$reserveErrorSp === void 0 ? true : _props$reserveErrorSp;
  return /*#__PURE__*/React.createElement(FieldContainer, {
    className: className,
    style: style,
    testID: testID
  }, /*#__PURE__*/React.createElement(SwitchTouchToFocusArea, {
    onPress: function onPress() {
      return onValueChange && onValueChange(!fieldState.value);
    },
    testID: testID && "".concat(testID, "-control")
  }, label && /*#__PURE__*/React.createElement(FieldLabel, {
    testID: testID && "".concat(testID, "-label")
  }, label), /*#__PURE__*/React.createElement(SwitchContainer, null, children)), reserveErrorSpace && /*#__PURE__*/React.createElement(Paragraph, {
    type: "error"
  }, fieldState.touched ? fieldState.error : ''));
}

export default SwitchFieldWrapper;
var SwitchTouchToFocusArea = styled(TouchToFocusArea)(_templateObject());
var SwitchContainer = styled(View)(_templateObject2());