import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import { Animated, Modal, StyleSheet, TouchableHighlight } from 'react-native';

var Popup = /*#__PURE__*/function (_React$Component) {
  _inherits(Popup, _React$Component);

  var _super = _createSuper(Popup);

  function Popup() {
    var _this;

    _classCallCheck(this, Popup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      animatedHeight: new Animated.Value(0),
      showModal: !!_this.props.show
    };

    _this._setModalVisible = function (visible) {
      _this.setState({
        showModal: visible
      }); // slide animation


      if (visible) {
        Animated.timing(_this.state.animatedHeight, {
          toValue: _this.props.height,
          duration: 300
        }).start();
      } else {
        _this.setState({
          animatedHeight: new Animated.Value(0)
        });
      }
    };

    return _this;
  }

  _createClass(Popup, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.show !== this.props.show) {
        this._setModalVisible(!!nextProps.show);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(Modal, {
        onRequestClose: this.props.onRequestClose,
        transparent: true,
        visible: this.state.showModal
      }, /*#__PURE__*/React.createElement(TouchableHighlight, {
        activeOpacity: 1,
        onPress: this.props.onRequestClose,
        style: styles.modalBackdrop,
        underlayColor: "#00000075"
      }, /*#__PURE__*/React.createElement(TouchableHighlight, {
        underlayColor: "#fff",
        testID: this.props.testID
      }, /*#__PURE__*/React.createElement(Animated.View, {
        style: [styles.container, {
          height: this.state.animatedHeight
        }]
      }, this.props.children))));
    }
  }]);

  return Popup;
}(React.Component);

Popup.defaultProps = {
  height: 259,
  show: false
};
var styles = StyleSheet.create({
  modalBackdrop: {
    backgroundColor: '#00000075',
    flex: 1,
    justifyContent: 'flex-end'
  },
  container: {
    backgroundColor: '#fff',
    height: 0,
    overflow: 'hidden'
  }
});
export default Popup;