import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import { Platform, TouchableOpacity, View } from 'react-native';
import Popup from './Popup';
import { Container, Control, IconText, IconTextContainer, OKText, PopupContentContainer, PopupText, PopupTopBar, ValueContainer } from './StyledComponents';

var PickerNative = /*#__PURE__*/function (_React$Component) {
  _inherits(PickerNative, _React$Component);

  var _super = _createSuper(PickerNative);

  function PickerNative() {
    var _this;

    _classCallCheck(this, PickerNative);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      var onBlur = _this.props.onBlur;
      onBlur && onBlur();

      _this.setState({
        isOpen: false
      });
    };

    _this.focus = function () {
      var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          readOnly = _this$props.readOnly;
      if (readOnly) return;
      onFocus && onFocus();

      _this.setState({
        isOpen: true
      });
    };

    _this.state = {
      isOpen: false
    };

    _this._onControlPress = function (event) {
      if (_this.props.readOnly) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault();

      _this.focus();
    };

    _this._renderClear = function () {
      var _this$props2 = _this.props,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          onClear = _this$props2.onClear,
          readOnly = _this$props2.readOnly;

      if (!clearable || readOnly) {
        return null;
      }

      return /*#__PURE__*/React.createElement(TouchableOpacity, {
        onPress: onClear
      }, /*#__PURE__*/React.createElement(PopupText, null, clearValueText));
    };

    _this._renderConfirmButton = function () {
      return /*#__PURE__*/React.createElement(TouchableOpacity, {
        onPress: _this.props.onConfirm
      }, /*#__PURE__*/React.createElement(OKText, null, "Done"));
    };

    _this._renderDropdownIcon = function () {
      var renderDropdownIcon = _this.props.renderDropdownIcon;
      return renderDropdownIcon ? renderDropdownIcon(_this.state) : /*#__PURE__*/React.createElement(IconTextContainer, null, /*#__PURE__*/React.createElement(IconText, null, "\u2304"));
    };

    _this._renderPopup = function () {
      var renderPopup = _this.props.renderPopup;
      return /*#__PURE__*/React.createElement(Popup, {
        onRequestClose: _this.blur,
        show: _this.state.isOpen
      }, /*#__PURE__*/React.createElement(PopupContentContainer, null, /*#__PURE__*/React.createElement(PopupTopBar, null, /*#__PURE__*/React.createElement(TouchableOpacity, {
        onPress: _this.blur
      }, /*#__PURE__*/React.createElement(PopupText, null, "Cancel")), /*#__PURE__*/React.createElement(View, {
        style: {
          flex: 1
        }
      }), _this._renderClear(), _this._renderConfirmButton()), renderPopup && renderPopup()));
    };

    _this._renderValue = function () {
      var renderValue = _this.props.renderValue;
      return /*#__PURE__*/React.createElement(ValueContainer, null, renderValue && renderValue(_this.state));
    };

    return _this;
  }

  _createClass(PickerNative, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          accessibilityLabel = _this$props3.accessibilityLabel,
          readOnly = _this$props3.readOnly,
          style = _this$props3.style,
          testID = _this$props3.testID;
      var styleProps = {
        style: style
      };
      return /*#__PURE__*/React.createElement(Container, Object.assign({}, styleProps, {
        accessibilityLabel: accessibilityLabel,
        testID: testID
      }), /*#__PURE__*/React.createElement(Control, {
        onPress: this._onControlPress
      }, this._renderValue(), this._renderDropdownIcon()), Platform.OS === 'ios' && !readOnly && this._renderPopup());
    }
  }]);

  return PickerNative;
}(React.Component);

PickerNative.defaultProps = {
  autoFocus: false,
  clearable: true,
  clearValueText: 'Clear value',
  readOnly: false
};
export default PickerNative;