import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import { Popover } from '../Popover.web';
import { Arrow, ArrowZone, Clear, ClearZone, Container, Control, FakeInput, PopoverContainer, ValueContainer } from './StyledComponents';

var PickerWeb = /*#__PURE__*/function (_React$Component) {
  _inherits(PickerWeb, _React$Component);

  var _super = _createSuper(PickerWeb);

  function PickerWeb() {
    var _this;

    _classCallCheck(this, PickerWeb);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      isOpen: false
    };
    _this._containerRef = React.createRef();

    _this._clearValue = function () {
      var onValueChange = _this.props.onValueChange;
      onValueChange && onValueChange(null);
    };

    _this._closePopover = function () {
      return _this.setState({
        isOpen: false
      });
    };

    _this._onClearButtonClick = function (event) {
      event.stopPropagation();
      event.preventDefault();

      _this._clearValue();
    };

    _this._onControlClick = function (event) {
      // if the event was triggered by a click and not the primary button, or if the component is
      // read-only, ignore it.
      // $FlowFixMe
      if (_this.props.readOnly || event.type === 'click' && event.button !== 0) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault();

      if (_this.state.isOpen) {
        _this.blur();
      } else {
        _this.focus();
      }
    };

    _this._onControlMouseDown = function (event) {
      event.stopPropagation();
      event.preventDefault();
    };

    _this._onDropdownIconClick = function (event) {
      // if the event was triggered by a click and not the primary
      // button, or if the component is read-only, ignore it.
      // $FlowFixMe
      if (_this.props.readOnly || event.type === 'click' && event.button !== 0) {
        return;
      } // If the menu isn't open, let the event bubble to _onControlClick


      if (!_this.state.isOpen) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault(); // close the menu

      _this.blur();
    };

    _this._onInputBlur = function () {
      var onBlur = _this.props.onBlur;
      onBlur && onBlur();

      _this._closePopover();
    };

    _this._onInputFocus = function () {
      var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          readOnly = _this$props.readOnly;
      if (readOnly) return;
      onFocus && onFocus();

      _this.setState({
        isOpen: true
      });
    };

    _this._onPopoverMouseDown = function (event) {
      // if the event was triggered by a mousedown and not the primary
      // button, or if the component is read-only, ignore it.
      if (_this.props.readOnly) {
        return;
      }

      event.stopPropagation();
      event.preventDefault();

      _this.focus();
    };

    _this._renderClear = function () {
      var _this$props2 = _this.props,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          readOnly = _this$props2.readOnly;

      if (!clearable || readOnly) {
        return null;
      }

      return /*#__PURE__*/React.createElement(ClearZone, {
        "aria-label": clearValueText,
        onClick: _this._onClearButtonClick,
        title: clearValueText
      }, /*#__PURE__*/React.createElement(Clear, null, "\xD7"));
    };

    _this._renderDropdownIcon = function () {
      var _this$props3 = _this.props,
          readOnly = _this$props3.readOnly,
          renderDropdownIcon = _this$props3.renderDropdownIcon;
      return /*#__PURE__*/React.createElement(ArrowZone, {
        onClick: _this._onDropdownIconClick,
        $isDisabled: readOnly
      }, renderDropdownIcon ? renderDropdownIcon(_this.state) : /*#__PURE__*/React.createElement(Arrow, {
        $isOpen: _this.state.isOpen
      }));
    };

    _this._renderInput = function () {
      return /*#__PURE__*/React.createElement(FakeInput, {
        ref: function ref(_ref) {
          _this._input = _ref;
        },
        onBlur: _this._onInputBlur,
        onFocus: _this._onInputFocus,
        tabIndex: 0
      });
    };

    _this._renderPopover = function () {
      var _this$props4 = _this.props,
          modal = _this$props4.modal,
          renderPopover = _this$props4.renderPopover;
      return modal ? /*#__PURE__*/React.createElement(Popover, {
        anchorEl: _this._containerRef.current,
        onContentMouseDown: _this._onPopoverMouseDown,
        onRequestClose: _this._closePopover,
        visible: _this.state.isOpen
      }, renderPopover && renderPopover()) : /*#__PURE__*/React.createElement(PopoverContainer, {
        onMouseDown: _this._onPopoverMouseDown
      }, renderPopover && renderPopover());
    };

    _this._renderValue = function () {
      var renderValue = _this.props.renderValue;
      return /*#__PURE__*/React.createElement(ValueContainer, null, renderValue && renderValue(_this.state));
    };

    return _this;
  }

  _createClass(PickerWeb, [{
    key: "blur",
    value: function blur() {
      this._input && this._input.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._input && this._input.focus();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          accessibilityLabel = _this$props5.accessibilityLabel,
          className = _this$props5.className,
          style = _this$props5.style,
          testID = _this$props5.testID;
      var styleProps = {
        className: className,
        style: style
      };
      return /*#__PURE__*/React.createElement(Container, Object.assign({}, styleProps, {
        ref: this._containerRef,
        accessibilityLabel: accessibilityLabel,
        testID: testID
      }), /*#__PURE__*/React.createElement(Control, {
        onClick: this._onControlClick,
        onMouseDown: this._onControlMouseDown
      }, this._renderInput(), this._renderValue(), this._renderClear(), this._renderDropdownIcon()), !!this.state.isOpen && this._renderPopover());
    }
  }]);

  return PickerWeb;
}(React.Component);

PickerWeb.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  readOnly: false
};
PickerWeb.displayName = 'PickerWeb';
export default PickerWeb;