import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import styled from 'styled-components';
import FontContext from '../../primitives/Font/FontContext';

function InputBase(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      nativeRef = _ref.nativeRef,
      testID = _ref.testID,
      props = _objectWithoutProperties(_ref, ["accessibilityLabel", "nativeRef", "testID"]);

  return /*#__PURE__*/React.createElement(FontContext.Consumer, null, function (_ref2) {
    var fontFamily = _ref2.fontFamily,
        fontSize = _ref2.fontSize;
    return /*#__PURE__*/React.createElement(StyledInput, Object.assign({}, props, {
      "aria-label": accessibilityLabel,
      "data-testid": testID,
      ref: nativeRef,
      $fontFamilyValue: fontFamily,
      $fontSizeValue: fontSize
    }));
  });
}

export default React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(InputBase, Object.assign({}, props, {
    nativeRef: ref
  }));
});
var StyledInput = styled.input.withConfig({
  displayName: "InputBase__StyledInput",
  componentId: "ciondq-0"
})(["appearance:none;background-color:transparent;border-color:black;border-radius:0;border-width:0;box-sizing:border-box;font-family:", ";font-size:", "px;padding:0;outline:none;resize:none;"], function (props) {
  return props.$fontFamilyValue;
}, function (props) {
  return props.$fontSizeValue;
});