import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n:root {\n  --reach-tooltip: 1;\n}\n\n[data-reach-tooltip] {\n  z-index: 1;\n  pointer-events: none;\n  position: absolute;\n  padding: 0.5em 1em;\n  box-shadow: 2px 2px 10px hsla(0, 0%, 0%, 0.1);\n  white-space: nowrap;\n  font-size: 85%;\n  background: hsla(0, 0%, 0%, 0.75);\n  color: white;\n  border: none;\n  borderRadius: 4px;\n}\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import Tooltip from '@reach/tooltip';
import * as React from 'react';
import styled, { createGlobalStyle } from 'styled-components';
import { buttonDefaultStyle } from './styles'; // $FlowFixMe typescript

import { createViewBase } from './ViewBase';
var GlobalStyle = createGlobalStyle(_templateObject());
export function createTouchableViewBase(component) {
  var ViewBase = createViewBase(component);
  var StyledViewBase = styled(ViewBase).withConfig({
    displayName: "TouchableViewBase__StyledViewBase",
    componentId: "cz83lq-0"
  })(["", ";"], buttonDefaultStyle);
  var StyledViewBaseWithForwardRef = React.forwardRef(function (props, ref) {
    return /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, props, {
      ref: ref
    }));
  }); // $FlowFixMe: forwardRef not supported yet

  return React.forwardRef(function (props, ref) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, props.tooltip ? /*#__PURE__*/React.createElement(Tooltip, {
      label: props.tooltip
    }, /*#__PURE__*/React.createElement(StyledViewBaseWithForwardRef, Object.assign({}, props, {
      ref: ref
    }))) : /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, props, {
      ref: ref
    })), /*#__PURE__*/React.createElement(GlobalStyle, null));
  });
}
export var DivTouchableViewBase = createTouchableViewBase('div');