import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import uniqueId from 'lodash/uniqueId';
import React from 'react';
import ReactDOM from 'react-dom';
import { injectEventPluginsByName } from 'react-dom/unstable-native-dependencies';
import UIManager from 'react-native-web/dist/cjs/exports/UIManager';
import ResponderEventPlugin from 'react-native-web/dist/cjs/modules/ResponderEventPlugin';
import styled from 'styled-components';
import { flex } from './styles';
injectEventPluginsByName({
  ResponderEventPlugin: ResponderEventPlugin
});
export function createViewBase(component) {
  var ViewBase = /*#__PURE__*/function (_React$Component) {
    _inherits(ViewBase, _React$Component);

    var _super = _createSuper(ViewBase);

    function ViewBase() {
      var _this;

      _classCallCheck(this, ViewBase);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));
      _this._isMounted = void 0;
      _this._lastLayout = {};
      _this._onLayoutId = uniqueId('onLayout');
      _this._resizeDetector = void 0;

      _this._onLayout = function () {
        var onLayout = _this.props.onLayout;

        if (onLayout) {
          UIManager.measure(ReactDOM.findDOMNode(_assertThisInitialized(_this)), function (x, y, width, height) {
            if (!_this._isMounted) return;

            if (_this._lastLayout.x !== x || _this._lastLayout.y !== y || _this._lastLayout.width !== width || _this._lastLayout.height !== height) {
              _this._lastLayout = {
                x: x,
                y: y,
                width: width,
                height: height
              };
              var nativeEvent = {
                layout: {
                  x: x,
                  y: y,
                  width: width,
                  height: height
                }
              };
              onLayout({
                nativeEvent: nativeEvent,
                timeStamp: Date.now()
              });
            }
          });
        }
      };

      return _this;
    }

    _createClass(ViewBase, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this._isMounted = true; // Defer adding resize event handler to window to support server-side
        // rendering

        this._resizeDetector = require('./detectResize');

        this._resizeDetector.register(this._onLayoutId, this);

        this._onLayout();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this._onLayout();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this._isMounted = false;

        this._resizeDetector.unregister(this._onLayoutId);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            accessibilityLabel = _this$props.accessibilityLabel,
            children = _this$props.children,
            nativeRef = _this$props.nativeRef,
            onLayout = _this$props.onLayout,
            testID = _this$props.testID,
            rest = _objectWithoutProperties(_this$props, ["accessibilityLabel", "children", "nativeRef", "onLayout", "testID"]);

        var props = _objectSpread(_objectSpread({}, rest), {}, {
          'aria-label': accessibilityLabel,
          'data-testid': testID,
          ref: nativeRef
        });

        return React.createElement(component, props, children);
      }
    }]);

    return ViewBase;
  }(React.Component); // Manually pass on responder event handlers since styled-components filters them out


  var StyledViewBase = styled(ViewBase).attrs(function (props) {
    return {
      onResponderGrant: props.onResponderGrant,
      onResponderMove: props.onResponderMove,
      onResponderRelease: props.onResponderRelease,
      onResponderTerminate: props.onResponderTerminate,
      onResponderTerminationRequest: props.onResponderTerminationRequest,
      onStartShouldSetResponder: props.onStartShouldSetResponder
    };
  }).withConfig({
    displayName: "ViewBase__StyledViewBase",
    componentId: "sc-66ckm-0"
  })(["", ";"], flex);
  return React.forwardRef(function (props, ref) {
    return /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, props, {
      nativeRef: ref
    }));
  });
}
export var DivViewBase = createViewBase('div');