import * as React from 'react';
import styled, { css, keyframes } from 'styled-components';
import { DivViewBase } from '../../internals/web/ViewBase';
var sizeMap = {
  small: 20,
  large: 36
};
export default function ActivityIndicator(_ref) {
  var _ref$animating = _ref.animating,
      animating = _ref$animating === void 0 ? true : _ref$animating,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? '#999' : _ref$color,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'small' : _ref$size,
      style = _ref.style,
      className = _ref.className,
      testID = _ref.testID;
  var containerStyleProps = {
    className: className,
    style: style
  };
  var spinnerContainerStyleProps = {
    $size: sizeMap[size]
  };
  var spinnerStyleProps = {
    $color: color
  };
  var containerStyle = {};
  if (!animating) containerStyle.visibility = 'hidden';
  return /*#__PURE__*/React.createElement(Container, Object.assign({}, containerStyleProps, {
    style: containerStyle,
    testID: testID
  }), /*#__PURE__*/React.createElement(SpinnerContainer, spinnerContainerStyleProps, /*#__PURE__*/React.createElement(Svg, {
    height: "100%",
    viewBox: "25 25 50 50",
    width: "100%"
  }, /*#__PURE__*/React.createElement(Circle, Object.assign({}, spinnerStyleProps, {
    cx: 50,
    cy: 50,
    fill: "none",
    r: 20,
    strokeMiterlimit: 10,
    strokeWidth: 4
  })))));
}
var Container = styled(DivViewBase).withConfig({
  displayName: "ActivityIndicatorweb__Container",
  componentId: "sc-15erzdi-0"
})(["align-items:center;justify-content:center;"]);
var SpinnerContainer = styled(DivViewBase).withConfig({
  displayName: "ActivityIndicatorweb__SpinnerContainer",
  componentId: "sc-15erzdi-1"
})(["width:", "px;height:", "px;"], function (_ref2) {
  var $size = _ref2.$size;
  return $size;
}, function (_ref3) {
  var $size = _ref3.$size;
  return $size;
});
var spin = keyframes(["100%{transform:rotate(360deg);}"]);
var spinRule = css(["", " 2s infinite linear;"], spin);
var dash = keyframes(["0%{stroke-dasharray:1,200;stroke-dashoffset:0;}50%{stroke-dasharray:89,200;stroke-dashoffset:-35px;}100%{stroke-dasharray:89,200;stroke-dashoffset:-124px;}"]);
var Svg = styled.svg.withConfig({
  displayName: "ActivityIndicatorweb__Svg",
  componentId: "sc-15erzdi-2"
})(["animation:", ";"], spinRule);
var Circle = styled.circle.withConfig({
  displayName: "ActivityIndicatorweb__Circle",
  componentId: "sc-15erzdi-3"
})(["animation:", " 1.5s infinite ease-in-out;stroke:", ";stroke-dasharray:1,200;stroke-dashoffset:0;transform-origin:center;"], dash, function (_ref4) {
  var $color = _ref4.$color;
  return $color;
});