import React from 'react';
import defaultFont from './defaultFont';
import FontContext from './FontContext';
export default function Font(_ref) {
  var children = _ref.children,
      _ref$fontFamily = _ref.fontFamily,
      fontFamily = _ref$fontFamily === void 0 ? defaultFont.fontFamily : _ref$fontFamily,
      _ref$fontSize = _ref.fontSize,
      fontSize = _ref$fontSize === void 0 ? defaultFont.fontSize : _ref$fontSize;
  var value = React.useMemo(function () {
    return {
      fontFamily: fontFamily,
      fontSize: fontSize
    };
  }, [fontFamily, fontSize]);
  return /*#__PURE__*/React.createElement(FontContext.Provider, {
    value: value
  }, children);
}