import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import React from 'react';
import { useFieldState } from './useFieldState';

function InternalField(props) {
  var component = props.component,
      inputRef = props.inputRef,
      label = props.label,
      name = props.name,
      inputProps = props.props,
      testID = props.testID,
      validate = props.validate;

  var _useFieldState = useFieldState({
    name: name,
    validate: validate
  }),
      fieldState = _useFieldState.fieldState,
      onBlur = _useFieldState.onBlur,
      onFocus = _useFieldState.onFocus,
      onValueChange = _useFieldState.onValueChange;

  return React.createElement(component, _objectSpread(_objectSpread({
    fieldState: fieldState,
    label: label,
    testID: testID || "".concat(name, "-field"),
    value: fieldState.value
  }, inputProps), {}, {
    onBlur: onBlur,
    onFocus: onFocus,
    onValueChange: onValueChange,
    ref: inputRef
  }));
}

export var Field = React.forwardRef(function (props, ref) {
  return (
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(InternalField, Object.assign({}, props, {
      inputRef: ref,
      props: props.props || {}
    }))
  );
});