import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import React from 'react';
import FlexForm from '../../../internals/web/FlexForm';
import { Field } from '../Field';
import { FormState, SubmissionError } from '../FormState';
import SubmitButton from '../SubmitButton';

var Form = /*#__PURE__*/function (_React$Component) {
  _inherits(Form, _React$Component);

  var _super = _createSuper(Form);

  function Form() {
    _classCallCheck(this, Form);

    return _super.apply(this, arguments);
  }

  _createClass(Form, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          initialValues = _this$props.initialValues,
          onSubmit = _this$props.onSubmit,
          style = _this$props.style,
          testID = _this$props.testID;
      return /*#__PURE__*/React.createElement(FormState, {
        initialValues: initialValues
      }, function (formState) {
        var fieldErrors = formState.fieldErrors,
            values = formState.values,
            actions = formState.actions;

        var handleFormSubmit = function handleFormSubmit(e) {
          e.preventDefault();
          e.stopPropagation();
          actions.touchAll();

          if (Object.keys(fieldErrors).length === 0) {
            actions.submit(function () {
              return onSubmit && onSubmit(values);
            });
          }
        };

        var formBody = typeof children === 'function' ? children(formState) : children;
        return /*#__PURE__*/React.createElement(FlexForm, {
          className: className,
          "data-testid": testID,
          onSubmit: handleFormSubmit,
          style: style
        }, formBody);
      });
    }
  }]);

  return Form;
}(React.Component);

Form.Field = Field;
Form.SubmissionError = SubmissionError;
Form.SubmitButton = SubmitButton;
export default Form;