import invariant from 'invariant';
import React from 'react';
var Context = React.createContext(undefined);
export function FormStateProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: value
  }, children);
}
export function useFormState() {
  return React.useContext(Context);
}
export function useFormStateStrict() {
  var formState = useFormState();
  invariant(formState, "Please put the component inside a Form or ModalForm.");
  return formState;
}