import React from 'react';
import { createTouchableViewBase } from '../../../internals/web/TouchableViewBase';
import { useFormStateStrict } from '../FormState';
var ButtonTouchableViewBase = createTouchableViewBase('button');

var SubmitButton = function SubmitButton(_ref) {
  var children = _ref.children,
      className = _ref.className,
      disabled = _ref.disabled,
      style = _ref.style,
      testID = _ref.testID;
  var formState = useFormStateStrict();
  return /*#__PURE__*/React.createElement(ButtonTouchableViewBase, {
    className: className,
    disabled: disabled,
    style: style,
    type: "submit",
    testID: testID
  }, typeof children === 'function' ? children(formState) : children);
};

export default SubmitButton;