import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import RN from 'react-native';
import styled from 'styled-components';
import OverlayDefaultProps from '../defaultProps';

var Overlay = /*#__PURE__*/function (_React$Component) {
  _inherits(Overlay, _React$Component);

  var _super = _createSuper(Overlay);

  function Overlay() {
    var _this;

    _classCallCheck(this, Overlay);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._onPress = function (event) {
      if (event.target === event.currentTarget) {
        var onPress = _this.props.onPress;
        onPress && onPress();
      }
    };

    return _this;
  }

  _createClass(Overlay, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          onLayout = _this$props.onLayout,
          testID = _this$props.testID,
          visible = _this$props.visible;
      return /*#__PURE__*/React.createElement(RN.Modal, {
        animationType: "none",
        onRequestClose: this._onPress,
        transparent: true,
        visible: visible
      }, /*#__PURE__*/React.createElement(OverlayContainer, {
        onLayout: onLayout,
        onPress: this._onPress,
        testID: testID || 'overlay-container',
        $color: color
      }, children));
    }
  }]);

  return Overlay;
}(React.Component);

Overlay.defaultProps = OverlayDefaultProps;
export default Overlay;
var OverlayContainer = styled.TouchableOpacity.attrs({
  activeOpacity: 1
}).withConfig({
  displayName: "Overlay__OverlayContainer",
  componentId: "sc-15b87ud-0"
})(["flex:1;background-color:", ";"], function (_ref) {
  var $color = _ref.$color;
  return $color || 'rgba(178, 178, 178, 0.8)';
});