import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import ExecutionEnvironment from 'exenv';
import * as React from 'react';
import ReactDOM from 'react-dom';
import OverlayDefaultProps from '../defaultProps';
import CloseButton from './CloseButton';
import OverlayContainer from './OverlayContainer';

var Overlay = /*#__PURE__*/function (_React$Component) {
  _inherits(Overlay, _React$Component);

  var _super = _createSuper(Overlay);

  function Overlay(props) {
    var _this;

    _classCallCheck(this, Overlay);

    _this = _super.call(this, props);
    _this._parent = document.body;

    _this._onClick = function (event) {
      if (event.target === event.currentTarget) {
        var onPress = _this.props.onPress;
        onPress && onPress();
      }
    };

    if (ExecutionEnvironment.canUseDOM) {
      _this._el = document.createElement('div');
    }

    return _this;
  }

  _createClass(Overlay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this._parent || !this._el) return;

      this._parent.appendChild(this._el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!this._parent || !this._el) return;

      this._parent.removeChild(this._el);
    }
  }, {
    key: "render",
    value: function render() {
      if (!this._el) {
        return null;
      }

      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          onLayout = _this$props.onLayout,
          visible = _this$props.visible,
          _this$props$showClose = _this$props.showCloseButton,
          showCloseButton = _this$props$showClose === void 0 ? false : _this$props$showClose,
          closeButtonStyle = _this$props.closeButtonStyle,
          onClose = _this$props.onClose,
          testID = _this$props.testID;
      var portalChild = visible ? /*#__PURE__*/React.createElement(OverlayContainer, {
        onClick: this._onClick,
        onLayout: onLayout,
        testID: testID || 'overlay-container',
        $color: color
      }, children, showCloseButton && /*#__PURE__*/React.createElement(CloseButton, {
        onPress: onClose,
        closeButtonStyle: closeButtonStyle
      })) : null;
      return ReactDOM.createPortal(portalChild, this._el);
    }
  }]);

  return Overlay;
}(React.Component);

Overlay.defaultProps = OverlayDefaultProps;
export default Overlay;