import React from 'react';
import NativePdf from 'react-native-pdf';
import { createDataUrlFromDefinition, initializePdfFonts } from '../helpers/pdfmake';
import { useUri } from '../helpers/useUri';
import { validateSource } from '../helpers/validateSource';
import Loading from './Loading'; // start loading fonts as soon as this module gets imported

initializePdfFonts(); // TODO: add controls

export default function Pdf(props) {
  var accessibilityLabel = props.accessibilityLabel,
      source = props.source,
      style = props.style,
      testID = props.testID;
  validateSource(source);
  var uri = useUri(source);

  if (!uri) {
    return /*#__PURE__*/React.createElement(Loading, props);
  }

  var nativePdfProps = {
    accessibilityLabel: accessibilityLabel,
    source: {
      uri: uri
    },
    style: style,
    testID: testID
  };
  return /*#__PURE__*/React.createElement(NativePdf, nativePdfProps);
}
Pdf.createDataUrlFromDefinition = createDataUrlFromDefinition;