import React from 'react';
import FlexIframe from '../../../internals/web/FlexIframe';
import { createDataUrlFromDefinition, initializePdfFonts } from '../helpers/pdfmake';
import { useUri } from '../helpers/useUri';
import { validateSource } from '../helpers/validateSource';
import Loading from './Loading';
// start loading fonts as soon as this module gets imported
initializePdfFonts();
export default function Pdf(props) {
  var accessibilityLabel = props.accessibilityLabel,
      className = props.className,
      source = props.source,
      style = props.style,
      testID = props.testID;
  validateSource(source);
  var uri = useUri(source);

  if (!uri) {
    return /*#__PURE__*/React.createElement(Loading, props);
  }

  var iframeProps = {
    'aria-label': accessibilityLabel,
    'data-testid': testID,
    className: className,
    src: uri,
    style: style
  };
  return /*#__PURE__*/React.createElement(FlexIframe, iframeProps);
}
Pdf.createDataUrlFromDefinition = createDataUrlFromDefinition;