import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React from 'react';
import { createDataUrlFromDefinition } from './pdfmake';
export function useUri(source) {
  var uri = source.uri;
  var definition = source.definition;
  var fonts = source.fonts;
  var tableLayouts = source.tableLayouts;

  var _React$useState = React.useState(),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      uriFromDefinition = _React$useState2[0],
      setUriFromDefinition = _React$useState2[1];

  React.useEffect(function () {
    var cancelled = false;

    if (definition) {
      createDataUrlFromDefinition({
        definition: definition,
        fonts: fonts,
        tableLayouts: tableLayouts
      }).then(function (dataUri) {
        if (cancelled) return;
        setUriFromDefinition(dataUri);
      });
    }

    return function () {
      cancelled = true;
    };
  }, [definition, fonts, tableLayouts, uri]);
  return uri || uriFromDefinition;
}