import * as React from 'react';
import { ScrollViewBase } from '../../internals/web/ScrollViewBase';
var ScrollView = React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      horizontal = _ref.horizontal,
      onLayout = _ref.onLayout,
      style = _ref.style,
      contentContainerStyle = _ref.contentContainerStyle,
      testID = _ref.testID,
      onScroll = _ref.onScroll,
      onContentSizeChange = _ref.onContentSizeChange,
      _ref$scrollEventThrot = _ref.scrollEventThrottle,
      scrollEventThrottle = _ref$scrollEventThrot === void 0 ? 16 : _ref$scrollEventThrot;
  var scrollableNodeRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      scrollTo: function scrollTo(options) {
        var x = options.x,
            y = options.y;

        if (scrollableNodeRef.current) {
          if (typeof x === 'number') {
            scrollableNodeRef.current.scrollLeft = x;
          }

          if (typeof y === 'number') {
            scrollableNodeRef.current.scrollTop = y;
          }
        }
      },
      scrollToEnd: function scrollToEnd() {
        if (scrollableNodeRef.current) {
          if (horizontal) {
            scrollableNodeRef.current.scrollLeft = scrollableNodeRef.current.scrollWidth;
          } else {
            scrollableNodeRef.current.scrollTop = scrollableNodeRef.current.scrollHeight;
          }
        }
      }
    };
  });
  var props = {
    accessibilityLabel: accessibilityLabel,
    className: className,
    horizontal: horizontal,
    onContentSizeChange: onContentSizeChange,
    onLayout: onLayout,
    onScroll: onScroll,
    scrollEventThrottle: scrollEventThrottle,
    style: style,
    contentContainerStyle: contentContainerStyle,
    testID: testID
  };
  return /*#__PURE__*/React.createElement(ScrollViewBase, Object.assign({}, props, {
    ref: scrollableNodeRef
  }), children);
});
export default ScrollView;