import React from 'react';
import RN from 'react-native';
import Colors from '../../../apis/Colors';
import FontContext from '../../Font/FontContext';
export default function Text(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      numberOfLines = _ref.numberOfLines,
      selectable = _ref.selectable,
      style = _ref.style,
      testID = _ref.testID;

  var _React$useContext = React.useContext(FontContext),
      fontFamily = _React$useContext.fontFamily,
      fontSize = _React$useContext.fontSize;

  var props = {
    accessibilityLabel: accessibilityLabel,
    numberOfLines: numberOfLines,
    selectable: selectable,
    testID: testID
  };
  return /*#__PURE__*/React.createElement(RN.Text, Object.assign({}, props, {
    style: [styles["default"], {
      fontFamily: fontFamily,
      fontSize: fontSize
    }, style]
  }), children);
}
var styles = RN.StyleSheet.create({
  "default": {
    color: Colors.BLACK
  }
});