import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import React from 'react';
import RN from 'react-native';
import styled from 'styled-components';
import FontContext from '../Font/FontContext';

var TextInput = /*#__PURE__*/function (_React$Component) {
  _inherits(TextInput, _React$Component);

  var _super = _createSuper(TextInput);

  function TextInput() {
    var _this;

    _classCallCheck(this, TextInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      _this._input && _this._input.blur();
    };

    _this.clear = function () {
      _this._input && _this._input.clear();
    };

    _this.focus = function () {
      _this._input && _this._input.focus();
    };

    _this._input = null;

    _this._captureInputRef = function (ref) {
      _this._input = ref;
    };

    _this._createBlurEventHandler = function () {
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        return function (event) {
          event.nativeEvent = {
            text: event.nativeEvent.text
          };
          onBlur(event);
        };
      }

      return onBlur || undefined;
    };

    _this._createFocusEventHandler = function () {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        return function (event) {
          event.nativeEvent = {
            text: event.nativeEvent.text
          };
          onFocus(event);
        };
      }

      return onFocus || undefined;
    };

    return _this;
  }

  _createClass(TextInput, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          accessibilityLabel = _this$props.accessibilityLabel,
          autoFocus = _this$props.autoFocus,
          defaultValue = _this$props.defaultValue,
          maxLength = _this$props.maxLength,
          multiline = _this$props.multiline,
          onValueChange = _this$props.onValueChange,
          placeholder = _this$props.placeholder,
          readOnly = _this$props.readOnly,
          style = _this$props.style,
          testID = _this$props.testID,
          type = _this$props.type,
          value = _this$props.value;
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        defaultValue: defaultValue,
        editable: !readOnly,
        ref: this._captureInputRef,
        maxLength: maxLength,
        multiline: multiline,
        onChangeText: onValueChange || undefined,
        onEndEditing: this._createBlurEventHandler(),
        onFocus: this._createFocusEventHandler(),
        placeholder: placeholder,
        style: style,
        testID: testID,
        value: value || '',
        underlineColorAndroid: 'rgba(0, 0, 0, 0)'
      }; // type specific props

      switch (type) {
        case 'email':
          Object.assign(props, {
            autoCapitalize: 'none',
            autoCorrect: false,
            keyboardType: 'email-address'
          });
          break;

        case 'number':
          Object.assign(props, {
            keyboardType: 'numeric'
          });
          break;

        case 'password':
          Object.assign(props, {
            autoCapitalize: 'none',
            autoCorrect: false,
            secureTextEntry: true
          });
          break;

        case 'tel':
          Object.assign(props, {
            keyboardType: 'phone-pad'
          });
          break;

        default:
          break;
      }

      return /*#__PURE__*/React.createElement(FontContext.Consumer, null, function (_ref) {
        var fontFamily = _ref.fontFamily,
            fontSize = _ref.fontSize;
        return /*#__PURE__*/React.createElement(StyledTextInput, Object.assign({}, props, {
          $fontFamily: fontFamily,
          $fontSize: fontSize
        }));
      });
    }
  }]);

  return TextInput;
}(React.Component);

TextInput.defaultProps = {
  autoFocus: false,
  multiline: false,
  placeholder: '',
  readOnly: false,
  type: 'text'
};
TextInput.displayName = 'TextInput';
export default TextInput;
var StyledTextInput = styled(RN.TextInput).withConfig({
  displayName: "TextInputnative__StyledTextInput",
  componentId: "sc-1ycerpo-0"
})(["font-family:", ";font-size:", "px;height:", "px;margin:0;padding:", ";"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
}, function (_ref2) {
  var multiline = _ref2.multiline;
  return multiline ? '36' : '18';
}, function (_ref3) {
  var multiline = _ref3.multiline;
  return multiline ? '8px 0px' : '0';
});