import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
// @ts-ignore
import invariant from 'fbjs/lib/invariant';
import React from 'react';
import styled from 'styled-components';
import InputBase from '../../internals/web/InputBase';
import TextAreaBase from '../../internals/web/TextAreaBase';
import FontContext from '../Font/FontContext';

var TextInput = /*#__PURE__*/function (_React$Component) {
  _inherits(TextInput, _React$Component);

  var _super = _createSuper(TextInput);

  function TextInput(props) {
    var _this;

    _classCallCheck(this, TextInput);

    _this = _super.call(this, props);
    _this._input = null;

    _this._captureInputRef = function (ref) {
      _this._input = ref;
    };

    _this._createBlurEventHandler = function () {
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        return function (event) {
          onBlur({
            nativeEvent: {
              text: event.currentTarget.value
            }
          });
        };
      }

      return onBlur;
    };

    _this._createChangeEventHandler = function () {
      var onValueChange = _this.props.onValueChange;

      if (onValueChange) {
        return function (event) {
          onValueChange(event.currentTarget.value);
        };
      }

      return onValueChange;
    };

    _this._createFocusEventHandler = function () {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        return function (event) {
          onFocus({
            nativeEvent: {
              text: event.currentTarget.value
            }
          });
        };
      }

      return onFocus;
    };

    _this.state = {};
    return _this;
  }

  _createClass(TextInput, [{
    key: "blur",
    value: function blur() {
      this._input && this._input.blur();
    }
  }, {
    key: "clear",
    value: function clear() {
      if (this._input) {
        this._input.value = '';
      }
    }
  }, {
    key: "focus",
    value: function focus() {
      this._input && this._input.focus();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.autoFocus) {
        setTimeout(function () {
          return _this2.focus();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          accessibilityLabel = _this$props.accessibilityLabel,
          className = _this$props.className,
          defaultValue = _this$props.defaultValue,
          placeholder = _this$props.placeholder,
          maxLength = _this$props.maxLength,
          multiline = _this$props.multiline,
          readOnly = _this$props.readOnly,
          style = _this$props.style,
          testID = _this$props.testID,
          type = _this$props.type,
          value = _this$props.value;
      var InputComponent = multiline ? TextArea : Input;
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoComplete: 'off',
        defaultValue: defaultValue,
        dir: 'auto',
        ref: this._captureInputRef,
        maxLength: maxLength,
        onBlur: this._createBlurEventHandler(),
        onChange: this._createChangeEventHandler(),
        onFocus: this._createFocusEventHandler(),
        placeholder: placeholder,
        readOnly: readOnly,
        testID: testID,
        type: type,
        value: value || ''
      };
      return /*#__PURE__*/React.createElement(FontContext.Consumer, null, function (_ref) {
        var fontFamily = _ref.fontFamily,
            fontSize = _ref.fontSize;
        var styleProps = {
          className: className,
          multiline: multiline,
          style: style,
          $fontFamily: fontFamily,
          $fontSize: fontSize
        }; //@ts-ignore

        return /*#__PURE__*/React.createElement(InputComponent, Object.assign({}, props, styleProps));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      TextInput._checkProps(nextProps);

      return null;
    }
  }, {
    key: "_checkProps",
    value: function _checkProps(props) {
      var multiline = props.multiline,
          type = props.type;
      invariant(!(multiline && type !== 'text'), 'Only type="text" is supported for multiline TextInput');
    }
  }]);

  return TextInput;
}(React.Component);

TextInput.defaultProps = {
  autoFocus: false,
  multiline: false,
  placeholder: '',
  readOnly: false,
  type: 'text'
};
TextInput.displayName = 'TextInput';
export default TextInput;
var Input = styled(InputBase).withConfig({
  displayName: "TextInputweb__Input",
  componentId: "sc-7svxlh-0"
})(["font-family:", ";font-size:", "px;"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
});
var TextArea = styled(TextAreaBase).attrs({
  rows: 5
}).withConfig({
  displayName: "TextInputweb__TextArea",
  componentId: "sc-7svxlh-1"
})(["font-family:", ";font-size:", "px;height:18px;padding:8px 0px;"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
});