import * as React from 'react';
import RN from 'react-native';
var View = React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      onLayout = _ref.onLayout,
      pointerEvents = _ref.pointerEvents,
      style = _ref.style,
      testID = _ref.testID;
  var nativeViewRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      // To be able to use View inside TouchableHighlight/TouchableOpacity
      setNativeProps: function setNativeProps(props) {
        return nativeViewRef.current && nativeViewRef.current.setNativeProps(props);
      }
    };
  });
  var props = {
    accessibilityLabel: accessibilityLabel,
    onLayout: onLayout,
    pointerEvents: pointerEvents,
    style: style,
    testID: testID
  };
  return /*#__PURE__*/React.createElement(RN.View, Object.assign({}, props, {
    ref: nativeViewRef
  }), children);
});
export default View;