import * as React from 'react';
import styled from 'styled-components';
import { DivViewBase } from '../../../internals/web/ViewBase';
export default function View(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      onLayout = _ref.onLayout,
      pointerEvents = _ref.pointerEvents,
      style = _ref.style,
      testID = _ref.testID;
  var styleProps = {
    className: className,
    $pointerEvents: pointerEvents,
    style: style
  };
  return /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, styleProps, {
    accessibilityLabel: accessibilityLabel,
    onLayout: onLayout,
    testID: testID
  }), children);
}
var pointerEventsAuto = "\n  pointer-events: auto;\n";
var pointerEventsBoxNone = "\n  pointer-events: none;\n  * {\n    pointer-events: all;\n  }\n";
var pointerEventsBoxOnly = "\n  pointer-events: all;\n  * {\n    pointer-events: none;\n  }\n";
var pointerEventsNone = "\n  pointer-events: none;\n  * {\n    pointer-events: none;\n  }\n";
var StyledViewBase = styled(DivViewBase).withConfig({
  displayName: "Viewweb__StyledViewBase",
  componentId: "sc-1fltyrz-0"
})(["", ";"], function (_ref2) {
  var $pointerEvents = _ref2.$pointerEvents;

  if ($pointerEvents === 'auto') {
    return pointerEventsAuto;
  } else if ($pointerEvents === 'none') {
    return pointerEventsNone;
  } else if ($pointerEvents === 'box-none') {
    return pointerEventsBoxNone;
  } else if ($pointerEvents === 'box-only') {
    return pointerEventsBoxOnly;
  }

  return '';
});