"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AlertContentContainer = exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Button = _interopRequireDefault(require("../../../components/Button"));

var _StyledComponents = require("../../../components/ModalForm/StyledComponents");

var _Paragraph = _interopRequireDefault(require("../../../components/Paragraph"));

var _breakpoint = require("../../../internals/web/breakpoint");

var _FlexDiv = _interopRequireDefault(require("../../../internals/web/FlexDiv"));

var _ViewBase = require("../../../internals/web/ViewBase");

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _defaultProps = _interopRequireDefault(require("../defaultProps"));

var AlertDialog = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(AlertDialog, _React$Component);

  var _super = (0, _createSuper2["default"])(AlertDialog);

  function AlertDialog() {
    var _this;

    (0, _classCallCheck2["default"])(this, AlertDialog);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.createActionButtonHandler = function (onPress) {
      return function (value) {
        var onDismiss = _this.props.onDismiss;
        onDismiss(value);
        onPress && onPress();
      };
    };

    _this.confirmButton = function () {
      var actions = _this.props.actions;

      var _onPress = _this.createActionButtonHandler(actions.confirm && actions.confirm.onPress);

      return /*#__PURE__*/React.createElement(_Button["default"], {
        text: actions.confirm && actions.confirm.text || 'Ok',
        onPress: function onPress() {
          return _onPress('confirm');
        },
        type: actions.confirm && actions.confirm.destructive ? 'destructive' : 'primary'
      });
    };

    _this.cancelButton = function () {
      var actions = _this.props.actions;

      var _onPress2 = _this.createActionButtonHandler(actions.cancel && actions.cancel.onPress);

      return actions.confirm && actions.cancel && /*#__PURE__*/React.createElement(_Button["default"], {
        type: "secondary",
        onPress: function onPress() {
          return _onPress2('cancel');
        },
        text: actions.cancel && actions.cancel.text || 'Cancel',
        style: {
          marginRight: 8
        }
      });
    };

    _this.neutralButton = function () {
      var actions = _this.props.actions;

      var _onPress3 = _this.createActionButtonHandler(actions.neutral && actions.neutral.onPress);

      return actions.confirm && actions.cancel && actions.neutral && /*#__PURE__*/React.createElement(_Button["default"], {
        type: "tertiary",
        onPress: function onPress() {
          return _onPress3('neutral');
        },
        text: actions.neutral && actions.neutral.text || 'Ask Me Later'
      });
    };

    return _this;
  }

  (0, _createClass2["default"])(AlertDialog, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          message = _this$props.message,
          title = _this$props.title;
      return /*#__PURE__*/React.createElement(AlertContentContainer, null, /*#__PURE__*/React.createElement(StyledView, null, title && /*#__PURE__*/React.createElement(AlertFormHeader, null, /*#__PURE__*/React.createElement(AlertFormTitleText, null, title)), /*#__PURE__*/React.createElement(AlertFormContent, null, /*#__PURE__*/React.createElement(_Paragraph["default"], null, message)), /*#__PURE__*/React.createElement(AlertFormFooter, null, /*#__PURE__*/React.createElement(AlertFormRow, null, this.neutralButton()), /*#__PURE__*/React.createElement(AlertFormRow, null, this.cancelButton(), this.confirmButton()))));
    }
  }]);
  return AlertDialog;
}(React.Component);

AlertDialog.defaultProps = _defaultProps["default"];
var _default = AlertDialog;
exports["default"] = _default;
var AlertContentContainer = (0, _styledComponents["default"])(_ViewBase.DivViewBase).attrs(function (props) {
  return {
    tabIndex: -1
  };
}).withConfig({
  displayName: "AlertDialog__AlertContentContainer",
  componentId: "sc-1q916i1-0"
})(["background-color:white;border-radius:4px;overflow:hidden;margin:auto;max-height:576px;min-height:140px;outline:none;@media (max-width:", "px){width:calc(100% - 40px);}@media (min-width:", "px){width:400px;}"], _breakpoint.breakpoint.max, _breakpoint.breakpoint.min);
exports.AlertContentContainer = AlertContentContainer;
var StyledView = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "AlertDialog__StyledView",
  componentId: "sc-1q916i1-1"
})(["flex:1;align-items:stretch;box-sizing:border-box;display:flex;flex-direction:column;flex-shrink:0;position:relative;min-height:0;min-width:0;"]);
var AlertFormTitleText = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "AlertDialog__AlertFormTitleText",
  componentId: "sc-1q916i1-2"
})(["font-size:20px;color:#2b2826;line-height:20px;"]);
var AlertFormHeader = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormHeader",
  componentId: "sc-1q916i1-3"
})(["flex:none;flex-direction:row;background-color:white;border-bottom:1px solid #dddbda;height:55px;align-items:center;justify-content:center;"]);
var AlertFormContent = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormContent",
  componentId: "sc-1q916i1-4"
})(["flex:1;background-color:white;padding:24px;@media (max-width:", "px){", ";}"], _breakpoint.breakpoint.max, _StyledComponents.modalFormContentStyle);
var AlertFormFooter = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormFooter",
  componentId: "sc-1q916i1-5"
})(["flex:none;flex-direction:row;justify-content:space-between;background-color:#fbfbfb;border-top:1px solid #eee;height:64px;padding:16px;@media (max-width:", "px){height:48px;padding:8px;}"], _breakpoint.breakpoint.max);
var AlertFormRow = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormRow",
  componentId: "sc-1q916i1-6"
})(["display:flex;flex-direction:row;"]);