"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDeviceKindByWidth = getDeviceKindByWidth;
exports.DeviceKindProvider = DeviceKindProvider;
exports.useDeviceKind = useDeviceKind;

var _react = _interopRequireDefault(require("react"));

// 240-479 pixels
function getDeviceKindByWidth(width) {
  if (width >= 992) return 'desktop';
  if (width >= 768) return 'tablet';
  if (width >= 480) return 'large-phone';
  return 'phone';
}

var DeviceKindContext = _react["default"].createContext(undefined);

function DeviceKindProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/_react["default"].createElement(DeviceKindContext.Provider, {
    value: value
  }, children);
}

function useDeviceKind() {
  var deviceKind = _react["default"].useContext(DeviceKindContext);

  return deviceKind;
}