"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _IconText = _interopRequireDefault(require("./IconText"));

var createIcon = function createIcon(fontFamily, fontFileName, glyphMap) {
  // Android doesn't care about actual fontFamily name, it will only look in fonts folder
  var fontReference = fontFileName.replace(/\.(otf|ttf)$/, '');
  return function Icon(_ref) {
    var name = _ref.name,
        style = _ref.style;
    var glyph = glyphMap[name] || '?';

    if (typeof glyph === 'number') {
      glyph = String.fromCharCode(glyph);
    }

    var styleProps = {
      $fontFamilyValue: fontReference,
      style: style
    };
    return /*#__PURE__*/_react["default"].createElement(_IconText["default"], styleProps, glyph);
  };
};

var _default = createIcon;
exports["default"] = _default;