"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Avatar;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var React = _interopRequireWildcard(require("react"));

var _Colors = _interopRequireDefault(require("../../apis/Colors"));

var _Style = require("../../apis/Style");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Badge = _interopRequireDefault(require("../Badge"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _helpers = require("./helpers");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: ", "px;\n  color: white;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  align-items: center;\n  justify-content: center;\n  background-color: ", ";\n  border-radius: ", "px;\n  height: ", "px;\n  width: ", "px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function Avatar(_ref) {
  var _ref$backgroundColor = _ref.backgroundColor,
      backgroundColor = _ref$backgroundColor === void 0 ? _Colors["default"].GREY : _ref$backgroundColor,
      className = _ref.className,
      icon = _ref.icon,
      style = _ref.style,
      badge = _ref.badge,
      testID = _ref.testID,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '?' : _ref$name,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size;
  return /*#__PURE__*/React.createElement(AvatarContainer, {
    $avatarBgColor: backgroundColor,
    className: className,
    $size: size,
    style: style,
    testID: testID
  }, icon ? /*#__PURE__*/React.createElement(_Icon["default"], {
    name: icon,
    color: "white",
    size: size
  }) : /*#__PURE__*/React.createElement(StyledText, {
    $size: size
  }, (0, _helpers.getInitials)(name)), badge && /*#__PURE__*/React.createElement(_Badge["default"], {
    number: badge
  }));
}

var AvatarContainer = (0, _Style.styled)(_View["default"])(_templateObject(), function (_ref2) {
  var $avatarBgColor = _ref2.$avatarBgColor;
  return $avatarBgColor;
}, function (_ref3) {
  var $size = _ref3.$size;
  return _helpers.SizeToRadius[$size];
}, function (_ref4) {
  var $size = _ref4.$size;
  return 2 * _helpers.SizeToRadius[$size];
}, function (_ref5) {
  var $size = _ref5.$size;
  return 2 * _helpers.SizeToRadius[$size];
});
var StyledText = (0, _Style.styled)(_Text["default"])(_templateObject2(), function (_ref6) {
  var $size = _ref6.$size;
  return _helpers.SizeToRadius[$size];
});