"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledIcon = exports.SpinnerContainer = exports.ButtonLabel = exports.buttonTextStyle = exports.buttonContainerStyle = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _helpers = require("./helpers");

var buttonContainerStyle = (0, _styledComponents.css)(["flex-direction:row;align-items:center;justify-content:center;border-radius:4px;height:32px;background-color:", ";border-color:", ";border-style:solid;border-width:1px;padding-left:", "px;padding-right:", "px;"], function (props) {
  return (0, _helpers.getBackgroundColor)(props);
}, function (props) {
  return (0, _helpers.getBorderColor)(props);
}, function (_ref) {
  var icon = _ref.icon,
      text = _ref.text;
  return icon && text ? 8 : text ? 16 : 0;
}, function (_ref2) {
  var text = _ref2.text;
  return text ? 16 : 0;
});
exports.buttonContainerStyle = buttonContainerStyle;
var buttonTextStyle = (0, _styledComponents.css)(["font-size:14px;color:", ";"], function (props) {
  return props.loading ? 'transparent' : (0, _helpers.getTextColor)(props);
});
exports.buttonTextStyle = buttonTextStyle;
var ButtonLabel = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "common-styles__ButtonLabel",
  componentId: "sc-5635y3-0"
})(["", ";"], buttonTextStyle);
exports.ButtonLabel = ButtonLabel;
var SpinnerContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "common-styles__SpinnerContainer",
  componentId: "sc-5635y3-1"
})(["position:absolute;top:0;bottom:0;left:0;right:0;align-items:center;justify-content:center;border-radius:4px;"]);
exports.SpinnerContainer = SpinnerContainer;
var StyledIcon = (0, _styledComponents["default"])(_Icon["default"]).withConfig({
  displayName: "common-styles__StyledIcon",
  componentId: "sc-5635y3-2"
})(["", ";"], buttonTextStyle);
exports.StyledIcon = StyledIcon;