"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ButtonSpinner = _interopRequireDefault(require("./ButtonSpinner"));

var _styles = require("./styles");

var createButton = function createButton(containerComponent, getContainerProps) {
  var StyledContainer = (0, _styledComponents["default"])(containerComponent).withConfig({
    displayName: "createButton__StyledContainer",
    componentId: "sc-1ti3i60-0"
  })(["", ";"], _styles.buttonContainerStyle);

  function Button(props) {
    var className = props.className,
        disabled = props.disabled,
        icon = props.icon,
        iconStyle = props.iconStyle,
        loading = props.loading,
        onPress = props.onPress,
        style = props.style,
        textStyle = props.textStyle,
        testID = props.testID,
        text = props.text,
        _props$type = props.type,
        type = _props$type === void 0 ? 'primary' : _props$type;
    var styleProps = {
      // pass the original value of `disabled` so that we know if button is
      // disabled because it's loading
      hasDisabledStyle: disabled,
      loading: loading,
      type: type
    };
    var containerStyleProps = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, styleProps), {}, {
      className: className,
      icon: icon,
      style: style,
      text: text
    });
    return /*#__PURE__*/_react["default"].createElement(StyledContainer, Object.assign({}, getContainerProps && getContainerProps(props) || {}, containerStyleProps, {
      disabled: disabled || loading,
      onPress: onPress,
      testID: testID
    }), icon && /*#__PURE__*/_react["default"].createElement(_styles.StyledIcon, Object.assign({}, styleProps, {
      name: icon,
      style: iconStyle
    })), text && /*#__PURE__*/_react["default"].createElement(_styles.ButtonLabel, Object.assign({}, styleProps, {
      style: textStyle
    }), text), loading && /*#__PURE__*/_react["default"].createElement(_ButtonSpinner["default"], styleProps));
  }

  return Button;
};

var _default = createButton;
exports["default"] = _default;