"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "ButtonLabel", {
  enumerable: true,
  get: function get() {
    return _commonStyles.ButtonLabel;
  }
});
Object.defineProperty(exports, "SpinnerContainer", {
  enumerable: true,
  get: function get() {
    return _commonStyles.SpinnerContainer;
  }
});
Object.defineProperty(exports, "StyledIcon", {
  enumerable: true,
  get: function get() {
    return _commonStyles.StyledIcon;
  }
});
Object.defineProperty(exports, "buttonTextStyle", {
  enumerable: true,
  get: function get() {
    return _commonStyles.buttonTextStyle;
  }
});
exports.buttonContainerStyle = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _Style = require("../../apis/Style");

var _commonStyles = require("./common-styles");

var _helpers = require("./helpers");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", ";\n\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var webButtonContainerStyle = (0, _Style.css)(_templateObject(), _commonStyles.buttonContainerStyle, function (_ref) {
  var disabled = _ref.disabled,
      type = _ref.type;
  return !disabled && "\n    &:hover,\n    &:focus {\n      background-color: ".concat((0, _helpers.getFocusedBackgroundColor)({
    type: type
  }), ";\n      border-color: ").concat((0, _helpers.getFocusedBorderColor)({
    type: type
  }), ";\n      * {\n        color: ").concat((0, _helpers.getFocusedTextColor)({
    type: type
  }), ";\n      }\n    }\n\n    &:active {\n      background-color: ").concat((0, _helpers.getActiveBackgroundColor)({
    type: type
  }), ";\n      border-color: ").concat((0, _helpers.getActiveBorderColor)({
    type: type
  }), ";\n      * {\n        color: ").concat((0, _helpers.getActiveTextColor)({
    type: type
  }), ";\n      }\n    }\n  ");
});
exports.buttonContainerStyle = webButtonContainerStyle;