"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Picker = _interopRequireDefault(require("../../../internals/Picker.native"));

var _constants = require("../constants");

var _StyledComponents = require("../StyledComponents");

var DatePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DatePicker, _React$Component);

  var _super = (0, _createSuper2["default"])(DatePicker);

  function DatePicker() {
    var _this;

    (0, _classCallCheck2["default"])(this, DatePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._openPicker = function () {
      var onFocus = _this.props.onFocus;
      onFocus && onFocus();

      _reactNative.DatePickerAndroid.open({
        year: _this._date.year(),
        month: _this._date.month(),
        day: _this._date.day()
      }).then(_this._onDateSelect);
    };

    _this._onDateSelect = function (_ref) {
      var action = _ref.action,
          year = _ref.year,
          month = _ref.month,
          day = _ref.day;

      if (action !== _reactNative.DatePickerAndroid.dismissedAction) {
        var date = (0, _moment["default"])({
          year: year,
          month: month,
          day: day
        });

        _this._selectDate(date);
      } else {
        _this.blur();
      }
    };

    _this._renderValue = function () {
      var placeholder = _this.props.placeholder;

      if (!_this._dateStr) {
        return /*#__PURE__*/React.createElement(_StyledComponents.PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(_StyledComponents.ValueText, null, _this._dateStr);
    };

    _this._selectDate = function (date) {
      var _this$props = _this.props,
          onValueChange = _this$props.onValueChange,
          valueFormat = _this$props.valueFormat;

      _this.blur();

      onValueChange && onValueChange(date.format(valueFormat));
    };

    return _this;
  }

  (0, _createClass2["default"])(DatePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          accessibilityLabel = _this$props2.accessibilityLabel,
          autoFocus = _this$props2.autoFocus,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          displayFormat = _this$props2.displayFormat,
          onBlur = _this$props2.onBlur,
          readOnly = _this$props2.readOnly,
          renderDropdownIcon = _this$props2.renderDropdownIcon,
          style = _this$props2.style,
          testID = _this$props2.testID,
          value = _this$props2.value,
          valueFormat = _this$props2.valueFormat;
      var styleProps = {
        style: style
      };

      if (value) {
        this._date = (0, _moment["default"])(value, valueFormat);
        this._dateStr = this._date.format(displayFormat);
      } else {
        this._date = (0, _moment["default"])();
        this._dateStr = '';
      }

      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onFocus: this._openPicker,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/React.createElement(_Picker["default"], Object.assign({}, styleProps, props));
    }
  }]);
  return DatePicker;
}(React.Component);

DatePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: _constants.DEFAULT_DATE_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: _constants.DEFAULT_DATE_VALUE_FORMAT
};
DatePicker.displayName = 'DatePicker';
var _default = DatePicker;
exports["default"] = _default;