"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Picker = _interopRequireDefault(require("../../../internals/Picker.native"));

var _constants = require("../constants");

var _StyledComponents = require("../StyledComponents");

var getDefaultDate = function getDefaultDate() {
  return new Date();
};

var DatePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DatePicker, _React$Component);

  var _super = (0, _createSuper2["default"])(DatePicker);

  (0, _createClass2["default"])(DatePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }]);

  function DatePicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, DatePicker);
    _this = _super.call(this, props);

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._onDateChange = function (date) {
      _this.setState({
        selectedDate: date
      });
    };

    _this._renderPopup = function () {
      return /*#__PURE__*/React.createElement(_reactNative.DatePickerIOS, {
        date: _this.state.selectedDate || getDefaultDate(),
        mode: "date",
        onDateChange: _this._onDateChange
      });
    };

    _this._renderValue = function () {
      var _this$props = _this.props,
          displayFormat = _this$props.displayFormat,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          valueFormat = _this$props.valueFormat;
      var date = (0, _moment["default"])(value || '', valueFormat);
      var dateStr = date.isValid() ? date.format(displayFormat) : '';

      if (!dateStr) {
        return /*#__PURE__*/React.createElement(_StyledComponents.PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(_StyledComponents.ValueText, null, dateStr);
    };

    _this._selectDate = function (date) {
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          valueFormat = _this$props2.valueFormat;

      _this.blur();

      _this.setState({
        selectedDate: date
      });

      if (onValueChange) {
        var dateMoment = (0, _moment["default"])(date);

        if (dateMoment.isValid()) {
          onValueChange(dateMoment.format(valueFormat));
        } else {
          onValueChange(null);
        }
      }
    };

    var _this$props3 = _this.props,
        _value = _this$props3.value,
        _valueFormat = _this$props3.valueFormat;
    var initialDate = (0, _moment["default"])(_value || '', _valueFormat);

    if (!initialDate.isValid()) {
      initialDate = (0, _moment["default"])();
    }

    _this.state = {
      selectedDate: initialDate.toDate()
    };
    return _this;
  }

  (0, _createClass2["default"])(DatePicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          accessibilityLabel = _this$props4.accessibilityLabel,
          autoFocus = _this$props4.autoFocus,
          clearable = _this$props4.clearable,
          clearValueText = _this$props4.clearValueText,
          onBlur = _this$props4.onBlur,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly,
          renderDropdownIcon = _this$props4.renderDropdownIcon,
          style = _this$props4.style,
          testID = _this$props4.testID;
      var styleProps = {
        style: style
      };
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onClear: function onClear() {
          return _this2._selectDate(null);
        },
        onConfirm: function onConfirm() {
          return _this2._selectDate(_this2.state.selectedDate || getDefaultDate());
        },
        onFocus: onFocus,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopup: this._renderPopup,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/React.createElement(_Picker["default"], Object.assign({}, styleProps, props));
    }
  }]);
  return DatePicker;
}(React.Component);

DatePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: _constants.DEFAULT_DATE_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: _constants.DEFAULT_DATE_VALUE_FORMAT
};
DatePicker.displayName = 'DatePicker';
var _default = DatePicker;
exports["default"] = _default;