"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _Picker = _interopRequireDefault(require("../../../internals/Picker.web"));

var _Calendar = _interopRequireDefault(require("./Calendar"));

var _StyledComponents = require("./StyledComponents");

var DEFAULT_DATE_FORMAT = 'YYYY-MM-DD';

var DatePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DatePicker, _React$Component);

  var _super = (0, _createSuper2["default"])(DatePicker);

  function DatePicker() {
    var _this;

    (0, _classCallCheck2["default"])(this, DatePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._renderPopover = function () {
      return /*#__PURE__*/React.createElement(_Calendar["default"], {
        alignRight: _this.props.alignRight,
        initialDate: _this._date,
        onSelect: _this._selectDate
      });
    };

    _this._renderValue = function () {
      var placeholder = _this.props.placeholder;

      if (!_this._dateStr) {
        return /*#__PURE__*/React.createElement(_StyledComponents.PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(_StyledComponents.ValueText, {
        $textColor: _this.props.textColor
      }, _this._dateStr);
    };

    _this._selectDate = function (date) {
      var _this$props = _this.props,
          onValueChange = _this$props.onValueChange,
          valueFormat = _this$props.valueFormat;

      _this.blur();

      onValueChange && onValueChange(date.format(valueFormat));
    };

    return _this;
  }

  (0, _createClass2["default"])(DatePicker, [{
    key: "blur",
    value: function blur() {
      var picker = this._picker;
      picker && setTimeout(function () {
        return picker.blur();
      }, 10); // the timeout is to counter some focus event that occurs after setting the value
      // not an elegant fix, will need to fix this properly, Hernus
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          accessibilityLabel = _this$props2.accessibilityLabel,
          autoFocus = _this$props2.autoFocus,
          className = _this$props2.className,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          displayFormat = _this$props2.displayFormat,
          modal = _this$props2.modal,
          onBlur = _this$props2.onBlur,
          onFocus = _this$props2.onFocus,
          onValueChange = _this$props2.onValueChange,
          readOnly = _this$props2.readOnly,
          renderDropdownIcon = _this$props2.renderDropdownIcon,
          style = _this$props2.style,
          testID = _this$props2.testID,
          value = _this$props2.value,
          valueFormat = _this$props2.valueFormat,
          alignRight = _this$props2.alignRight;
      var styleProps = {
        className: className,
        style: style
      };

      if (value) {
        this._date = (0, _moment["default"])(value, valueFormat);
        this._dateStr = this._date.format(displayFormat);
      } else {
        this._date = (0, _moment["default"])();
        this._dateStr = '';
      }

      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        modal: modal,
        onBlur: onBlur,
        onFocus: onFocus,
        onValueChange: onValueChange,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopover: this._renderPopover,
        renderValue: this._renderValue,
        testID: testID,
        alignRight: alignRight
      };
      return /*#__PURE__*/React.createElement(_Picker["default"], Object.assign({}, styleProps, props));
    }
  }]);
  return DatePicker;
}(React.Component);

DatePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: DEFAULT_DATE_FORMAT,
  readOnly: false,
  valueFormat: DEFAULT_DATE_FORMAT,
  alignRight: undefined,
  textColor: undefined
};
DatePicker.displayName = 'DatePicker';
var _default = DatePicker;
exports["default"] = _default;