"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Dropdown;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var React = _interopRequireWildcard(require("react"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _Modal = _interopRequireDefault(require("./Modal"));

var _StyledComponents = require("./StyledComponents.native");

// Note that this is not the Modal we export. It has a slide animation on native.
function Dropdown(_ref) {
  var actions = _ref.actions,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'more-vert' : _ref$icon,
      children = _ref.children,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? 'black' : _ref$iconColor;

  var _React$useState = React.useState(false),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var close = function close() {
    return setActive(false);
  };

  var renderAction = function renderAction(action) {
    return /*#__PURE__*/React.createElement(_StyledComponents.ActionRow, {
      key: action.label,
      onPress: function onPress() {
        close();
        action.onPress();
      }
    }, action.icon && /*#__PURE__*/React.createElement(_Icon["default"], {
      name: action.icon
    }), /*#__PURE__*/React.createElement(_StyledComponents.Label, null, action.label));
  };

  return /*#__PURE__*/React.createElement(_StyledComponents.LinkContainer, null, /*#__PURE__*/React.createElement(_StyledComponents.LinkInner, {
    onPress: function onPress() {
      return setActive(true);
    }
  }, children || /*#__PURE__*/React.createElement(_Icon["default"], {
    name: icon,
    color: iconColor
  })), /*#__PURE__*/React.createElement(_Modal["default"], {
    onRequestClose: close,
    visible: active
  }, /*#__PURE__*/React.createElement(_StyledComponents.ModalContainer, null, /*#__PURE__*/React.createElement(_StyledComponents.BackLink, {
    onPress: close
  }, /*#__PURE__*/React.createElement(_View["default"], {
    pointerEvents: 'none'
  }, /*#__PURE__*/React.createElement(_Icon["default"], {
    name: "arrow-back-ios"
  }))), actions.map(renderAction))));
}