"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _Style = require("../../apis/Style");

var _IconMaterial = _interopRequireDefault(require("./IconMaterial"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  flex: none;\n  align-items: center;\n  ", ";\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var Icon = (0, _Style.styled)(_IconMaterial["default"])(_templateObject(), function (_ref) {
  var color = _ref.color;
  return color && "color: ".concat(color);
}, function (_ref2) {
  var size = _ref2.size;
  var fontSizeString;
  var sizes = {
    small: 16,
    medium: 32,
    large: 48
  }; // If use input is number then use number
  // Else if use input is nothing return default 16
  // If user input small, medium or large then return the relevent one

  if (typeof size === 'number' && Number.isFinite(size) && size > 0) {
    fontSizeString = size;
  } else if (size === 'small' || size === 'medium' || size === 'large') {
    fontSizeString = sizes[size];
  } else {
    fontSizeString = 16;
    return "height: 24px;\n              line-height: 24px;\n              width: 24px;\n              font-size: ".concat(fontSizeString, "px");
  }

  return "height: ".concat(fontSizeString, "px;\n            line-height: ").concat(fontSizeString, "px;\n            width: ").concat(fontSizeString, "px;\n            font-size: ").concat(fontSizeString, "px");
});
Icon.displayName = 'Icon';
var _default = Icon;
exports["default"] = _default;