"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _Style = require("../../apis/Style");

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _Icon = _interopRequireDefault(require("../Icon"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var IconButton = function IconButton(_ref) {
  var className = _ref.className,
      color = _ref.color,
      disabled = _ref.disabled,
      name = _ref.name,
      onPress = _ref.onPress,
      style = _ref.style,
      tooltip = _ref.tooltip,
      size = _ref.size,
      testID = _ref.testID;
  var iconProps = {
    color: color,
    name: name,
    size: size
  };
  return /*#__PURE__*/_react["default"].createElement(StyledTouchableView, {
    className: className,
    disabled: disabled,
    onPress: onPress,
    style: style,
    tooltip: tooltip,
    size: size,
    testID: testID || "iconButton-".concat(name)
  }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], iconProps));
};

var _default = IconButton;
exports["default"] = _default;
var StyledTouchableView = (0, _Style.styled)(_TouchableView["default"])(_templateObject(), function (_ref2) {
  var size = _ref2.size;
  var containerSizeString;
  var sizes = {
    small: 16,
    medium: 32,
    large: 48
  }; // If use input is number then use number
  // Else if use input is nothing return default 16, and the container should be 24x24 to keep a space between two Icons
  // If user input small, medium or large then return the relevent one

  if (typeof size === 'number' && Number.isFinite(size) && size > 0) {
    containerSizeString = size;
  } else if (size === 'small' || size === 'medium' || size === 'large') {
    containerSizeString = sizes[size];
  } else {
    return "height: 24px;\n              width: 24px;";
  }

  return "height: ".concat(containerSizeString, "px;\n          width: ").concat(containerSizeString, "px;");
});