"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../apis/Style");

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Badge = _interopRequireDefault(require("../Badge"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _SubHeading = _interopRequireDefault(require("../SubHeading"));

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  width: ", ";\n  font-size: ", ";\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  padding: 8px;\n  border-radius: 3px;\n  width: 100%;\n  height: ", ";\n  background: ", ";\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  margin: 8px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])([""]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  align-items: center;\n  width: ", ";\n  margin: ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var IconCard = function IconCard(_ref) {
  var icon = _ref.icon,
      color = _ref.color,
      badge = _ref.badge,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'small' : _ref$size,
      testID = _ref.testID,
      text = _ref.text,
      onPress = _ref.onPress,
      style = _ref.style;
  var sizes = {
    small: 40,
    medium: 80,
    large: 120
  };
  return /*#__PURE__*/React.createElement(Container, {
    $size: sizes[size],
    onPress: onPress,
    style: style,
    testID: testID
  }, /*#__PURE__*/React.createElement(StyledView, {
    $color: color,
    $size: sizes[size]
  }, badge && /*#__PURE__*/React.createElement(_Badge["default"], {
    number: badge
  }), /*#__PURE__*/React.createElement(StyledIcon, {
    name: icon !== null && icon !== void 0 ? icon : '',
    color: color && 'white',
    $size: sizes[size]
  })), text && /*#__PURE__*/React.createElement(StyledSubHeading, null, text));
};

var _default = IconCard;
exports["default"] = _default;
var Container = (0, _Style.styled)(_TouchableView["default"])(_templateObject(), function (_ref2) {
  var $size = _ref2.$size;
  return $size ? "".concat($size, "px") : '40px';
}, function (_ref3) {
  var $size = _ref3.$size;
  return $size ? "".concat($size / 10, "px") : '8px';
});
var StyledSubHeading = (0, _Style.styled)(_SubHeading["default"])(_templateObject2());
var StyledView = (0, _Style.styled)(_View["default"])(_templateObject3(), function (_ref4) {
  var $size = _ref4.$size;
  return "".concat($size, "px");
}, function (_ref5) {
  var $color = _ref5.$color;
  return $color || '#D8D8D8';
});
var StyledIcon = (0, _Style.styled)(_Icon["default"])(_templateObject4(), function (_ref6) {
  var $size = _ref6.$size;
  return $size ? "".concat($size * 2 / 5, "px") : '16px';
}, function (_ref7) {
  var $size = _ref7.$size;
  return $size ? "".concat($size / 3, "px") : '14px';
});