"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _chunk = _interopRequireDefault(require("lodash/chunk"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _MaterialIcons = _interopRequireDefault(require("../../../../glyphmaps/MaterialIcons.json"));

var _TextField = _interopRequireDefault(require("../../../components/input-fields/TextField"));

var _FlatList = _interopRequireDefault(require("../../../primitives/FlatList"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _IconButton = _interopRequireDefault(require("../../IconButton"));

var _Modal = _interopRequireDefault(require("../../Modal"));

var iconList = Object.keys(_MaterialIcons["default"]);

var IconModal = function IconModal(_ref) {
  var modalVisable = _ref.modalVisable,
      setModalVisable = _ref.setModalVisable,
      setIconName = _ref.setIconName;
  var ARRAY_SIZE = 23;

  var _useState = (0, _react.useState)(''),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      input = _useState2[0],
      setInput = _useState2[1]; // filter the list and generate 2D array for flatList


  var resultArray = (0, _react.useMemo)(function () {
    return (0, _chunk["default"])(iconList.filter(function (icon) {
      return input ? icon.includes(input) : true;
    }), ARRAY_SIZE);
  }, [input]);
  return /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    onRequestClose: function onRequestClose() {
      return setModalVisable(false);
    },
    visible: modalVisable,
    title: "Please choose your Icon"
  }, /*#__PURE__*/_react["default"].createElement(IconsContainer, null, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
    value: input,
    onValueChange: setInput,
    placeholder: "Type to search Icon",
    reserveErrorSpace: false
  }), /*#__PURE__*/_react["default"].createElement(FlatListContainer, null, /*#__PURE__*/_react["default"].createElement(_FlatList["default"], {
    horizontal: false,
    data: resultArray,
    renderItem: function renderItem(_ref2) {
      var item = _ref2.item;
      return /*#__PURE__*/_react["default"].createElement(FlatListRow, {
        key: item[0]
      }, item.map(function (icon) {
        return /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          key: icon,
          name: icon,
          onPress: function onPress() {
            setIconName(icon);
            setModalVisable(false);
          },
          tooltip: icon
        });
      }));
    }
  }))));
};

var IconsContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "IconModalweb__IconsContainer",
  componentId: "sc-17qn6fz-0"
})(["padding:0px 8px;"]);
var FlatListContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "IconModalweb__FlatListContainer",
  componentId: "sc-17qn6fz-1"
})(["align-items:center;height:145px;"]);
var FlatListRow = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "IconModalweb__FlatListRow",
  componentId: "sc-17qn6fz-2"
})(["flex-direction:row;"]);
var _default = IconModal;
exports["default"] = _default;