"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Menu;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var React = _interopRequireWildcard(require("react"));

var _Colors = _interopRequireDefault(require("../../apis/Colors"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _MenuContext = require("./MenuContext");

var _Modal = _interopRequireDefault(require("./Modal"));

var _StyledComponents = require("./StyledComponents.native");

// Note that this is not the Modal we export. It has a slide animation on native.
function Menu(_ref) {
  var children = _ref.children,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'menu' : _ref$icon,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? _Colors["default"].BLACK : _ref$iconColor,
      testID = _ref.testID,
      trigger = _ref.trigger,
      triggerStyle = _ref.triggerStyle;

  var _React$useState = React.useState(false),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var close = function close() {
    return setActive(false);
  };

  return /*#__PURE__*/React.createElement(_MenuContext.Context.Provider, {
    value: {
      close: close,
      active: active
    }
  }, /*#__PURE__*/React.createElement(_StyledComponents.TriggerContainer, {
    onPress: function onPress() {
      return setActive(true);
    },
    style: triggerStyle,
    testID: testID
  }, typeof trigger === 'function' ? trigger(active) : trigger || /*#__PURE__*/React.createElement(_Icon["default"], {
    name: icon,
    color: iconColor
  })), /*#__PURE__*/React.createElement(_Modal["default"], {
    onRequestClose: close,
    visible: active
  }, /*#__PURE__*/React.createElement(_StyledComponents.ModalContainer, null, children)));
}

var Item = function Item(_ref2) {
  var children = _ref2.children,
      icon = _ref2.icon,
      numberOfLines = _ref2.numberOfLines,
      _onPress = _ref2.onPress;
  var context = (0, _MenuContext.useMenuContext)();
  return /*#__PURE__*/React.createElement(_StyledComponents.ActionRow, {
    onPress: function onPress() {
      context.close();
      _onPress === null || _onPress === void 0 ? void 0 : _onPress();
    }
  }, typeof children === 'string' ? /*#__PURE__*/React.createElement(React.Fragment, null, icon ? /*#__PURE__*/React.createElement(_StyledComponents.MenuItemIcon, {
    name: icon
  }) : null, /*#__PURE__*/React.createElement(_StyledComponents.MenuItemLabel, {
    numberOfLines: numberOfLines,
    $hasIcon: !!icon
  }, children)) : children);
};

Menu.Item = Item;