"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Menu;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var React = _interopRequireWildcard(require("react"));

var _Colors = _interopRequireDefault(require("../../apis/Colors"));

var _DeviceKind = require("../../apis/DeviceKind");

var _Popover = require("../../internals/Popover.web");

var _Icon = _interopRequireDefault(require("../Icon"));

var _MenuContext = require("./MenuContext");

var _StyledComponents = require("./StyledComponents.web");

function Menu(_ref) {
  var align = _ref.align,
      children = _ref.children,
      className = _ref.className,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'menu' : _ref$icon,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? _Colors["default"].BLACK : _ref$iconColor,
      _ref$maxHeight = _ref.maxHeight,
      maxHeight = _ref$maxHeight === void 0 ? 150 : _ref$maxHeight,
      maxWidth = _ref.maxWidth,
      _ref$minWidth = _ref.minWidth,
      minWidth = _ref$minWidth === void 0 ? 120 : _ref$minWidth,
      testID = _ref.testID,
      trigger = _ref.trigger,
      triggerStyle = _ref.triggerStyle;

  var _React$useState = React.useState(false),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var containerRef = React.useRef(null);
  var deviceKind = (0, _DeviceKind.useDeviceKind)();

  var close = function close() {
    return setActive(false);
  };

  var getPopoverPlacement = function getPopoverPlacement(anchorRect, popupContentRect) {
    var right = anchorRect.left - popupContentRect.width + anchorRect.width;
    var distanceFromRight = window.innerWidth - anchorRect.left - anchorRect.width;

    var _align = align || (anchorRect.left < distanceFromRight * 2 ? 'left' : 'right');

    return {
      top: anchorRect.bottom,
      left: _align === 'left' ? anchorRect.left : right
    };
  };

  return /*#__PURE__*/React.createElement(_MenuContext.Context.Provider, {
    value: {
      close: close,
      active: active
    }
  }, /*#__PURE__*/React.createElement(_StyledComponents.TriggerContainer, {
    ref: containerRef,
    className: className,
    onClick: function onClick() {
      return setActive(true);
    },
    testID: testID,
    style: triggerStyle
  }, typeof trigger === 'function' ? trigger(active) : trigger || /*#__PURE__*/React.createElement(_Icon["default"], {
    name: icon,
    color: iconColor
  })), active ? /*#__PURE__*/React.createElement(_Popover.Popover, {
    anchorEl: containerRef.current,
    onRequestClose: function onRequestClose() {
      return setActive(false);
    },
    placement: getPopoverPlacement,
    visible: true
  }, /*#__PURE__*/React.createElement(_StyledComponents.PopoverContentContainer, {
    $minWidth: minWidth,
    $maxWidth: maxWidth,
    $maxHeight: maxHeight,
    $deviceKind: deviceKind
  }, children)) : null);
}

var Item = function Item(_ref2) {
  var children = _ref2.children,
      icon = _ref2.icon,
      numberOfLines = _ref2.numberOfLines,
      _onPress = _ref2.onPress;
  var context = (0, _MenuContext.useMenuContext)();
  return /*#__PURE__*/React.createElement(_StyledComponents.ActionRow, {
    onPress: function onPress() {
      context.close();
      _onPress === null || _onPress === void 0 ? void 0 : _onPress();
    }
  }, typeof children === 'string' ? /*#__PURE__*/React.createElement(React.Fragment, null, icon ? /*#__PURE__*/React.createElement(_StyledComponents.MenuItemIcon, {
    name: icon
  }) : null, /*#__PURE__*/React.createElement(_StyledComponents.MenuItemLabel, {
    numberOfLines: numberOfLines,
    $hasIcon: !!icon
  }, children)) : children);
};

Menu.Item = Item;