"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _SubmitButton = _interopRequireDefault(require("../../SubmitButton"));

var _ = _interopRequireDefault(require(".."));

test('should not trigger submit of the outer form when inner form is submitted', function () {
  var handleOuterSubmit = jest.fn();
  var handleInnerSubmit = jest.fn();

  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/_react["default"].createElement(_["default"], {
    onRequestClose: function onRequestClose() {},
    onSubmit: handleOuterSubmit,
    testID: "outer",
    visible: true
  }, /*#__PURE__*/_react["default"].createElement(_["default"], {
    onRequestClose: function onRequestClose() {},
    onSubmit: handleInnerSubmit,
    testID: "inner",
    visible: true
  }, /*#__PURE__*/_react["default"].createElement(_SubmitButton["default"], {
    testID: "submit",
    text: "Submit"
  })))),
      getByTestId = _render.getByTestId;

  var submitButton = getByTestId('submit');
  expect(submitButton).toBeTruthy();

  _reactTestingLibrary.fireEvent.click(submitButton);

  expect(handleInnerSubmit).toHaveBeenCalledTimes(1);
  expect(handleOuterSubmit).toHaveBeenCalledTimes(0);
});