"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ModalWizard;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _Style = require("../../apis/Style");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Button = _interopRequireDefault(require("../Button"));

var _Modal = _interopRequireDefault(require("../Modal"));

var _SubmitButton = _interopRequireDefault(require("../SubmitButton"));

var _styles = require("./styles");

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-left: 16px;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-left: 16px;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  background-color: #fafafa;\n  align-items: center;\n  flex-direction: row;\n  justify-content: flex-end;\n  ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: 18px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  align-items: center;\n  justify-content: center;\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function ModalWizard(_ref) {
  var startFromStep = _ref.startFromStep,
      onFinish = _ref.onFinish,
      onRequestClose = _ref.onRequestClose,
      screens = _ref.screens,
      submitButtonText = _ref.submitButtonText,
      _ref$canSubmit = _ref.canSubmit,
      canSubmit = _ref$canSubmit === void 0 ? true : _ref$canSubmit,
      placement = _ref.placement,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? true : _ref$visible,
      testID = _ref.testID;

  var _React$useState = _react["default"].useState({
    step: startFromStep || 0,
    submitting: false,
    formValues: {}
  }),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var isLastStep = state.step + 1 === screens.length;

  var handleSubmit = /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setState((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
                submitting: true
              }));

              if (!(typeof onFinish === 'function')) {
                _context.next = 4;
                break;
              }

              _context.next = 4;
              return onFinish();

            case 4:
              onRequestClose();

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleSubmit() {
      return _ref2.apply(this, arguments);
    };
  }();

  var renderCommonFooterButtons = function renderCommonFooterButtons() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, state.step > 0 && /*#__PURE__*/_react["default"].createElement(FooterButton, {
      type: "tertiary",
      text: "Back",
      onPress: function onPress() {
        return setState(function (_ref3) {
          var step = _ref3.step;
          return (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
            step: step - 1
          });
        });
      }
    }), /*#__PURE__*/_react["default"].createElement(FooterButton, {
      type: "tertiary",
      text: "Cancel",
      onPress: onRequestClose
    }));
  };

  var renderForm = function renderForm() {
    var currentScreen = screens[state.step]; // Make the form aware/controllable of steps

    var FormElement = currentScreen.render();
    var initialValues = state.formValues[state.step];
    return /*#__PURE__*/_react["default"].createElement(FormElement.type, Object.assign({
      style: {
        flex: 1
      },
      initialValues: initialValues
    }, FormElement.props, {
      onSubmit: /*#__PURE__*/function () {
        var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(filledFormValues) {
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  // save in state
                  setState(function (_ref5) {
                    var formValues = _ref5.formValues,
                        step = _ref5.step;
                    var updatedFormValues = (0, _objectSpread2["default"])({}, formValues);
                    updatedFormValues[state.step] = filledFormValues;
                    return (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
                      formValues: updatedFormValues,
                      step: isLastStep ? step : step + 1
                    });
                  }); // invoke user's onSubmit callback

                  _context2.next = 3;
                  return FormElement.props.onSubmit(filledFormValues);

                case 3:
                  // handling steps
                  if (isLastStep) {
                    handleSubmit();
                  }

                case 4:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        return function (_x) {
          return _ref4.apply(this, arguments);
        };
      }()
    }), function (formState) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styles.BodyContainer, null, typeof FormElement.props.children === 'function' ? FormElement.props.children(formState) : FormElement.props.children), /*#__PURE__*/_react["default"].createElement(Footer, null, renderCommonFooterButtons(), isLastStep ? /*#__PURE__*/_react["default"].createElement(FormSubmitButton, {
        text: submitButtonText || 'Submit',
        type: "primary"
      }) : /*#__PURE__*/_react["default"].createElement(FormSubmitButton, {
        text: "Next",
        type: "tertiary"
      })));
    });
  };

  var renderNonForm = function renderNonForm() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styles.BodyContainer, null, screens[state.step].render()), /*#__PURE__*/_react["default"].createElement(Footer, null, renderCommonFooterButtons(), isLastStep ? /*#__PURE__*/_react["default"].createElement(FooterButton, {
      type: "primary",
      text: submitButtonText || 'Submit',
      onPress: handleSubmit,
      loading: state.submitting,
      disabled: !canSubmit
    }) : /*#__PURE__*/_react["default"].createElement(FooterButton, {
      type: "tertiary",
      text: "Next",
      onPress: function onPress() {
        return setState(function (_ref6) {
          var step = _ref6.step;
          return (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
            step: step + 1
          });
        });
      }
    })));
  };

  var currentScreen = screens[state.step];
  return /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    visible: visible,
    onRequestClose: onRequestClose,
    placement: placement,
    hideHeader: true,
    "data-testid": testID
  }, /*#__PURE__*/_react["default"].createElement(HeadingContainer, null, /*#__PURE__*/_react["default"].createElement(Heading, null, currentScreen.title || 'Wizard')), currentScreen.isForm ? renderForm() : renderNonForm());
}

var HeadingContainer = (0, _Style.styled)(_View["default"])(_templateObject(), _styles.headingStyle);
var Heading = (0, _Style.styled)(_Text["default"])(_templateObject2());
var Footer = (0, _Style.styled)(_View["default"])(_templateObject3(), _styles.footerStyle);
var FooterButton = (0, _Style.styled)(_Button["default"])(_templateObject4());
var FormSubmitButton = (0, _Style.styled)(_SubmitButton["default"])(_templateObject5());