"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ModalWizardTest;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _Form = _interopRequireDefault(require("../../../primitives/Form/Form.web"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Button = _interopRequireDefault(require("../../Button"));

var _SelectField = _interopRequireDefault(require("../../input-fields/SelectField"));

var _TextField = _interopRequireDefault(require("../../input-fields/TextField"));

var _ = _interopRequireDefault(require(".."));

function ModalWizardTest() {
  var _React$useState = _react["default"].useState({
    showModal: false,
    formValues: {}
  }),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var renderFirstScreen = function renderFirstScreen() {
    return /*#__PURE__*/_react["default"].createElement(_Form["default"], {
      onSubmit: function onSubmit(formValues) {
        return setState((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
          formValues: formValues
        }));
      }
    }, function (_ref) {
      var getFieldValue = _ref.getFieldValue;
      var requireAge = getFieldValue('requireAge');
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Form["default"].Field, {
        name: "name",
        label: "Name",
        component: _TextField["default"],
        validate: function validate(value) {
          return value ? undefined : 'Required';
        }
      }), /*#__PURE__*/_react["default"].createElement(_Form["default"].Field, {
        name: "requireAge",
        label: "Require Age",
        component: _SelectField["default"],
        props: {
          options: [{
            value: 'yes',
            label: 'Yes'
          }, {
            value: 'no',
            label: 'No'
          }]
        }
      }), requireAge === 'yes' && /*#__PURE__*/_react["default"].createElement(_Form["default"].Field, {
        name: "age",
        label: "Age",
        component: _TextField["default"]
      }));
    });
  };

  var renderSecondScreen = function renderSecondScreen() {
    var formValues = state.formValues;
    return /*#__PURE__*/_react["default"].createElement(_View["default"], null, /*#__PURE__*/_react["default"].createElement(_Text["default"], null, "Summary"), /*#__PURE__*/_react["default"].createElement(_Text["default"], null, "Selected values are:"), /*#__PURE__*/_react["default"].createElement(_Text["default"], null, "Name: ", formValues.name), /*#__PURE__*/_react["default"].createElement(_Text["default"], null, "Age: ", formValues.age));
  };

  return /*#__PURE__*/_react["default"].createElement(_View["default"], null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    onPress: function onPress() {
      return setState((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
        showModal: true
      }));
    },
    text: "Open Wizard"
  }), state.showModal && /*#__PURE__*/_react["default"].createElement(_["default"], {
    testID: "test",
    visible: true,
    onRequestClose: function onRequestClose() {
      return setState((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, state), {}, {
        showModal: false
      }));
    },
    screens: [{
      title: 'First Step',
      render: renderFirstScreen,
      isForm: true
    }, {
      title: 'Second Step',
      render: renderSecondScreen
    }],
    onFinish: function onFinish() {
      return console.log('Submitting the wizard, values are: ', state.formValues);
    }
  }));
}