"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../../apis/Style");

var _FlatList = _interopRequireDefault(require("../../../primitives/FlatList"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: 20px;\n  opacity: ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  align-items: center;\n  flex-direction: row;\n  height: ", "px;\n  padding: 0 10px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  flex: 1;\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var ROW_HEIGHT = 50;

var Menu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Menu, _React$Component);

  var _super = (0, _createSuper2["default"])(Menu);

  function Menu() {
    var _this;

    (0, _classCallCheck2["default"])(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._defaultGetItemLayout = function (item, index) {
      return {
        length: ROW_HEIGHT,
        offset: ROW_HEIGHT * index,
        index: index
      };
    };

    _this._defaultRenderOption = function (_ref) {
      var option = _ref.option,
          isSelected = _ref.isSelected;
      var optionLabel = option[_this.props.labelKey];
      return /*#__PURE__*/React.createElement(Row, {
        testID: "select-option-".concat(optionLabel)
      }, /*#__PURE__*/React.createElement(Label, {
        numberOfLines: 2,
        $isDisabled: option.disabled
      }, optionLabel), /*#__PURE__*/React.createElement(SelectedIcon, {
        $show: isSelected
      }, "\u2713"));
    };

    _this._keyExtractor = function (option) {
      return option[_this.props.valueKey];
    };

    _this._renderItem = function (_ref2) {
      var option = _ref2.item,
          index = _ref2.index;
      var _this$props = _this.props,
          onItemSelect = _this$props.onItemSelect,
          selectedOptions = _this$props.selectedOptions;
      var renderOption = _this.props.renderOption || _this._defaultRenderOption;
      var isSelected = selectedOptions.indexOf(option) > -1;
      return /*#__PURE__*/React.createElement(_TouchableView["default"], {
        disabled: option.disabled,
        onPress: function onPress() {
          return onItemSelect(option);
        }
      }, renderOption({
        option: option,
        index: index,
        isSelected: isSelected
      }));
    };

    return _this;
  }

  (0, _createClass2["default"])(Menu, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          getItemLayout = _this$props2.getItemLayout,
          onEndReached = _this$props2.onEndReached,
          onEndReachedThreshold = _this$props2.onEndReachedThreshold,
          options = _this$props2.options;
      return /*#__PURE__*/React.createElement(_FlatList["default"], {
        data: options,
        getItemLayout: getItemLayout || this._defaultGetItemLayout,
        keyExtractor: this._keyExtractor,
        onEndReached: onEndReached,
        onEndReachedThreshold: onEndReachedThreshold,
        renderItem: this._renderItem
      });
    }
  }]);
  return Menu;
}(React.Component);

var _default = Menu;
exports["default"] = _default;
var Label = (0, _Style.styled)(_Text["default"])(_templateObject(), function (_ref3) {
  var $isDisabled = _ref3.$isDisabled;
  return $isDisabled && "\n    color: #ccc;\n  ";
});
var Row = (0, _Style.styled)(_View["default"])(_templateObject2(), ROW_HEIGHT);
var SelectedIcon = (0, _Style.styled)(_Text["default"])(_templateObject3(), function (props) {
  return props.$show ? '1' : '0';
});