"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _FontContext = _interopRequireDefault(require("../../../primitives/Font/FontContext"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

function normalizeSearchText(rawText) {
  if (!rawText) return '';
  return rawText.match(/\w|\s/g).join('').replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' ');
}

var SearchBar = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SearchBar, _React$Component);

  var _super = (0, _createSuper2["default"])(SearchBar);

  function SearchBar() {
    var _this;

    (0, _classCallCheck2["default"])(this, SearchBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._captureInputRef = function (ref) {
      _this._input = ref;
      var inputRef = _this.props.inputRef;
      inputRef && inputRef(ref);
    };

    _this._onContainerPress = function () {
      _this._input && _this._input.focus();
    };

    _this._onInputSubmit = function (event) {
      var onInputSubmit = _this.props.onInputSubmit;
      onInputSubmit && onInputSubmit(normalizeSearchText(event.nativeEvent.text));
    };

    _this._renderSpinner = function () {
      return /*#__PURE__*/React.createElement(SpinnerContainer, null, /*#__PURE__*/React.createElement(_reactNative.ActivityIndicator, {
        animating: _this.props.isLoading
      }));
    };

    return _this;
  }

  (0, _createClass2["default"])(SearchBar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          disabled = _this$props.disabled,
          onInputChange = _this$props.onInputChange,
          searchText = _this$props.searchText,
          style = _this$props.style;
      return /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        activeOpacity: 1,
        onPress: this._onContainerPress
      }, /*#__PURE__*/React.createElement(Container, {
        pointerEvents: "none",
        style: style,
        testID: "select-searchbar-container"
      }, /*#__PURE__*/React.createElement(InnerContainer, null, /*#__PURE__*/React.createElement(IconContainer, null, /*#__PURE__*/React.createElement(IconText, null, "\uD83D\uDD0D")), disabled ? /*#__PURE__*/React.createElement(SearchText, null, searchText) : /*#__PURE__*/React.createElement(_FontContext["default"].Consumer, null, function (_ref) {
        var fontFamily = _ref.fontFamily;
        return /*#__PURE__*/React.createElement(StyledTextInput, {
          autoCorrect: false,
          editable: !disabled,
          ref: _this2._captureInputRef,
          onChangeText: onInputChange,
          onSubmitEditing: _this2._onInputSubmit,
          returnKeyLabel: "Search",
          returnKeyType: "search",
          showUnderline: false,
          value: searchText,
          testID: "select-searchbar-textinput",
          $fontFamily: fontFamily
        });
      }), this._renderSpinner())));
    }
  }]);
  return SearchBar;
}(React.Component);

SearchBar.defaultProps = {
  disabled: false,
  isLoading: false
};
var _default = SearchBar;
exports["default"] = _default;

var Container = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__Container",
  componentId: "aktd7j-0"
})(["background-color:#eee;padding:6px;padding-top:5px;"]);

var InnerContainer = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__InnerContainer",
  componentId: "aktd7j-1"
})(["flex-direction:row;align-items:center;background-color:#fff;height:31px;border-width:0;border-color:#ddd;border-radius:15px;"]);

var IconContainer = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__IconContainer",
  componentId: "aktd7j-2"
})(["justify-content:center;background-color:transparent;position:absolute;top:0;bottom:0;left:15px;"]);

var IconText = _styledComponents["default"].Text.withConfig({
  displayName: "SearchBar__IconText",
  componentId: "aktd7j-3"
})([""]);

var SearchText = (0, _styledComponents["default"])(_Text["default"]).attrs(function (props) {
  return {
    numberOfLines: 1
  };
}).withConfig({
  displayName: "SearchBar__SearchText",
  componentId: "aktd7j-4"
})(["margin-left:34px;margin-right:3px;"]);

var SpinnerContainer = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__SpinnerContainer",
  componentId: "aktd7j-5"
})(["padding-horizontal:10px;"]);

var StyledTextInput = _styledComponents["default"].TextInput.withConfig({
  displayName: "SearchBar__StyledTextInput",
  componentId: "aktd7j-6"
})(["flex:1;font-family:", ";font-size:14px;height:28px;margin-top:2px;margin-bottom:1px;margin-left:38px;"], function (props) {
  return props.$fontFamily;
});