"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Popup = _interopRequireDefault(require("../../../internals/Picker.native/Popup"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _Menu = _interopRequireDefault(require("./Menu"));

var _SearchBar = _interopRequireDefault(require("./SearchBar"));

var _SelectedOption = _interopRequireDefault(require("./SelectedOption"));

var _StyledComponents = require("./StyledComponents");

var Select = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Select, _React$Component);

  var _super = (0, _createSuper2["default"])(Select);

  function Select() {
    var _this;

    (0, _classCallCheck2["default"])(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      var onBlur = _this.props.onBlur;

      _this._setPopupVisible(false);

      onBlur && onBlur();
    };

    _this.focus = function () {
      _this._openPicker();
    };

    _this.state = {
      inputValue: '',
      isOpen: false
    };

    _this._addValue = function (option) {
      var selectedOptions = _this._getSelectedOptions();

      _this._setValue(selectedOptions.concat(option));
    };

    _this._captureSearchInput = function (ref) {
      _this._searchInput = ref;
    };

    _this._blurSearchInput = function () {
      _this._searchInput && _this._searchInput.blur();
    };

    _this._clearValue = function () {
      _this._setValue([]);
    };

    _this._filterOptions = function (excludeOptions) {
      var _this$props = _this.props,
          filterOption = _this$props.filterOption,
          labelKey = _this$props.labelKey,
          valueKey = _this$props.valueKey;

      var filterValue = _this.state.inputValue.toLowerCase();

      var options = _this.props.options || [];
      var excludeValues;
      if (excludeOptions) excludeValues = excludeOptions.map(function (i) {
        return i[valueKey];
      });
      return options.filter(function (option) {
        if (excludeValues && excludeValues.indexOf(option[valueKey]) > -1) return false;
        if (filterOption) return filterOption(option, filterValue);
        if (!filterValue) return true;
        var labelTest = String(option[labelKey]).toLowerCase();
        return labelTest.indexOf(filterValue) >= 0;
      });
    };

    _this._getOptionFromValue = function (value) {
      var _this$props2 = _this.props,
          options = _this$props2.options,
          valueKey = _this$props2.valueKey;
      return Select._findOption(options, valueKey, value);
    };

    _this._getOptionLabel = function (option) {
      return option[_this.props.labelKey];
    };

    _this._getSelectedOptions = function () {
      var value = _this.props.value;
      var valueArray;

      if (Array.isArray(value)) {
        valueArray = value;
      } else {
        valueArray = [value];
      }

      return valueArray.map(_this._getOptionFromValue).filter(Boolean);
    };

    _this._getSelectState = function () {
      var _this$props3 = _this.props,
          clearable = _this$props3.clearable,
          isLoading = _this$props3.isLoading,
          multi = _this$props3.multi,
          readOnly = _this$props3.readOnly,
          searchable = _this$props3.searchable;

      var selectedOptions = _this._getSelectedOptions();

      var visibleOptions = _this._filterOptions();

      return {
        hasValue: selectedOptions.length > 0,
        isMulti: multi,
        isSingle: !multi,
        isClearable: clearable,
        isDisabled: readOnly,
        isLoading: isLoading,
        isOpen: _this.state.isOpen,
        isSearchable: searchable,
        selectedOptions: selectedOptions,
        visibleOptions: visibleOptions
      };
    };

    _this._onCancel = function () {
      _this.blur();
    };

    _this._onSearchBarInputChange = function (inputValue) {
      var onInputChange = _this.props.onInputChange;

      if (onInputChange) {
        onInputChange(inputValue, true);
      }

      _this.setState({
        inputValue: inputValue
      });
    };

    _this._openPicker = function () {
      var _this$props4 = _this.props,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly;
      if (readOnly) return;

      _this._setPopupVisible(true);

      onFocus && onFocus();
    };

    _this._selectOption = function (option) {
      if (_this.props.multi) {
        _this._addValue(option);
      } else {
        _this._setValue([option]);
      }
    };

    _this._setPopupVisible = function (visible) {
      _this.setState({
        isOpen: visible
      });
    };

    _this._setValue = function (options) {
      var _this$props5 = _this.props,
          multi = _this$props5.multi,
          onValueChange = _this$props5.onValueChange,
          valueKey = _this$props5.valueKey;

      if (!multi) {
        _this.blur();
      }

      if (onValueChange) {
        var valueArray = options.map(function (option) {
          return option[valueKey];
        });

        var _value = multi ? valueArray : valueArray.length > 0 ? valueArray[0] : null;

        onValueChange(_value);
      }
    };

    _this._toggleOption = function (option) {
      var valueKey = _this.props.valueKey;

      var selectedOptions = _this._getSelectedOptions();

      if (selectedOptions.find(function (op) {
        return op[valueKey] === option[valueKey];
      })) {
        _this._setValue(selectedOptions.filter(function (op) {
          return op[valueKey] !== option[valueKey];
        }));
      } else {
        _this._selectOption(option);
      }
    };

    _this._renderClear = function () {
      var _this$props6 = _this.props,
          clearable = _this$props6.clearable,
          clearAllText = _this$props6.clearAllText,
          clearValueText = _this$props6.clearValueText,
          isLoading = _this$props6.isLoading,
          multi = _this$props6.multi,
          readOnly = _this$props6.readOnly,
          value = _this$props6.value;

      if (!clearable || value === undefined || value === null || multi && !value.length || readOnly || isLoading) {
        return null;
      }

      var label = multi ? clearAllText : clearValueText;
      return /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        onPress: _this._clearValue
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupText, null, label));
    };

    _this._renderConfirmButton = function () {
      if (!_this.props.multi) return null;
      return /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        onPress: _this.blur
      }, /*#__PURE__*/React.createElement(_StyledComponents.OKText, null, "OK"));
    };

    _this._renderDropdownIcon = function () {
      var renderDropdownIcon = _this.props.renderDropdownIcon;
      return renderDropdownIcon ? renderDropdownIcon() : /*#__PURE__*/React.createElement(_Icon["default"], {
        name: "arrow-drop-down",
        style: {
          marginLeft: 10,
          fontSize: 16
        }
      });
    };

    _this._renderMenu = function (options, selectedOptions) {
      var _this$props7 = _this.props,
          labelKey = _this$props7.labelKey,
          multi = _this$props7.multi,
          noResultsText = _this$props7.noResultsText,
          onDropdownEndReached = _this$props7.onDropdownEndReached,
          onDropdownEndReachedThreshold = _this$props7.onDropdownEndReachedThreshold,
          renderOption = _this$props7.renderOption,
          valueKey = _this$props7.valueKey;
      var body = null;

      if (options.length > 0) {
        var handleSelect = multi ? _this._toggleOption : _this._selectOption;
        body = /*#__PURE__*/React.createElement(_Menu["default"], {
          labelKey: labelKey,
          onEndReached: onDropdownEndReached,
          onEndReachedThreshold: onDropdownEndReachedThreshold,
          onItemSelect: handleSelect,
          options: options,
          renderOption: renderOption,
          selectedOptions: selectedOptions,
          valueKey: valueKey
        });
      } else if (noResultsText) {
        body = /*#__PURE__*/React.createElement(_StyledComponents.ListEmptyContainer, null, /*#__PURE__*/React.createElement(_StyledComponents.PopupText, null, noResultsText));
      }

      return /*#__PURE__*/React.createElement(_StyledComponents.ListContainer, null, body);
    };

    _this._renderPopup = function (options, selectedOptions) {
      var searchable = _this.props.searchable;
      var popupHeight = searchable ? 359 : 259;
      return /*#__PURE__*/React.createElement(_Popup["default"], {
        height: popupHeight,
        onRequestClose: _this._onCancel,
        show: _this.state.isOpen,
        testID: "select-popup-container"
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupTouchableContainer, {
        activeOpacity: 1,
        onPress: _this._blurSearchInput
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupContentContainer, null, /*#__PURE__*/React.createElement(_StyledComponents.PopupTopBar, null, /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        onPress: _this._onCancel
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupText, null, "Cancel")), /*#__PURE__*/React.createElement(_reactNative.View, {
        style: {
          flex: 1
        }
      }), _this._renderClear(), _this._renderConfirmButton()), _this._renderSearchBar(), _this._renderMenu(options, selectedOptions))));
    };

    _this._renderSearchBar = function () {
      if (!_this.props.searchable) return null;
      return /*#__PURE__*/React.createElement(_SearchBar["default"], {
        inputRef: _this._captureSearchInput,
        isLoading: _this.props.isLoading,
        onInputChange: _this._onSearchBarInputChange,
        searchText: _this.state.inputValue
      });
    };

    _this._renderSelectedValue = function (selectedOptions) {
      var _this$props8 = _this.props,
          labelKey = _this$props8.labelKey,
          multi = _this$props8.multi,
          placeholder = _this$props8.placeholder,
          valueKey = _this$props8.valueKey;

      if (selectedOptions.length === 0) {
        return /*#__PURE__*/React.createElement(_StyledComponents.Placeholder, null, placeholder);
      }

      if (multi) {
        return selectedOptions.map(function (option) {
          return /*#__PURE__*/React.createElement(_SelectedOption["default"], {
            key: "value-".concat(option[valueKey]),
            labelKey: labelKey,
            option: option,
            style: {
              marginRight: 8
            }
          });
        });
      }

      var option = selectedOptions[0];
      return /*#__PURE__*/React.createElement(_SelectedOption["default"], {
        labelKey: labelKey,
        option: option
      });
    };

    return _this;
  }

  (0, _createClass2["default"])(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props9 = this.props,
          accessibilityLabel = _this$props9.accessibilityLabel,
          style = _this$props9.style,
          testID = _this$props9.testID;

      var selectState = this._getSelectState();

      var selectedOptions = selectState.selectedOptions,
          visibleOptions = selectState.visibleOptions;
      var styleProps = {
        style: style
      };
      return /*#__PURE__*/React.createElement(_StyledComponents.Container, Object.assign({}, styleProps, {
        accessibilityLabel: accessibilityLabel,
        onPress: this.focus,
        testID: testID
      }), /*#__PURE__*/React.createElement(_StyledComponents.Control, null, /*#__PURE__*/React.createElement(_StyledComponents.MultiValueWrapper, null, this._renderSelectedValue(selectedOptions)), this._renderDropdownIcon(), this._renderPopup(visibleOptions, selectedOptions)));
    }
  }]);
  return Select;
}(React.Component);

Select.defaultProps = {
  autoFocus: false,
  clearable: true,
  clearAllText: 'Clear all',
  clearValueText: 'Clear value',
  isLoading: false,
  labelKey: 'label',
  multi: false,
  noResultsText: 'No results found',
  placeholder: '',
  readOnly: false,
  searchable: true,
  valueKey: 'value'
};

Select._findOption = function (options, valueKey, value) {
  var valueType = typeof value;
  if (valueType !== 'string' && valueType !== 'number') return null;
  if (!options) return null;

  for (var i = 0; i < options.length; i++) {
    if (options[i][valueKey] === value) return options[i];
  }

  return null;
};

var _default = Select;
exports["default"] = _default;