"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _Style = require("../../../apis/Style");

var _FlatList = _interopRequireDefault(require("../../../primitives/FlatList"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _OptionContainer = _interopRequireDefault(require("./OptionContainer"));

var _SearchBar = _interopRequireDefault(require("./SearchBar"));

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  opacity: ", ";\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  align-items: center;\n  flex-direction: row;\n  height: ", "px;\n  padding: 0 5px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  flex: 1;\n  ", ";\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  border-radius: inherit;\n  max-height: 198px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var ROW_HEIGHT = 35;

var _defaultGetItemLayout = function _defaultGetItemLayout(item, index) {
  return {
    length: ROW_HEIGHT,
    offset: ROW_HEIGHT * index,
    index: index
  };
};

function Menu(_ref) {
  var focusedOption = _ref.focusedOption,
      focusedOptionRef = _ref.focusedOptionRef,
      getItemLayout = _ref.getItemLayout,
      isSearchable = _ref.isSearchable,
      listRef = _ref.listRef,
      labelKey = _ref.labelKey,
      noResults = _ref.noResults,
      onEndReached = _ref.onEndReached,
      onEndReachedThreshold = _ref.onEndReachedThreshold,
      onInputBlur = _ref.onInputBlur,
      onInputChange = _ref.onInputChange,
      onItemFocus = _ref.onItemFocus,
      onItemSelect = _ref.onItemSelect,
      options = _ref.options,
      renderOption = _ref.renderOption,
      searchText = _ref.searchText,
      selectedOptions = _ref.selectedOptions,
      testID = _ref.testID,
      valueKey = _ref.valueKey;

  var extraData = _react["default"].useMemo(function () {
    return {
      focusedOption: focusedOption,
      selectedOptions: selectedOptions
    };
  }, [focusedOption, selectedOptions]);

  var _defaultRenderOption = function _defaultRenderOption(_ref2) {
    var option = _ref2.option,
        isSelected = _ref2.isSelected;
    return /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Label, {
      numberOfLines: 2,
      $isDisabled: option.disabled
    }, option[labelKey]), /*#__PURE__*/_react["default"].createElement(SelectedIcon, {
      name: "check",
      $show: isSelected
    }));
  };

  var _keyExtractor = function _keyExtractor(option) {
    return option[valueKey];
  };

  var _renderItem = function _renderItem(_ref3) {
    var option = _ref3.item,
        index = _ref3.index;
    var finalRenderOption = renderOption || _defaultRenderOption;
    var isFocused = option === focusedOption;
    var isSelected = selectedOptions.indexOf(option) > -1;
    return /*#__PURE__*/_react["default"].createElement(_OptionContainer["default"], {
      innerRef: function innerRef(ref) {
        return focusedOptionRef === null || focusedOptionRef === void 0 ? void 0 : focusedOptionRef(ref, isFocused);
      },
      isDisabled: option.disabled,
      index: index,
      isFocused: isFocused,
      isSelected: isSelected,
      onFocus: onItemFocus,
      onSelect: onItemSelect,
      option: option
    }, finalRenderOption({
      option: option,
      index: index,
      isSelected: isSelected
    }));
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, isSearchable ? /*#__PURE__*/_react["default"].createElement(_SearchBar["default"], {
    autoFocus: true,
    onInputBlur: onInputBlur,
    onInputChange: onInputChange,
    searchText: searchText
  }) : null, options.length > 0 ? /*#__PURE__*/_react["default"].createElement(StyledFlatList, {
    data: options,
    extraData: extraData,
    getItemLayout: getItemLayout || _defaultGetItemLayout,
    ref: listRef,
    keyExtractor: _keyExtractor,
    onEndReached: onEndReached,
    onEndReachedThreshold: onEndReachedThreshold,
    renderItem: _renderItem,
    testID: "".concat(testID, "-list")
  }) : noResults);
}

var _default = Menu;
exports["default"] = _default;
var StyledFlatList = (0, _Style.styled)(_FlatList["default"])(_templateObject());
var Label = (0, _Style.styled)(_Text["default"])(_templateObject2(), function (_ref4) {
  var $isDisabled = _ref4.$isDisabled;
  return $isDisabled && "\n    color: #ccc;\n  ";
});
var Row = (0, _Style.styled)(_View["default"])(_templateObject3(), ROW_HEIGHT);
var SelectedIcon = (0, _Style.styled)(_Icon["default"])(_templateObject4(), function (props) {
  return props.$show ? '1' : '0';
});