"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireDefault(require("react"));

var _Style = require("../../../apis/Style");

var _ViewBase = require("../../../internals/web/ViewBase");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  background-color: #fff;\n  cursor: pointer;\n\n  ", " ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var blockEvent = function blockEvent(event) {
  event.preventDefault();
  event.stopPropagation();
};

var OptionContainer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(OptionContainer, _React$Component);

  var _super = (0, _createSuper2["default"])(OptionContainer);

  function OptionContainer() {
    var _this;

    (0, _classCallCheck2["default"])(this, OptionContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this._dragging = void 0;

    _this._onClick = function (event) {
      event.preventDefault();
      event.stopPropagation();
      var _this$props = _this.props,
          index = _this$props.index,
          onSelect = _this$props.onSelect,
          option = _this$props.option;
      onSelect(option, event, index);
    };

    _this._onFocus = function (event) {
      var _this$props2 = _this.props,
          index = _this$props2.index,
          isFocused = _this$props2.isFocused,
          onFocus = _this$props2.onFocus,
          option = _this$props2.option;

      if (!isFocused && onFocus) {
        onFocus(option, event, index);
      }
    };

    _this._onMouseEnter = function (event) {
      _this._onFocus(event);
    };

    _this._onMouseMove = function (event) {
      _this._onFocus(event);
    };

    _this._onTouchEnd = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return;

      _this._onClick(event);
    };

    _this._onTouchMove = function () {
      // Set a flag that the view is being dragged
      _this._dragging = true;
    };

    _this._onTouchStart = function () {
      // Set a flag that the view is not being dragged
      _this._dragging = false;
    };

    return _this;
  }

  (0, _createClass2["default"])(OptionContainer, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          children = _this$props3.children,
          innerRef = _this$props3.innerRef,
          isDisabled = _this$props3.isDisabled,
          isFocused = _this$props3.isFocused;
      return isDisabled ? /*#__PURE__*/_react["default"].createElement(Container, {
        $isDisabled: isDisabled,
        onMouseDown: blockEvent,
        onClick: blockEvent
      }, children) : /*#__PURE__*/_react["default"].createElement(Container, {
        ref: innerRef,
        $isFocused: isFocused,
        onClick: this._onClick,
        onMouseEnter: this._onMouseEnter,
        onMouseMove: this._onMouseMove,
        onTouchEnd: this._onTouchEnd,
        onTouchStart: this._onTouchStart,
        onTouchMove: this._onTouchMove,
        role: "option"
      }, children);
    }
  }]);
  return OptionContainer;
}(_react["default"].Component);

var _default = OptionContainer;
exports["default"] = _default;
var Container = (0, _Style.styled)(_ViewBase.DivViewBase)(_templateObject(), function (props) {
  return props.$isFocused && "\n    background-color: #f9f9f9;\n  ";
}, function (props) {
  return props.$isDisabled && "\n    color: #ccc;\n    cursor: default;\n  ";
});