"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = SearchBar;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ViewBase = require("../../../internals/web/ViewBase");

var _ActivityIndicator = _interopRequireDefault(require("../../../primitives/ActivityIndicator"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _TextInput = _interopRequireDefault(require("../../../primitives/TextInput"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Icon = _interopRequireDefault(require("../../Icon"));

function SearchBar(_ref) {
  var autoFocus = _ref.autoFocus,
      className = _ref.className,
      disabled = _ref.disabled,
      isLoading = _ref.isLoading,
      onInputBlur = _ref.onInputBlur,
      onInputChange = _ref.onInputChange,
      searchText = _ref.searchText,
      style = _ref.style;

  var inputRef = _react["default"].useRef(null);

  var handleContainerPress = function handleContainerPress() {
    var _inputRef$current;

    (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.focus();
  };

  return /*#__PURE__*/_react["default"].createElement(Container, {
    className: className,
    onClick: handleContainerPress,
    style: style,
    testID: "select-searchbar-container"
  }, /*#__PURE__*/_react["default"].createElement(InnerContainer, null, /*#__PURE__*/_react["default"].createElement(IconContainer, null, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
    name: "search"
  })), disabled ? /*#__PURE__*/_react["default"].createElement(SearchText, null, searchText) : /*#__PURE__*/_react["default"].createElement(StyledTextInput, {
    ref: inputRef,
    autoFocus: autoFocus,
    onBlur: onInputBlur,
    onValueChange: onInputChange,
    readOnly: disabled,
    testID: "select-searchbar-textinput",
    value: searchText
  }), /*#__PURE__*/_react["default"].createElement(SpinnerContainer, null, /*#__PURE__*/_react["default"].createElement(_ActivityIndicator["default"], {
    animating: isLoading !== null && isLoading !== void 0 ? isLoading : false
  }))));
}

var Container = (0, _styledComponents["default"])(_ViewBase.DivViewBase).withConfig({
  displayName: "SearchBar__Container",
  componentId: "sc-1yo43dz-0"
})(["flex:none;background-color:#eee;padding:6px;"]);
var InnerContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "SearchBar__InnerContainer",
  componentId: "sc-1yo43dz-1"
})(["flex-direction:row;background-color:#fff;height:28px;border-width:0;border-radius:15px;"]);
var IconContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "SearchBar__IconContainer",
  componentId: "sc-1yo43dz-2"
})(["align-items:center;justify-content:center;background-color:transparent;position:absolute;top:0;bottom:0;left:8px;"]);
var SearchText = (0, _styledComponents["default"])(_Text["default"]).attrs({
  numberOfLines: 1
}).withConfig({
  displayName: "SearchBar__SearchText",
  componentId: "sc-1yo43dz-3"
})(["margin-left:32px;"]);
var SpinnerContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "SearchBar__SpinnerContainer",
  componentId: "sc-1yo43dz-4"
})(["align-items:center;justify-content:center;padding:0 10px;"]);
var StyledTextInput = (0, _styledComponents["default"])(_TextInput["default"]).withConfig({
  displayName: "SearchBar__StyledTextInput",
  componentId: "sc-1yo43dz-5"
})(["flex:1;font-size:14px;margin-left:32px;"]);