"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AriaOnly = exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var SelectedOption = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SelectedOption, _React$Component);

  var _super = (0, _createSuper2["default"])(SelectedOption);

  function SelectedOption() {
    var _this;

    (0, _classCallCheck2["default"])(this, SelectedOption);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._onRemoveButtonClick = function (event) {
      event.preventDefault();
      event.stopPropagation();
      var _this$props = _this.props,
          onRemove = _this$props.onRemove,
          option = _this$props.option;
      onRemove && onRemove(option);
    };

    _this._onRemoveButtonTouchEnd = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return; // Fire the mouse events

      _this._onRemoveButtonClick(event);
    };

    _this._onRemoveButtonTouchMove = function () {
      // Set a flag that the view is being dragged
      _this._dragging = true;
    };

    _this._onRemoveButtonTouchStart = function () {
      // Set a flag that the view is not being dragged
      _this._dragging = false;
    };

    _this._renderLabel = function () {
      var _this$props2 = _this.props,
          labelKey = _this$props2.labelKey,
          onRemove = _this$props2.onRemove,
          option = _this$props2.option,
          props = (0, _objectWithoutProperties2["default"])(_this$props2, ["labelKey", "onRemove", "option"]);
      return /*#__PURE__*/React.createElement(Label, Object.assign({}, props, {
        "aria-selected": "true",
        role: "option"
      }), option[labelKey], !!props.isMulti && /*#__PURE__*/React.createElement(AriaOnly, null, "\xA0"));
    };

    _this._renderRemoveIcon = function () {
      var _this$props3 = _this.props,
          isDisabled = _this$props3.isDisabled,
          onRemove = _this$props3.onRemove;
      if (isDisabled || !onRemove) return null;
      return /*#__PURE__*/React.createElement(Icon, {
        "aria-hidden": "true",
        onClick: _this._onRemoveButtonClick,
        onTouchEnd: _this._onRemoveButtonTouchEnd,
        onTouchMove: _this._onRemoveButtonTouchMove,
        onTouchStart: _this._onRemoveButtonTouchStart
      }, "\xD7");
    };

    return _this;
  }

  (0, _createClass2["default"])(SelectedOption, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          labelKey = _this$props4.labelKey,
          onRemove = _this$props4.onRemove,
          option = _this$props4.option,
          props = (0, _objectWithoutProperties2["default"])(_this$props4, ["labelKey", "onRemove", "option"]);
      return /*#__PURE__*/React.createElement(Container, props, this._renderRemoveIcon(), this._renderLabel());
    }
  }]);
  return SelectedOption;
}(React.Component);

var _default = SelectedOption;
exports["default"] = _default;

var AriaOnly = _styledComponents["default"].span.withConfig({
  displayName: "SelectedOption__AriaOnly",
  componentId: "zd1pql-0"
})(["display:inline-block;height:1px;width:1px;margin:-1px;clip:rect(0,0,0,0);overflow:hidden;float:left;"]);

exports.AriaOnly = AriaOnly;

var Container = _styledComponents["default"].div.withConfig({
  displayName: "SelectedOption__Container",
  componentId: "zd1pql-1"
})(["&:not(:first-of-type){margin-left:5px;}", ";"], function (_ref) {
  var isDisabled = _ref.isDisabled,
      isMulti = _ref.isMulti;
  return isMulti ? "\n    background-color: #ebf5ff;\n    border-radius: 2px;\n    border: 1px solid #c2e0ff;\n    color: #007eff;\n    display: inline-block;\n    font-size: 0.85em;\n    vertical-align: top;\n    ".concat(isDisabled && "\n      background-color: #fcfcfc;\n      border: 1px solid #e3e3e3;\n      color: #333;\n    ", "\n  ") : "\n    display: flex;\n    align-items: center;\n    bottom: 0;\n    color: #aaa;\n    left: 0;\n    position: absolute;\n    right: 0;\n    top: 0;\n    max-width: 100%;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    white-space: nowrap;\n  ";
});

var Icon = _styledComponents["default"].span.withConfig({
  displayName: "SelectedOption__Icon",
  componentId: "zd1pql-2"
})(["display:inline-block;cursor:pointer;border-bottom-left-radius:2px;border-top-left-radius:2px;border-right:1px solid #c2e0ff;padding:0 5px;&:focus &:hover{background-color:#d8eafd;color:#0071e6;}&:active{:active{background-color:#c2e0ff;}}"]);

var Label = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "SelectedOption__Label",
  componentId: "zd1pql-3"
})(["", ";"], function (_ref2) {
  var isMulti = _ref2.isMulti;
  return isMulti && "\n    display: inline-block;\n    vertical-align: middle;\n    border-bottom-right-radius: 2px;\n    border-top-right-radius: 2px;\n    cursor: default;\n    padding: 0 5px;\n  ";
});