"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Picker;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../apis/Style");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _styles = require("./styles");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  min-width: 50px;\n  height: 40px;\n  padding-left: 10px;\n  padding-right: 10px;\n  background-color: ", ";\n  border-top-left-radius: ", ";\n  border-top-right-radius: ", ";\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  margin-bottom: 1px;\n  align-items: center;\n  justify-content: center;\n  ", ";\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  flex-direction: column;\n  max-width: 400px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function Picker(_ref) {
  var options = _ref.options,
      _ref$selected = _ref.selected,
      selected = _ref$selected === void 0 ? [] : _ref$selected,
      onChange = _ref.onChange,
      optionToString = _ref.optionToString,
      _ref$multi = _ref.multi,
      multi = _ref$multi === void 0 ? false : _ref$multi,
      testID = _ref.testID;
  return /*#__PURE__*/React.createElement(StyledView, {
    testID: testID
  }, options.map(function (option, i) {
    var isSelected;
    if (multi) isSelected = selected.includes(option);else isSelected = selected === option;
    return /*#__PURE__*/React.createElement(TabButton, {
      key: i,
      $isSelected: isSelected,
      $position: getPosition(i, options.length),
      onPress: function onPress() {
        var output;

        if (!multi) {
          output = option;
        } else {
          if (selected.includes(option)) {
            output = selected.filter(function (item) {
              return item !== option;
            });
          } else {
            output = [].concat((0, _toConsumableArray2["default"])(selected), [option]);
          }
        }

        onChange(output);
      }
    }, /*#__PURE__*/React.createElement(_Text["default"], {
      key: option.value
    }, optionToString(option)));
  }));
}

var StyledView = (0, _Style.styled)(_View["default"])(_templateObject());
var TabButton = (0, _Style.styled)(_TouchableView["default"])(_templateObject2(), function (_ref2) {
  var $isSelected = _ref2.$isSelected;
  return $isSelected ? 'orange' : '#f8f8f8';
}, function (_ref3) {
  var $position = _ref3.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref4) {
  var $position = _ref4.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref5) {
  var $position = _ref5.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (_ref6) {
  var $position = _ref6.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (props) {
  return (0, _styles.ButtonCSS)(props);
});

var getPosition = function getPosition(pos, length) {
  if (pos === 0) {
    return 'first';
  }

  if (pos === length - 1) {
    return 'last';
  }

  return 'middle';
};