"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Picker = _interopRequireDefault(require("../../../internals/Picker.native"));

var _constants = require("../constants");

var _StyledComponents = require("../StyledComponents");

var getDefaultTime = function getDefaultTime() {
  return (0, _moment["default"])().startOf('minute').toDate();
};

var TimePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TimePicker, _React$Component);

  var _super = (0, _createSuper2["default"])(TimePicker);

  (0, _createClass2["default"])(TimePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }]);

  function TimePicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, TimePicker);
    _this = _super.call(this, props);

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._onTimeChange = function (time) {
      _this.setState({
        selectedTime: time
      });
    };

    _this._renderPopup = function () {
      return /*#__PURE__*/React.createElement(_reactNative.DatePickerIOS, {
        date: _this.state.selectedTime || getDefaultTime(),
        mode: "time",
        onDateChange: _this._onTimeChange
      });
    };

    _this._renderValue = function () {
      var _this$props = _this.props,
          displayFormat = _this$props.displayFormat,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          valueFormat = _this$props.valueFormat;
      var time = (0, _moment["default"])(value || '', valueFormat);
      var timeStr = time.isValid() ? time.format(displayFormat) : '';

      if (!timeStr) {
        return /*#__PURE__*/React.createElement(_StyledComponents.PlaceholderText, null, placeholder);
      }

      return /*#__PURE__*/React.createElement(_StyledComponents.ValueText, null, timeStr);
    };

    _this._selectTime = function (time) {
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          valueFormat = _this$props2.valueFormat;

      _this.blur();

      _this.setState({
        selectedTime: time
      });

      if (onValueChange) {
        var timeMoment = (0, _moment["default"])(time);

        if (timeMoment.isValid()) {
          onValueChange(timeMoment.format(valueFormat));
        } else {
          onValueChange(null);
        }
      }
    };

    var _this$props3 = _this.props,
        _value = _this$props3.value,
        _valueFormat = _this$props3.valueFormat;
    var initialTime = (0, _moment["default"])(_value || '', _valueFormat);

    if (!initialTime.isValid()) {
      initialTime = (0, _moment["default"])();
    }

    _this.state = {
      selectedTime: initialTime.toDate()
    };
    return _this;
  }

  (0, _createClass2["default"])(TimePicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          accessibilityLabel = _this$props4.accessibilityLabel,
          autoFocus = _this$props4.autoFocus,
          clearable = _this$props4.clearable,
          clearValueText = _this$props4.clearValueText,
          onBlur = _this$props4.onBlur,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly,
          renderDropdownIcon = _this$props4.renderDropdownIcon,
          style = _this$props4.style,
          testID = _this$props4.testID;
      var styleProps = {
        style: style
      };
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onClear: function onClear() {
          return _this2._selectTime(null);
        },
        onConfirm: function onConfirm() {
          return _this2._selectTime(_this2.state.selectedTime || getDefaultTime());
        },
        onFocus: onFocus,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopup: this._renderPopup,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/React.createElement(_Picker["default"], Object.assign({}, styleProps, props));
    }
  }]);
  return TimePicker;
}(React.Component);

TimePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: _constants.DEFAULT_TIME_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: _constants.DEFAULT_TIME_VALUE_FORMAT
};
TimePicker.displayName = 'TimePicker';
var _default = TimePicker;
exports["default"] = _default;