"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _constants = require("../constants");

/* eslint-disable react/no-array-index-key */
var CELL_HEIGHT = 25;

var WheelPicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(WheelPicker, _React$Component);

  var _super = (0, _createSuper2["default"])(WheelPicker);

  function WheelPicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, WheelPicker);
    _this = _super.call(this, props);
    _this._wheelRefs = [];

    _this._submit = function () {
      var onSelect = _this.props.onSelect;
      var _this$state = _this.state,
          selectedHour = _this$state.selectedHour,
          selectedMinute = _this$state.selectedMinute,
          selectedMeridiem = _this$state.selectedMeridiem;
      var hour = selectedMeridiem === 'AM' ? selectedHour : selectedHour + 12;
      var value = (0, _moment["default"])({
        hour: hour,
        minute: selectedMinute
      });
      onSelect && onSelect(value);
    };

    _this._renderWheels = function () {
      return /*#__PURE__*/React.createElement(WheelsContainer, null, /*#__PURE__*/React.createElement(Wheel, {
        ref: function ref(_ref) {
          _this._wheelRefs[0] = _ref;
        }
      }, _constants.HOURS.map(function (hour, hourNum) {
        var isSelected = hourNum === _this.state.selectedHour;
        return /*#__PURE__*/React.createElement(Cell, {
          key: hour,
          onClick: function onClick() {
            return _this.setState({
              selectedHour: hourNum
            });
          },
          $isSelected: isSelected
        }, /*#__PURE__*/React.createElement(CellText, {
          $isSelected: isSelected
        }, hour));
      })), /*#__PURE__*/React.createElement(Wheel, {
        ref: function ref(_ref2) {
          _this._wheelRefs[1] = _ref2;
        }
      }, _constants.MINUTES.map(function (minute, minuteNum) {
        var isSelected = minuteNum === _this.state.selectedMinute;
        return /*#__PURE__*/React.createElement(Cell, {
          key: minuteNum,
          onClick: function onClick() {
            return _this.setState({
              selectedMinute: minuteNum
            });
          },
          $isSelected: isSelected
        }, /*#__PURE__*/React.createElement(CellText, {
          $isSelected: isSelected
        }, minute));
      })), /*#__PURE__*/React.createElement(Wheel, {
        ref: function ref(_ref3) {
          _this._wheelRefs[2] = _ref3;
        }
      }, _constants.MERIDIEMS.map(function (meridiem) {
        var isSelected = meridiem === _this.state.selectedMeridiem;
        return /*#__PURE__*/React.createElement(Cell, {
          key: meridiem,
          onClick: function onClick() {
            return _this.setState({
              selectedMeridiem: meridiem
            });
          },
          $isSelected: isSelected
        }, /*#__PURE__*/React.createElement(CellText, {
          $isSelected: isSelected
        }, meridiem));
      })));
    };

    _this._renderFooter = function () {
      return /*#__PURE__*/React.createElement(FooterContainer, null, /*#__PURE__*/React.createElement(DoneButton, {
        onClick: _this._submit
      }, /*#__PURE__*/React.createElement(_Text["default"], null, "Done")));
    };

    var initialTime = _this.props.initialTime;

    if (!initialTime || !initialTime.isValid()) {
      initialTime = (0, _moment["default"])();
    }

    _this.state = {
      selectedHour: initialTime.hour() % 12,
      selectedMinute: initialTime.minute(),
      selectedMeridiem: initialTime.format('A')
    };
    return _this;
  }

  (0, _createClass2["default"])(WheelPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$state2 = this.state,
          selectedHour = _this$state2.selectedHour,
          selectedMinute = _this$state2.selectedMinute;

      if (selectedHour > 4 && this._wheelRefs[0]) {
        this._wheelRefs[0].scrollTop = CELL_HEIGHT * (selectedHour - 4);
      }

      if (selectedMinute > 4 && this._wheelRefs[1]) {
        this._wheelRefs[1].scrollTop = CELL_HEIGHT * (selectedMinute - 4);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(Container, {
        $displayRight: this.props.displayRight
      }, this._renderWheels(), this._renderFooter());
    }
  }]);
  return WheelPicker;
}(React.Component);

var _default = WheelPicker;
exports["default"] = _default;

var Container = _styledComponents["default"].div.attrs(function (props) {
  return {
    'data-component': 'wheel-picker'
  };
}).withConfig({
  displayName: "WheelPicker__Container",
  componentId: "sc-18gpl15-0"
})(["", ""], function (_ref4) {
  var $displayRight = _ref4.$displayRight;
  return $displayRight && "\n    position: absolute;\n    border: 1px solid #ccc;\n    right: ".concat($displayRight, "px;\n    background-color: #fff;\n  ");
});

var Cell = _styledComponents["default"].div.withConfig({
  displayName: "WheelPicker__Cell",
  componentId: "sc-18gpl15-1"
})(["align-items:center;cursor:pointer;display:flex;height:", "px;justify-content:center;padding:0 25px;", ";"], CELL_HEIGHT, function (_ref5) {
  var $isSelected = _ref5.$isSelected;
  return $isSelected ? "\n    background-color: #445;\n  " : "\n    &:hover {\n      background-color: #eee;\n    }\n  ";
});

var CellText = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "WheelPicker__CellText",
  componentId: "sc-18gpl15-2"
})(["", ";"], function (_ref6) {
  var $isSelected = _ref6.$isSelected;
  return $isSelected && "color: white;";
});

var DoneButton = _styledComponents["default"].button.attrs(function (props) {
  return {
    tabIndex: -1,
    type: 'button'
  };
}).withConfig({
  displayName: "WheelPicker__DoneButton",
  componentId: "sc-18gpl15-3"
})(["background:none;border:none;cursor:pointer;height:100%;width:100%;&:hover{background-color:#eee;}"]);

var FooterContainer = _styledComponents["default"].div.withConfig({
  displayName: "WheelPicker__FooterContainer",
  componentId: "sc-18gpl15-4"
})(["border-top:1px solid #ddd;height:25px;"]);

var Wheel = _styledComponents["default"].div.withConfig({
  displayName: "WheelPicker__Wheel",
  componentId: "sc-18gpl15-5"
})(["overflow-y:auto;width:70px;&:not(:last-child){border-right:1px solid #ddd;}"]);

var WheelsContainer = _styledComponents["default"].div.withConfig({
  displayName: "WheelPicker__WheelsContainer",
  componentId: "sc-18gpl15-6"
})(["display:flex;height:", "px;"], 9 * CELL_HEIGHT);