"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _warning = _interopRequireDefault(require("warning"));

var _Form = require("../../../primitives/Form");

var _OldSelect = _interopRequireDefault(require("../../OldSelect"));

var _Select = _interopRequireDefault(require("../../Select"));

var _wrappers = require("../wrappers");

function SelectField(props, ref) {
  var passedFieldState = props.fieldState,
      label = props.label,
      modal = props.modal,
      options = props.options,
      required = props.required,
      reserveErrorSpace = props.reserveErrorSpace,
      testID = props.testID,
      validate = props.validate,
      rest = (0, _objectWithoutProperties2["default"])(props, ["fieldState", "label", "modal", "options", "required", "reserveErrorSpace", "testID", "validate"]);
  (0, _warning["default"])(!(validate && !reserveErrorSpace), "Prop \"reserveErrorSpace\" is set to false while \"validate\" is supplied. You will not see the validation error.");
  var SelectComponent = modal ? _Select["default"] : _OldSelect["default"];

  var inputRef = _react["default"].useRef(null);

  var focusInput = _react["default"].useCallback(function () {
    return inputRef.current && inputRef.current.focus();
  }, []);

  var blurInput = _react["default"].useCallback(function () {
    return inputRef.current && inputRef.current.blur();
  }, []);

  _react["default"].useImperativeHandle(ref, function () {
    return {
      focus: focusInput,
      blur: blurInput
    };
  });

  var _useFieldState = (0, _Form.useFieldState)(props),
      fieldState = _useFieldState.fieldState,
      onBlur = _useFieldState.onBlur,
      onFocus = _useFieldState.onFocus,
      onValueChange = _useFieldState.onValueChange;

  return /*#__PURE__*/_react["default"].createElement(_wrappers.InputFieldWrapper, {
    fieldState: fieldState,
    focusInput: focusInput,
    label: label,
    onValueChange: onValueChange,
    required: required,
    reserveErrorSpace: reserveErrorSpace,
    testID: testID
  }, /*#__PURE__*/_react["default"].createElement(SelectComponent, Object.assign({}, rest, {
    ref: inputRef,
    onBlur: onBlur,
    onFocus: onFocus,
    onValueChange: onValueChange,
    options: options,
    value: fieldState.value
  })));
}

var ForwardRefSelectField = _react["default"].forwardRef(SelectField); // Cast to NamedExoticComponent to remove `propTypes` which causes problems when
// type checking.


var _default = ForwardRefSelectField;
exports["default"] = _default;