"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Paragraph = _interopRequireDefault(require("../../Paragraph"));

var _FieldContainer = _interopRequireDefault(require("../FieldContainer"));

var _FieldLabel = _interopRequireDefault(require("../FieldLabel"));

var _StyledComponents = require("../StyledComponents");

var _TouchToFocusArea = _interopRequireDefault(require("../TouchToFocusArea"));

function InputFieldWrapper(props) {
  var children = props.children,
      className = props.className,
      fieldState = props.fieldState,
      focusInput = props.focusInput,
      label = props.label,
      required = props.required,
      style = props.style,
      testID = props.testID,
      _props$reserveErrorSp = props.reserveErrorSpace,
      reserveErrorSpace = _props$reserveErrorSp === void 0 ? true : _props$reserveErrorSp;
  return /*#__PURE__*/_react["default"].createElement(_FieldContainer["default"], {
    className: className,
    style: style,
    testID: testID
  }, /*#__PURE__*/_react["default"].createElement(_TouchToFocusArea["default"], {
    onPress: focusInput,
    testID: testID && "".concat(testID, "-control")
  }, label && /*#__PURE__*/_react["default"].createElement(_StyledComponents.FieldLabelContainer, null, /*#__PURE__*/_react["default"].createElement(_FieldLabel["default"], {
    testID: testID && "".concat(testID, "-label")
  }, label), required && /*#__PURE__*/_react["default"].createElement(_StyledComponents.FieldLabelAsterisk, null)), /*#__PURE__*/_react["default"].createElement(_StyledComponents.FieldInputContainer, {
    $hasError: fieldState.touched && fieldState.error
  }, children)), reserveErrorSpace && /*#__PURE__*/_react["default"].createElement(_Paragraph["default"], {
    type: "error"
  }, fieldState.touched ? fieldState.error : ''));
}

var _default = InputFieldWrapper;
exports["default"] = _default;