"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var Popup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Popup, _React$Component);

  var _super = (0, _createSuper2["default"])(Popup);

  function Popup() {
    var _this;

    (0, _classCallCheck2["default"])(this, Popup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      animatedHeight: new _reactNative.Animated.Value(0),
      showModal: !!_this.props.show
    };

    _this._setModalVisible = function (visible) {
      _this.setState({
        showModal: visible
      }); // slide animation


      if (visible) {
        _reactNative.Animated.timing(_this.state.animatedHeight, {
          toValue: _this.props.height,
          duration: 300
        }).start();
      } else {
        _this.setState({
          animatedHeight: new _reactNative.Animated.Value(0)
        });
      }
    };

    return _this;
  }

  (0, _createClass2["default"])(Popup, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.show !== this.props.show) {
        this._setModalVisible(!!nextProps.show);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(_reactNative.Modal, {
        onRequestClose: this.props.onRequestClose,
        transparent: true,
        visible: this.state.showModal
      }, /*#__PURE__*/React.createElement(_reactNative.TouchableHighlight, {
        activeOpacity: 1,
        onPress: this.props.onRequestClose,
        style: styles.modalBackdrop,
        underlayColor: "#00000075"
      }, /*#__PURE__*/React.createElement(_reactNative.TouchableHighlight, {
        underlayColor: "#fff",
        testID: this.props.testID
      }, /*#__PURE__*/React.createElement(_reactNative.Animated.View, {
        style: [styles.container, {
          height: this.state.animatedHeight
        }]
      }, this.props.children))));
    }
  }]);
  return Popup;
}(React.Component);

Popup.defaultProps = {
  height: 259,
  show: false
};

var styles = _reactNative.StyleSheet.create({
  modalBackdrop: {
    backgroundColor: '#00000075',
    flex: 1,
    justifyContent: 'flex-end'
  },
  container: {
    backgroundColor: '#fff',
    height: 0,
    overflow: 'hidden'
  }
});

var _default = Popup;
exports["default"] = _default;