"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Popup = _interopRequireDefault(require("./Popup"));

var _StyledComponents = require("./StyledComponents");

var PickerNative = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(PickerNative, _React$Component);

  var _super = (0, _createSuper2["default"])(PickerNative);

  function PickerNative() {
    var _this;

    (0, _classCallCheck2["default"])(this, PickerNative);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      var onBlur = _this.props.onBlur;
      onBlur && onBlur();

      _this.setState({
        isOpen: false
      });
    };

    _this.focus = function () {
      var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          readOnly = _this$props.readOnly;
      if (readOnly) return;
      onFocus && onFocus();

      _this.setState({
        isOpen: true
      });
    };

    _this.state = {
      isOpen: false
    };

    _this._onControlPress = function (event) {
      if (_this.props.readOnly) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault();

      _this.focus();
    };

    _this._renderClear = function () {
      var _this$props2 = _this.props,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          onClear = _this$props2.onClear,
          readOnly = _this$props2.readOnly;

      if (!clearable || readOnly) {
        return null;
      }

      return /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        onPress: onClear
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupText, null, clearValueText));
    };

    _this._renderConfirmButton = function () {
      return /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        onPress: _this.props.onConfirm
      }, /*#__PURE__*/React.createElement(_StyledComponents.OKText, null, "Done"));
    };

    _this._renderDropdownIcon = function () {
      var renderDropdownIcon = _this.props.renderDropdownIcon;
      return renderDropdownIcon ? renderDropdownIcon(_this.state) : /*#__PURE__*/React.createElement(_StyledComponents.IconTextContainer, null, /*#__PURE__*/React.createElement(_StyledComponents.IconText, null, "\u2304"));
    };

    _this._renderPopup = function () {
      var renderPopup = _this.props.renderPopup;
      return /*#__PURE__*/React.createElement(_Popup["default"], {
        onRequestClose: _this.blur,
        show: _this.state.isOpen
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupContentContainer, null, /*#__PURE__*/React.createElement(_StyledComponents.PopupTopBar, null, /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, {
        onPress: _this.blur
      }, /*#__PURE__*/React.createElement(_StyledComponents.PopupText, null, "Cancel")), /*#__PURE__*/React.createElement(_reactNative.View, {
        style: {
          flex: 1
        }
      }), _this._renderClear(), _this._renderConfirmButton()), renderPopup && renderPopup()));
    };

    _this._renderValue = function () {
      var renderValue = _this.props.renderValue;
      return /*#__PURE__*/React.createElement(_StyledComponents.ValueContainer, null, renderValue && renderValue(_this.state));
    };

    return _this;
  }

  (0, _createClass2["default"])(PickerNative, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          accessibilityLabel = _this$props3.accessibilityLabel,
          readOnly = _this$props3.readOnly,
          style = _this$props3.style,
          testID = _this$props3.testID;
      var styleProps = {
        style: style
      };
      return /*#__PURE__*/React.createElement(_StyledComponents.Container, Object.assign({}, styleProps, {
        accessibilityLabel: accessibilityLabel,
        testID: testID
      }), /*#__PURE__*/React.createElement(_StyledComponents.Control, {
        onPress: this._onControlPress
      }, this._renderValue(), this._renderDropdownIcon()), _reactNative.Platform.OS === 'ios' && !readOnly && this._renderPopup());
    }
  }]);
  return PickerNative;
}(React.Component);

PickerNative.defaultProps = {
  autoFocus: false,
  clearable: true,
  clearValueText: 'Clear value',
  readOnly: false
};
var _default = PickerNative;
exports["default"] = _default;