"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _FontContext = _interopRequireDefault(require("../../primitives/Font/FontContext"));

function TextAreaBase(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      nativeRef = _ref.nativeRef,
      testID = _ref.testID,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["accessibilityLabel", "nativeRef", "testID"]);
  return /*#__PURE__*/_react["default"].createElement(_FontContext["default"].Consumer, null, function (_ref2) {
    var fontFamily = _ref2.fontFamily,
        fontSize = _ref2.fontSize;
    return /*#__PURE__*/_react["default"].createElement(StyledTextArea, Object.assign({}, props, {
      "aria-label": accessibilityLabel,
      "data-testid": testID,
      ref: nativeRef,
      $fontFamilyValue: fontFamily,
      $fontSizeValue: fontSize
    }));
  });
}

var _default = _react["default"].forwardRef(function (props, ref) {
  return /*#__PURE__*/_react["default"].createElement(TextAreaBase, Object.assign({}, props, {
    nativeRef: ref
  }));
});

exports["default"] = _default;

var StyledTextArea = _styledComponents["default"].textarea.withConfig({
  displayName: "TextAreaBase__StyledTextArea",
  componentId: "jf73dt-0"
})(["appearance:none;background-color:transparent;border-color:black;border-radius:0;border-width:0;box-sizing:border-box;font-family:", ";font-size:", "px;padding:0;outline:none;resize:none;"], function (props) {
  return props.$fontFamilyValue;
}, function (props) {
  return props.$fontSizeValue;
});