"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createTouchableViewBase = createTouchableViewBase;
exports.DivTouchableViewBase = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _tooltip = _interopRequireDefault(require("@reach/tooltip"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styles = require("./styles");

var _ViewBase = require("./ViewBase");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n:root {\n  --reach-tooltip: 1;\n}\n\n[data-reach-tooltip] {\n  z-index: 1;\n  pointer-events: none;\n  position: absolute;\n  padding: 0.5em 1em;\n  box-shadow: 2px 2px 10px hsla(0, 0%, 0%, 0.1);\n  white-space: nowrap;\n  font-size: 85%;\n  background: hsla(0, 0%, 0%, 0.75);\n  color: white;\n  border: none;\n  borderRadius: 4px;\n}\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var GlobalStyle = (0, _styledComponents.createGlobalStyle)(_templateObject());

function createTouchableViewBase(component) {
  var ViewBase = (0, _ViewBase.createViewBase)(component);
  var StyledViewBase = (0, _styledComponents["default"])(ViewBase).withConfig({
    displayName: "TouchableViewBase__StyledViewBase",
    componentId: "cz83lq-0"
  })(["", ";"], _styles.buttonDefaultStyle);
  var StyledViewBaseWithForwardRef = React.forwardRef(function (props, ref) {
    return /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, props, {
      ref: ref
    }));
  }); // $FlowFixMe: forwardRef not supported yet

  return React.forwardRef(function (props, ref) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, props.tooltip ? /*#__PURE__*/React.createElement(_tooltip["default"], {
      label: props.tooltip
    }, /*#__PURE__*/React.createElement(StyledViewBaseWithForwardRef, Object.assign({}, props, {
      ref: ref
    }))) : /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, props, {
      ref: ref
    })), /*#__PURE__*/React.createElement(GlobalStyle, null));
  });
}

var DivTouchableViewBase = createTouchableViewBase('div');
exports.DivTouchableViewBase = DivTouchableViewBase;