"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createViewBase = createViewBase;
exports.DivViewBase = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _uniqueId = _interopRequireDefault(require("lodash/uniqueId"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _unstableNativeDependencies = require("react-dom/unstable-native-dependencies");

var _UIManager = _interopRequireDefault(require("react-native-web/dist/cjs/exports/UIManager"));

var _ResponderEventPlugin = _interopRequireDefault(require("react-native-web/dist/cjs/modules/ResponderEventPlugin"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _styles = require("./styles");

(0, _unstableNativeDependencies.injectEventPluginsByName)({
  ResponderEventPlugin: _ResponderEventPlugin["default"]
});

function createViewBase(component) {
  var ViewBase = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(ViewBase, _React$Component);

    var _super = (0, _createSuper2["default"])(ViewBase);

    function ViewBase() {
      var _this;

      (0, _classCallCheck2["default"])(this, ViewBase);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));
      _this._isMounted = void 0;
      _this._lastLayout = {};
      _this._onLayoutId = (0, _uniqueId["default"])('onLayout');
      _this._resizeDetector = void 0;

      _this._onLayout = function () {
        var onLayout = _this.props.onLayout;

        if (onLayout) {
          _UIManager["default"].measure(_reactDom["default"].findDOMNode((0, _assertThisInitialized2["default"])(_this)), function (x, y, width, height) {
            if (!_this._isMounted) return;

            if (_this._lastLayout.x !== x || _this._lastLayout.y !== y || _this._lastLayout.width !== width || _this._lastLayout.height !== height) {
              _this._lastLayout = {
                x: x,
                y: y,
                width: width,
                height: height
              };
              var nativeEvent = {
                layout: {
                  x: x,
                  y: y,
                  width: width,
                  height: height
                }
              };
              onLayout({
                nativeEvent: nativeEvent,
                timeStamp: Date.now()
              });
            }
          });
        }
      };

      return _this;
    }

    (0, _createClass2["default"])(ViewBase, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this._isMounted = true; // Defer adding resize event handler to window to support server-side
        // rendering

        this._resizeDetector = require('./detectResize');

        this._resizeDetector.register(this._onLayoutId, this);

        this._onLayout();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this._onLayout();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this._isMounted = false;

        this._resizeDetector.unregister(this._onLayoutId);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            accessibilityLabel = _this$props.accessibilityLabel,
            children = _this$props.children,
            nativeRef = _this$props.nativeRef,
            onLayout = _this$props.onLayout,
            testID = _this$props.testID,
            rest = (0, _objectWithoutProperties2["default"])(_this$props, ["accessibilityLabel", "children", "nativeRef", "onLayout", "testID"]);
        var props = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, rest), {}, {
          'aria-label': accessibilityLabel,
          'data-testid': testID,
          ref: nativeRef
        });
        return _react["default"].createElement(component, props, children);
      }
    }]);
    return ViewBase;
  }(_react["default"].Component); // Manually pass on responder event handlers since styled-components filters them out


  var StyledViewBase = (0, _styledComponents["default"])(ViewBase).attrs(function (props) {
    return {
      onResponderGrant: props.onResponderGrant,
      onResponderMove: props.onResponderMove,
      onResponderRelease: props.onResponderRelease,
      onResponderTerminate: props.onResponderTerminate,
      onResponderTerminationRequest: props.onResponderTerminationRequest,
      onStartShouldSetResponder: props.onStartShouldSetResponder
    };
  }).withConfig({
    displayName: "ViewBase__StyledViewBase",
    componentId: "sc-66ckm-0"
  })(["", ";"], _styles.flex);
  return _react["default"].forwardRef(function (props, ref) {
    return /*#__PURE__*/_react["default"].createElement(StyledViewBase, Object.assign({}, props, {
      nativeRef: ref
    }));
  });
}

var DivViewBase = createViewBase('div');
exports.DivViewBase = DivViewBase;