"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _Style = require("../../../apis/Style");

var _Text = _interopRequireDefault(require("../../Text"));

var _ = _interopRequireDefault(require(".."));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n    font-size: 20px;\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

test('texts without a parent Font should use default font', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/_react["default"].createElement(_Text["default"], {
    testID: "test"
  }, "hello")),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('texts rendered inside Font should inherit font', function () {
  var _render2 = (0, _reactTestingLibrary.render)( /*#__PURE__*/_react["default"].createElement(_["default"], {
    fontFamily: "Times",
    fontSize: 10
  }, /*#__PURE__*/_react["default"].createElement(_Text["default"], {
    testID: "test"
  }, "hello"))),
      getByTestId = _render2.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: Times;\n      font-size: 10px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('texts can override inherited font', function () {
  var StyledText = (0, _Style.styled)(_Text["default"])(_templateObject());

  var _render3 = (0, _reactTestingLibrary.render)( /*#__PURE__*/_react["default"].createElement(_["default"], {
    fontFamily: "Times",
    fontSize: 10
  }, /*#__PURE__*/_react["default"].createElement(StyledText, {
    testID: "test"
  }, "hello"))),
      getByTestId = _render3.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n.c0 {\n  box-sizing: border-box;\n  color: #191E26;\n  display: inline;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  font-family: Times;\n  font-size: 10px;\n  position: relative;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n  -ms-hyphens: auto;\n  cursor: inherit;\n}\n\n.c1 {\n  font-size: 20px;\n}\n\n<div\n  class=\"c0 c1\"\n  data-testid=\"test\"\n  data-text-as-pseudo-element=\"hello\"\n/>\n");
});