"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Field = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _react = _interopRequireDefault(require("react"));

var _useFieldState2 = require("./useFieldState");

function InternalField(props) {
  var component = props.component,
      inputRef = props.inputRef,
      label = props.label,
      name = props.name,
      inputProps = props.props,
      testID = props.testID,
      validate = props.validate;

  var _useFieldState = (0, _useFieldState2.useFieldState)({
    name: name,
    validate: validate
  }),
      fieldState = _useFieldState.fieldState,
      onBlur = _useFieldState.onBlur,
      onFocus = _useFieldState.onFocus,
      onValueChange = _useFieldState.onValueChange;

  return _react["default"].createElement(component, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    fieldState: fieldState,
    label: label,
    testID: testID || "".concat(name, "-field"),
    value: fieldState.value
  }, inputProps), {}, {
    onBlur: onBlur,
    onFocus: onFocus,
    onValueChange: onValueChange,
    ref: inputRef
  }));
}

var Field = _react["default"].forwardRef(function (props, ref) {
  return (
    /*#__PURE__*/
    // @ts-ignore
    _react["default"].createElement(InternalField, Object.assign({}, props, {
      inputRef: ref,
      props: props.props || {}
    }))
  );
});

exports.Field = Field;