"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireDefault(require("react"));

var _FlexForm = _interopRequireDefault(require("../../../internals/web/FlexForm"));

var _Field = require("../Field");

var _FormState = require("../FormState");

var _SubmitButton = _interopRequireDefault(require("../SubmitButton"));

var Form = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Form, _React$Component);

  var _super = (0, _createSuper2["default"])(Form);

  function Form() {
    (0, _classCallCheck2["default"])(this, Form);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Form, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          initialValues = _this$props.initialValues,
          onSubmit = _this$props.onSubmit,
          style = _this$props.style,
          testID = _this$props.testID;
      return /*#__PURE__*/_react["default"].createElement(_FormState.FormState, {
        initialValues: initialValues
      }, function (formState) {
        var fieldErrors = formState.fieldErrors,
            values = formState.values,
            actions = formState.actions;

        var handleFormSubmit = function handleFormSubmit(e) {
          e.preventDefault();
          e.stopPropagation();
          actions.touchAll();

          if (Object.keys(fieldErrors).length === 0) {
            actions.submit(function () {
              return onSubmit && onSubmit(values);
            });
          }
        };

        var formBody = typeof children === 'function' ? children(formState) : children;
        return /*#__PURE__*/_react["default"].createElement(_FlexForm["default"], {
          className: className,
          "data-testid": testID,
          onSubmit: handleFormSubmit,
          style: style
        }, formBody);
      });
    }
  }]);
  return Form;
}(_react["default"].Component);

Form.Field = _Field.Field;
Form.SubmissionError = _FormState.SubmissionError;
Form.SubmitButton = _SubmitButton["default"];
var _default = Form;
exports["default"] = _default;