"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormStateProvider = FormStateProvider;
exports.useFormState = useFormState;
exports.useFormStateStrict = useFormStateStrict;

var _invariant = _interopRequireDefault(require("invariant"));

var _react = _interopRequireDefault(require("react"));

var Context = _react["default"].createContext(undefined);

function FormStateProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
    value: value
  }, children);
}

function useFormState() {
  return _react["default"].useContext(Context);
}

function useFormStateStrict() {
  var formState = useFormState();
  (0, _invariant["default"])(formState, "Please put the component inside a Form or ModalForm.");
  return formState;
}