"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _defaultProps = _interopRequireDefault(require("../defaultProps"));

var Overlay = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Overlay, _React$Component);

  var _super = (0, _createSuper2["default"])(Overlay);

  function Overlay() {
    var _this;

    (0, _classCallCheck2["default"])(this, Overlay);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._onPress = function (event) {
      if (event.target === event.currentTarget) {
        var onPress = _this.props.onPress;
        onPress && onPress();
      }
    };

    return _this;
  }

  (0, _createClass2["default"])(Overlay, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          onLayout = _this$props.onLayout,
          testID = _this$props.testID,
          visible = _this$props.visible;
      return /*#__PURE__*/React.createElement(_reactNative["default"].Modal, {
        animationType: "none",
        onRequestClose: this._onPress,
        transparent: true,
        visible: visible
      }, /*#__PURE__*/React.createElement(OverlayContainer, {
        onLayout: onLayout,
        onPress: this._onPress,
        testID: testID || 'overlay-container',
        $color: color
      }, children));
    }
  }]);
  return Overlay;
}(React.Component);

Overlay.defaultProps = _defaultProps["default"];
var _default = Overlay;
exports["default"] = _default;

var OverlayContainer = _styledComponents["default"].TouchableOpacity.attrs({
  activeOpacity: 1
}).withConfig({
  displayName: "Overlay__OverlayContainer",
  componentId: "sc-15b87ud-0"
})(["flex:1;background-color:", ";"], function (_ref) {
  var $color = _ref.$color;
  return $color || 'rgba(178, 178, 178, 0.8)';
});