"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _exenv = _interopRequireDefault(require("exenv"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _defaultProps = _interopRequireDefault(require("../defaultProps"));

var _CloseButton = _interopRequireDefault(require("./CloseButton"));

var _OverlayContainer = _interopRequireDefault(require("./OverlayContainer"));

var Overlay = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Overlay, _React$Component);

  var _super = (0, _createSuper2["default"])(Overlay);

  function Overlay(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Overlay);
    _this = _super.call(this, props);
    _this._parent = document.body;

    _this._onClick = function (event) {
      if (event.target === event.currentTarget) {
        var onPress = _this.props.onPress;
        onPress && onPress();
      }
    };

    if (_exenv["default"].canUseDOM) {
      _this._el = document.createElement('div');
    }

    return _this;
  }

  (0, _createClass2["default"])(Overlay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this._parent || !this._el) return;

      this._parent.appendChild(this._el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!this._parent || !this._el) return;

      this._parent.removeChild(this._el);
    }
  }, {
    key: "render",
    value: function render() {
      if (!this._el) {
        return null;
      }

      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          onLayout = _this$props.onLayout,
          visible = _this$props.visible,
          _this$props$showClose = _this$props.showCloseButton,
          showCloseButton = _this$props$showClose === void 0 ? false : _this$props$showClose,
          closeButtonStyle = _this$props.closeButtonStyle,
          onClose = _this$props.onClose,
          testID = _this$props.testID;
      var portalChild = visible ? /*#__PURE__*/React.createElement(_OverlayContainer["default"], {
        onClick: this._onClick,
        onLayout: onLayout,
        testID: testID || 'overlay-container',
        $color: color
      }, children, showCloseButton && /*#__PURE__*/React.createElement(_CloseButton["default"], {
        onPress: onClose,
        closeButtonStyle: closeButtonStyle
      })) : null;
      return _reactDom["default"].createPortal(portalChild, this._el);
    }
  }]);
  return Overlay;
}(React.Component);

Overlay.defaultProps = _defaultProps["default"];
var _default = Overlay;
exports["default"] = _default;