"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Pdf;

var _react = _interopRequireDefault(require("react"));

var _reactNativePdf = _interopRequireDefault(require("react-native-pdf"));

var _pdfmake = require("../helpers/pdfmake");

var _useUri = require("../helpers/useUri");

var _validateSource = require("../helpers/validateSource");

var _Loading = _interopRequireDefault(require("./Loading"));

// start loading fonts as soon as this module gets imported
(0, _pdfmake.initializePdfFonts)(); // TODO: add controls

function Pdf(props) {
  var accessibilityLabel = props.accessibilityLabel,
      source = props.source,
      style = props.style,
      testID = props.testID;
  (0, _validateSource.validateSource)(source);
  var uri = (0, _useUri.useUri)(source);

  if (!uri) {
    return /*#__PURE__*/_react["default"].createElement(_Loading["default"], props);
  }

  var nativePdfProps = {
    accessibilityLabel: accessibilityLabel,
    source: {
      uri: uri
    },
    style: style,
    testID: testID
  };
  return /*#__PURE__*/_react["default"].createElement(_reactNativePdf["default"], nativePdfProps);
}

Pdf.createDataUrlFromDefinition = _pdfmake.createDataUrlFromDefinition;