"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useUri = useUri;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _pdfmake = require("./pdfmake");

function useUri(source) {
  var uri = source.uri;
  var definition = source.definition;
  var fonts = source.fonts;
  var tableLayouts = source.tableLayouts;

  var _React$useState = _react["default"].useState(),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      uriFromDefinition = _React$useState2[0],
      setUriFromDefinition = _React$useState2[1];

  _react["default"].useEffect(function () {
    var cancelled = false;

    if (definition) {
      (0, _pdfmake.createDataUrlFromDefinition)({
        definition: definition,
        fonts: fonts,
        tableLayouts: tableLayouts
      }).then(function (dataUri) {
        if (cancelled) return;
        setUriFromDefinition(dataUri);
      });
    }

    return function () {
      cancelled = true;
    };
  }, [definition, fonts, tableLayouts, uri]);

  return uri || uriFromDefinition;
}