"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var ScrollView = React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      horizontal = _ref.horizontal,
      onLayout = _ref.onLayout,
      style = _ref.style,
      contentContainerStyle = _ref.contentContainerStyle,
      testID = _ref.testID,
      onScroll = _ref.onScroll,
      onContentSizeChange = _ref.onContentSizeChange,
      _ref$scrollEventThrot = _ref.scrollEventThrottle,
      scrollEventThrottle = _ref$scrollEventThrot === void 0 ? 16 : _ref$scrollEventThrot;
  var scrollableNodeRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      scrollTo: function scrollTo(options) {
        var _scrollableNodeRef$cu;

        (_scrollableNodeRef$cu = scrollableNodeRef.current) === null || _scrollableNodeRef$cu === void 0 ? void 0 : _scrollableNodeRef$cu.scrollTo(options);
      },
      scrollToEnd: function scrollToEnd() {
        var _scrollableNodeRef$cu2;

        (_scrollableNodeRef$cu2 = scrollableNodeRef.current) === null || _scrollableNodeRef$cu2 === void 0 ? void 0 : _scrollableNodeRef$cu2.scrollToEnd();
      }
    };
  });
  var props = {
    accessibilityLabel: accessibilityLabel,
    horizontal: horizontal,
    keyboardDismissMode: 'on-drag',
    keyboardShouldPersistTaps: 'handled',
    onContentSizeChange: onContentSizeChange,
    onLayout: onLayout,
    onScroll: onScroll,
    scrollEventThrottle: scrollEventThrottle,
    style: style,
    contentContainerStyle: contentContainerStyle,
    testID: testID
  };
  return /*#__PURE__*/React.createElement(_reactNative["default"].ScrollView, Object.assign({}, props, {
    ref: scrollableNodeRef
  }), children);
});
var _default = ScrollView;
exports["default"] = _default;