"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var Switch = React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onValueChange = _ref.onValueChange,
      style = _ref.style,
      testID = _ref.testID,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? false : _ref$value;
  var containerRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      focus: function focus() {
        var _containerRef$current;

        return (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.focus();
      },
      blur: function blur() {
        var _containerRef$current2;

        return (_containerRef$current2 = containerRef.current) === null || _containerRef$current2 === void 0 ? void 0 : _containerRef$current2.blur();
      }
    };
  });
  var toggleHandleLeft = React.useRef(new _reactNative.Animated.Value(2));

  var _React$useState = React.useState(value),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      prevValue = _React$useState2[0],
      setPrevValue = _React$useState2[1];

  React.useEffect(function () {
    if (!!value !== !!prevValue) {
      _reactNative.Animated.timing(toggleHandleLeft.current, {
        toValue: value ? 26 : 2,
        duration: 200
      }).start();

      setPrevValue(value);
    }
  }, [value, prevValue]);

  var _onBlur = function _onBlur(_event) {
    onBlur === null || onBlur === void 0 ? void 0 : onBlur({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onFocus = function _onFocus(_event) {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onKeyPress = function _onKeyPress(event) {
    var ENTER = 13;
    var SPACE = 32;

    if (event.which === ENTER || event.which === SPACE) {
      event.preventDefault();
      event.stopPropagation();

      _toggle();
    }
  };

  var _toggle = function _toggle() {
    return !disabled && (onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(!value));
  };

  var props = {
    accessibilityLabel: accessibilityLabel,
    onPress: _toggle,
    onBlur: _onBlur,
    onFocus: _onFocus,
    onKeyPress: _onKeyPress,
    testID: testID
  };
  var styleProps = {
    style: style,
    $value: !!value
  };
  return /*#__PURE__*/React.createElement(SwitchContainer, Object.assign({
    ref: containerRef
  }, props, styleProps), /*#__PURE__*/React.createElement(_reactNative.Animated.View, {
    style: [styles.handle, {
      left: toggleHandleLeft.current
    }]
  }));
});
var _default = Switch;
exports["default"] = _default;
var SwitchContainer = (0, _styledComponents["default"])(_reactNative.TouchableOpacity).attrs(function (_props) {
  return {
    activeOpacity: 1
  };
}).withConfig({
  displayName: "Switch__SwitchContainer",
  componentId: "ugqey1-0"
})(["flex:none;flex-direction:row;background-color:", ";border-radius:12px;height:24px;width:48px;"], function (_ref2) {
  var $value = _ref2.$value;
  return $value ? '#FF7800' : '#B0ADAB';
});

var styles = _reactNative.StyleSheet.create({
  handle: {
    backgroundColor: 'white',
    borderRadius: 10,
    height: 20,
    width: 20,
    position: 'absolute',
    top: 2,
    bottom: 2
  }
});