"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Text;

var _react = _interopRequireDefault(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var _Colors = _interopRequireDefault(require("../../../apis/Colors"));

var _FontContext = _interopRequireDefault(require("../../Font/FontContext"));

function Text(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      numberOfLines = _ref.numberOfLines,
      selectable = _ref.selectable,
      style = _ref.style,
      testID = _ref.testID;

  var _React$useContext = _react["default"].useContext(_FontContext["default"]),
      fontFamily = _React$useContext.fontFamily,
      fontSize = _React$useContext.fontSize;

  var props = {
    accessibilityLabel: accessibilityLabel,
    numberOfLines: numberOfLines,
    selectable: selectable,
    testID: testID
  };
  return /*#__PURE__*/_react["default"].createElement(_reactNative["default"].Text, Object.assign({}, props, {
    style: [styles["default"], {
      fontFamily: fontFamily,
      fontSize: fontSize
    }, style]
  }), children);
}

var styles = _reactNative["default"].StyleSheet.create({
  "default": {
    color: _Colors["default"].BLACK
  }
});