"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _invariant = _interopRequireDefault(require("fbjs/lib/invariant"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _InputBase = _interopRequireDefault(require("../../internals/web/InputBase"));

var _TextAreaBase = _interopRequireDefault(require("../../internals/web/TextAreaBase"));

var _FontContext = _interopRequireDefault(require("../Font/FontContext"));

// @ts-ignore
var TextInput = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TextInput, _React$Component);

  var _super = (0, _createSuper2["default"])(TextInput);

  function TextInput(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, TextInput);
    _this = _super.call(this, props);
    _this._input = null;

    _this._captureInputRef = function (ref) {
      _this._input = ref;
    };

    _this._createBlurEventHandler = function () {
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        return function (event) {
          onBlur({
            nativeEvent: {
              text: event.currentTarget.value
            }
          });
        };
      }

      return onBlur;
    };

    _this._createChangeEventHandler = function () {
      var onValueChange = _this.props.onValueChange;

      if (onValueChange) {
        return function (event) {
          onValueChange(event.currentTarget.value);
        };
      }

      return onValueChange;
    };

    _this._createFocusEventHandler = function () {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        return function (event) {
          onFocus({
            nativeEvent: {
              text: event.currentTarget.value
            }
          });
        };
      }

      return onFocus;
    };

    _this.state = {};
    return _this;
  }

  (0, _createClass2["default"])(TextInput, [{
    key: "blur",
    value: function blur() {
      this._input && this._input.blur();
    }
  }, {
    key: "clear",
    value: function clear() {
      if (this._input) {
        this._input.value = '';
      }
    }
  }, {
    key: "focus",
    value: function focus() {
      this._input && this._input.focus();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.autoFocus) {
        setTimeout(function () {
          return _this2.focus();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          accessibilityLabel = _this$props.accessibilityLabel,
          className = _this$props.className,
          defaultValue = _this$props.defaultValue,
          placeholder = _this$props.placeholder,
          maxLength = _this$props.maxLength,
          multiline = _this$props.multiline,
          readOnly = _this$props.readOnly,
          style = _this$props.style,
          testID = _this$props.testID,
          type = _this$props.type,
          value = _this$props.value;
      var InputComponent = multiline ? TextArea : Input;
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoComplete: 'off',
        defaultValue: defaultValue,
        dir: 'auto',
        ref: this._captureInputRef,
        maxLength: maxLength,
        onBlur: this._createBlurEventHandler(),
        onChange: this._createChangeEventHandler(),
        onFocus: this._createFocusEventHandler(),
        placeholder: placeholder,
        readOnly: readOnly,
        testID: testID,
        type: type,
        value: value || ''
      };
      return /*#__PURE__*/_react["default"].createElement(_FontContext["default"].Consumer, null, function (_ref) {
        var fontFamily = _ref.fontFamily,
            fontSize = _ref.fontSize;
        var styleProps = {
          className: className,
          multiline: multiline,
          style: style,
          $fontFamily: fontFamily,
          $fontSize: fontSize
        }; //@ts-ignore

        return /*#__PURE__*/_react["default"].createElement(InputComponent, Object.assign({}, props, styleProps));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      TextInput._checkProps(nextProps);

      return null;
    }
  }, {
    key: "_checkProps",
    value: function _checkProps(props) {
      var multiline = props.multiline,
          type = props.type;
      (0, _invariant["default"])(!(multiline && type !== 'text'), 'Only type="text" is supported for multiline TextInput');
    }
  }]);
  return TextInput;
}(_react["default"].Component);

TextInput.defaultProps = {
  autoFocus: false,
  multiline: false,
  placeholder: '',
  readOnly: false,
  type: 'text'
};
TextInput.displayName = 'TextInput';
var _default = TextInput;
exports["default"] = _default;
var Input = (0, _styledComponents["default"])(_InputBase["default"]).withConfig({
  displayName: "TextInputweb__Input",
  componentId: "sc-7svxlh-0"
})(["font-family:", ";font-size:", "px;"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
});
var TextArea = (0, _styledComponents["default"])(_TextAreaBase["default"]).attrs({
  rows: 5
}).withConfig({
  displayName: "TextInputweb__TextArea",
  componentId: "sc-7svxlh-1"
})(["font-family:", ";font-size:", "px;height:18px;padding:8px 0px;"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
});