"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _TouchEventUtils = _interopRequireDefault(require("fbjs/lib/TouchEventUtils"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _UIManager = _interopRequireDefault(require("react-native-web/dist/cjs/exports/UIManager"));

var _TouchableViewBase = require("../../internals/web/TouchableViewBase");

var _IsResponderActive, _IsKeyboardActive, _IsResponderPressingI, _IsKeyboardPressingIn, _IsLongPressingIn, _States$NOT_RESPONDER, _States$RESPONDER_ACT, _States$RESPONDER_ACT2, _States$RESPONDER_ACT3, _States$RESPONDER_ACT4, _States$KEYBOARD_ACTI, _States$KEYBOARD_ACTI2, _States$ERROR, _Transitions;

/**
 * Touchable states.
 */
var States = {
  NOT_RESPONDER: 'NOT_RESPONDER',
  // Not the responder
  RESPONDER_ACTIVE_PRESS_IN: 'RESPONDER_ACTIVE_PRESS_IN',
  // Responder, active, in the `PressRect`
  RESPONDER_ACTIVE_PRESS_OUT: 'RESPONDER_ACTIVE_PRESS_OUT',
  // Responder, active, out of `PressRect`
  RESPONDER_ACTIVE_LONG_PRESS_IN: 'RESPONDER_ACTIVE_LONG_PRESS_IN',
  // Responder, active, in the `PressRect`, after long press threshold
  RESPONDER_ACTIVE_LONG_PRESS_OUT: 'RESPONDER_ACTIVE_LONG_PRESS_OUT',
  // Responder, active, out of `PressRect`, after long press threshold
  KEYBOARD_ACTIVE_PRESS_IN: 'KEYBOARD_ACTIVE_PRESS_IN',
  KEYBOARD_ACTIVE_LONG_PRESS_IN: 'KEYBOARD_ACTIVE_LONG_PRESS_IN',
  ERROR: 'ERROR'
};

/**
 * Quick lookup map for states that are considered to be "active"
 */
var IsResponderActive = (_IsResponderActive = {}, (0, _defineProperty2["default"])(_IsResponderActive, States.RESPONDER_ACTIVE_PRESS_IN, true), (0, _defineProperty2["default"])(_IsResponderActive, States.RESPONDER_ACTIVE_PRESS_OUT, true), (0, _defineProperty2["default"])(_IsResponderActive, States.RESPONDER_ACTIVE_LONG_PRESS_IN, true), (0, _defineProperty2["default"])(_IsResponderActive, States.RESPONDER_ACTIVE_LONG_PRESS_OUT, true), _IsResponderActive);
var IsKeyboardActive = (_IsKeyboardActive = {}, (0, _defineProperty2["default"])(_IsKeyboardActive, States.KEYBOARD_ACTIVE_PRESS_IN, true), (0, _defineProperty2["default"])(_IsKeyboardActive, States.KEYBOARD_ACTIVE_LONG_PRESS_IN, true), _IsKeyboardActive);
/**
 * Quick lookup for states that are considered to be "pressing" and are
 * therefore eligible to result in a "selection" if the press stops.
 */

var IsResponderPressingIn = (_IsResponderPressingI = {}, (0, _defineProperty2["default"])(_IsResponderPressingI, States.RESPONDER_ACTIVE_PRESS_IN, true), (0, _defineProperty2["default"])(_IsResponderPressingI, States.RESPONDER_ACTIVE_LONG_PRESS_IN, true), _IsResponderPressingI);
var IsKeyboardPressingIn = (_IsKeyboardPressingIn = {}, (0, _defineProperty2["default"])(_IsKeyboardPressingIn, States.KEYBOARD_ACTIVE_PRESS_IN, true), (0, _defineProperty2["default"])(_IsKeyboardPressingIn, States.KEYBOARD_ACTIVE_LONG_PRESS_IN, true), _IsKeyboardPressingIn);
var IsPressingIn = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, IsResponderPressingIn), IsKeyboardPressingIn);
var IsLongPressingIn = (_IsLongPressingIn = {}, (0, _defineProperty2["default"])(_IsLongPressingIn, States.RESPONDER_ACTIVE_LONG_PRESS_IN, true), (0, _defineProperty2["default"])(_IsLongPressingIn, States.KEYBOARD_ACTIVE_LONG_PRESS_IN, true), _IsLongPressingIn);
/**
 * Inputs to the state machine.
 */

var Signals = {
  RESPONDER_GRANT: 'RESPONDER_GRANT',
  RESPONDER_RELEASE: 'RESPONDER_RELEASE',
  RESPONDER_TERMINATED: 'RESPONDER_TERMINATED',
  ENTER_PRESS_RECT: 'ENTER_PRESS_RECT',
  LEAVE_PRESS_RECT: 'LEAVE_PRESS_RECT',
  LONG_PRESS_DETECTED: 'LONG_PRESS_DETECTED',
  KEYBOARD_PRESS: 'KEYBOARD_PRESS',
  KEYBOARD_RELEASE: 'KEYBOARD_RELEASE'
};

/**
 * Mapping from States x Signals => States
 */
var Transitions = (_Transitions = {}, (0, _defineProperty2["default"])(_Transitions, States.NOT_RESPONDER, (_States$NOT_RESPONDER = {}, (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.RESPONDER_GRANT, States.RESPONDER_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.RESPONDER_RELEASE, States.ERROR), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.RESPONDER_TERMINATED, States.ERROR), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.ENTER_PRESS_RECT, States.ERROR), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.LEAVE_PRESS_RECT, States.ERROR), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.LONG_PRESS_DETECTED, States.ERROR), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.KEYBOARD_PRESS, States.KEYBOARD_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$NOT_RESPONDER, Signals.KEYBOARD_RELEASE, States.ERROR), _States$NOT_RESPONDER)), (0, _defineProperty2["default"])(_Transitions, States.RESPONDER_ACTIVE_PRESS_IN, (_States$RESPONDER_ACT = {}, (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.RESPONDER_GRANT, States.ERROR), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.RESPONDER_RELEASE, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.RESPONDER_TERMINATED, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.ENTER_PRESS_RECT, States.RESPONDER_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.LEAVE_PRESS_RECT, States.RESPONDER_ACTIVE_PRESS_OUT), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.LONG_PRESS_DETECTED, States.RESPONDER_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.KEYBOARD_PRESS, States.RESPONDER_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT, Signals.KEYBOARD_RELEASE, States.RESPONDER_ACTIVE_PRESS_IN), _States$RESPONDER_ACT)), (0, _defineProperty2["default"])(_Transitions, States.RESPONDER_ACTIVE_PRESS_OUT, (_States$RESPONDER_ACT2 = {}, (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.RESPONDER_GRANT, States.ERROR), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.RESPONDER_RELEASE, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.RESPONDER_TERMINATED, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.ENTER_PRESS_RECT, States.RESPONDER_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.LEAVE_PRESS_RECT, States.RESPONDER_ACTIVE_PRESS_OUT), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.LONG_PRESS_DETECTED, States.ERROR), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.KEYBOARD_PRESS, States.RESPONDER_ACTIVE_PRESS_OUT), (0, _defineProperty2["default"])(_States$RESPONDER_ACT2, Signals.KEYBOARD_RELEASE, States.RESPONDER_ACTIVE_PRESS_OUT), _States$RESPONDER_ACT2)), (0, _defineProperty2["default"])(_Transitions, States.RESPONDER_ACTIVE_LONG_PRESS_IN, (_States$RESPONDER_ACT3 = {}, (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.RESPONDER_GRANT, States.ERROR), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.RESPONDER_RELEASE, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.RESPONDER_TERMINATED, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.ENTER_PRESS_RECT, States.RESPONDER_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.LEAVE_PRESS_RECT, States.RESPONDER_ACTIVE_LONG_PRESS_OUT), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.LONG_PRESS_DETECTED, States.RESPONDER_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.KEYBOARD_PRESS, States.RESPONDER_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT3, Signals.KEYBOARD_RELEASE, States.RESPONDER_ACTIVE_LONG_PRESS_IN), _States$RESPONDER_ACT3)), (0, _defineProperty2["default"])(_Transitions, States.RESPONDER_ACTIVE_LONG_PRESS_OUT, (_States$RESPONDER_ACT4 = {}, (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.RESPONDER_GRANT, States.ERROR), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.RESPONDER_RELEASE, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.RESPONDER_TERMINATED, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.ENTER_PRESS_RECT, States.RESPONDER_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.LEAVE_PRESS_RECT, States.RESPONDER_ACTIVE_LONG_PRESS_OUT), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.LONG_PRESS_DETECTED, States.ERROR), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.KEYBOARD_PRESS, States.RESPONDER_ACTIVE_LONG_PRESS_OUT), (0, _defineProperty2["default"])(_States$RESPONDER_ACT4, Signals.KEYBOARD_RELEASE, States.RESPONDER_ACTIVE_LONG_PRESS_OUT), _States$RESPONDER_ACT4)), (0, _defineProperty2["default"])(_Transitions, States.KEYBOARD_ACTIVE_PRESS_IN, (_States$KEYBOARD_ACTI = {}, (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.RESPONDER_GRANT, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.RESPONDER_RELEASE, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.RESPONDER_TERMINATED, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.ENTER_PRESS_RECT, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.LEAVE_PRESS_RECT, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.LONG_PRESS_DETECTED, States.KEYBOARD_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.KEYBOARD_PRESS, States.KEYBOARD_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI, Signals.KEYBOARD_RELEASE, States.NOT_RESPONDER), _States$KEYBOARD_ACTI)), (0, _defineProperty2["default"])(_Transitions, States.KEYBOARD_ACTIVE_LONG_PRESS_IN, (_States$KEYBOARD_ACTI2 = {}, (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.RESPONDER_GRANT, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.RESPONDER_RELEASE, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.RESPONDER_TERMINATED, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.ENTER_PRESS_RECT, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.LEAVE_PRESS_RECT, States.ERROR), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.LONG_PRESS_DETECTED, States.KEYBOARD_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.KEYBOARD_PRESS, States.KEYBOARD_ACTIVE_LONG_PRESS_IN), (0, _defineProperty2["default"])(_States$KEYBOARD_ACTI2, Signals.KEYBOARD_RELEASE, States.NOT_RESPONDER), _States$KEYBOARD_ACTI2)), (0, _defineProperty2["default"])(_Transitions, States.ERROR, (_States$ERROR = {}, (0, _defineProperty2["default"])(_States$ERROR, Signals.RESPONDER_GRANT, States.RESPONDER_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$ERROR, Signals.RESPONDER_RELEASE, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$ERROR, Signals.RESPONDER_TERMINATED, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$ERROR, Signals.ENTER_PRESS_RECT, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$ERROR, Signals.LEAVE_PRESS_RECT, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$ERROR, Signals.LONG_PRESS_DETECTED, States.NOT_RESPONDER), (0, _defineProperty2["default"])(_States$ERROR, Signals.KEYBOARD_PRESS, States.KEYBOARD_ACTIVE_PRESS_IN), (0, _defineProperty2["default"])(_States$ERROR, Signals.KEYBOARD_RELEASE, States.NOT_RESPONDER), _States$ERROR)), _Transitions); // ==== Typical Constants for integrating into UI components ====

var HIGHLIGHT_DELAY_MS = 0;
var PRESS_EXPAND_PX = 20;
var LONG_PRESS_THRESHOLD = 500;
var LONG_PRESS_DELAY_MS = LONG_PRESS_THRESHOLD - HIGHLIGHT_DELAY_MS;
var LONG_PRESS_ALLOWED_MOVEMENT = 10;

var TouchableView = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TouchableView, _React$Component);

  var _super = (0, _createSuper2["default"])(TouchableView);

  function TouchableView() {
    var _this;

    (0, _classCallCheck2["default"])(this, TouchableView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      touchable: {
        touchState: undefined,
        responderID: null
      }
    };
    _this._activeKey = null;

    _this._cancelLongPressDelayTimeout = function () {
      _this._longPressDelayTimeout && clearTimeout(_this._longPressDelayTimeout);
      _this._longPressDelayTimeout = null;
    };

    _this._getDistanceBetweenPoints = function (aX, aY, bX, bY) {
      var deltaX = aX - bX;
      var deltaY = aY - bY;
      return Math.sqrt(deltaX * deltaX + deltaY * deltaY);
    };

    _this._getLongPressDelayMS = function () {
      var delayLongPress = _this.props.delayLongPress;
      return isNaN(delayLongPress) ? LONG_PRESS_DELAY_MS : delayLongPress;
    };

    _this._getPressRectOffset = function () {
      return {
        left: PRESS_EXPAND_PX,
        right: PRESS_EXPAND_PX,
        top: PRESS_EXPAND_PX,
        bottom: PRESS_EXPAND_PX
      };
    };

    _this._handleLongDelay = function (event) {
      _this._longPressDelayTimeout = null;
      var curState = _this.state.touchable.touchState;

      if (IsPressingIn[curState]) {
        _this._receiveSignal(Signals.LONG_PRESS_DETECTED, event);
      }
    };

    _this._handleLongPress = function () {
      var onLongPress = _this.props.onLongPress;
      onLongPress && onLongPress();
    };

    _this._handlePress = function () {
      var onPress = _this.props.onPress;
      onPress && onPress();
    };

    _this._handlePressIn = function () {
      var onPressIn = _this.props.onPressIn;
      onPressIn && onPressIn();
    };

    _this._handlePressOut = function () {
      var onPressOut = _this.props.onPressOut;
      onPressOut && onPressOut();
    };

    _this._handleQueryLayout = function (l, t, w, h, globalX, globalY) {
      // don't do anything UIManager failed to measure node
      if (!l && !t && !w && !h && !globalX && !globalY) {
        return;
      }

      _this.state.touchable.positionOnActivate = {
        left: globalX,
        top: globalY
      };
      _this.state.touchable.dimensionsOnActivate = {
        width: w,
        height: h
      };
    };

    _this._onKeyDownUp = function (event) {
      var ENTER = 13;
      var SPACE = 32;
      var type = event.type,
          which = event.which;
      var curState = _this.state.touchable.touchState;

      if ((which === ENTER || which === SPACE) && !IsResponderActive[curState]) {
        if (type === 'keydown' && _this._activeKey === null) {
          _this._activeKey = which;
          _this.state.touchable.touchState = _this.state.touchable.touchState || States.NOT_RESPONDER;

          _this._receiveSignal(Signals.KEYBOARD_PRESS);

          var longDelayMS = _this._getLongPressDelayMS();

          _this._longPressDelayTimeout = setTimeout(_this._handleLongDelay, longDelayMS);
        } else if (type === 'keyup' && which === _this._activeKey) {
          _this._activeKey = null;

          _this._receiveSignal(Signals.KEYBOARD_RELEASE);
        }

        event.stopPropagation();
        event.preventDefault();
      }
    };

    _this._onResponderGrant = function (event) {
      var dispatchID = event.currentTarget;
      _this.state.touchable.touchState = States.NOT_RESPONDER;
      _this.state.touchable.responderID = dispatchID;

      _this._receiveSignal(Signals.RESPONDER_GRANT, event);

      var longDelayMS = _this._getLongPressDelayMS();

      _this._longPressDelayTimeout = setTimeout(_this._handleLongDelay.bind((0, _assertThisInitialized2["default"])(_this), event), longDelayMS);
    };

    _this._onResponderMove = function (event) {
      // Measurement may not have returned yet.
      if (!_this.state.touchable.positionOnActivate || !_this.state.touchable.dimensionsOnActivate) {
        return;
      }

      var positionOnActivate = _this.state.touchable.positionOnActivate;
      var dimensionsOnActivate = _this.state.touchable.dimensionsOnActivate;

      var pressRectOffset = _this._getPressRectOffset();

      var pressExpandLeft = pressRectOffset.left;
      var pressExpandTop = pressRectOffset.top;
      var pressExpandRight = pressRectOffset.right;
      var pressExpandBottom = pressRectOffset.bottom;

      var touch = _TouchEventUtils["default"].extractSingleTouch(event.nativeEvent);

      var pageX = touch && touch.pageX;
      var pageY = touch && touch.pageY;

      if (_this._pressInLocation) {
        var movedDistance = _this._getDistanceBetweenPoints(pageX, pageY, _this._pressInLocation.pageX, _this._pressInLocation.pageY);

        if (movedDistance > LONG_PRESS_ALLOWED_MOVEMENT) {
          _this._cancelLongPressDelayTimeout();
        }
      }

      var isTouchWithinActive = pageX > positionOnActivate.left - pressExpandLeft && pageY > positionOnActivate.top - pressExpandTop && pageX < positionOnActivate.left + dimensionsOnActivate.width + pressExpandRight && pageY < positionOnActivate.top + dimensionsOnActivate.height + pressExpandBottom;

      if (isTouchWithinActive) {
        _this._receiveSignal(Signals.ENTER_PRESS_RECT, event);
      } else {
        _this._cancelLongPressDelayTimeout();

        _this._receiveSignal(Signals.LEAVE_PRESS_RECT, event);
      }
    };

    _this._onResponderRelease = function (event) {
      _this._receiveSignal(Signals.RESPONDER_RELEASE, event);
    };

    _this._onResponderTerminate = function (event) {
      _this._receiveSignal(Signals.RESPONDER_TERMINATED, event);
    };

    _this._onResponderTerminationRequest = function () {
      return true;
    };

    _this._onStartShouldSetResponder = function () {
      var curState = _this.state.touchable.touchState;
      return !_this.props.disabled && !IsKeyboardActive[curState];
    };

    _this._performSideEffectsForTransition = function (curState, nextState, signal, event) {
      var curIsHighlight = IsPressingIn[curState];
      var newIsHighlight = IsPressingIn[nextState];
      var isFinalSignal = signal === Signals.RESPONDER_TERMINATED || signal === Signals.RESPONDER_RELEASE || signal === Signals.KEYBOARD_RELEASE;

      if (isFinalSignal) {
        _this._cancelLongPressDelayTimeout();
      }

      if (!IsResponderActive[curState] && IsResponderActive[nextState]) {
        _this._remeasureMetricsOnActivation();
      }

      if (IsPressingIn[curState] && signal === Signals.LONG_PRESS_DETECTED) {
        _this._handleLongPress && _this._handleLongPress();
      }

      if (newIsHighlight && !curIsHighlight) {
        _this._startHighlight(event);
      } else if (!newIsHighlight && curIsHighlight) {
        _this._endHighlight();
      }

      if (IsResponderPressingIn[curState] && signal === Signals.RESPONDER_RELEASE || IsKeyboardPressingIn[curState] && signal === Signals.KEYBOARD_RELEASE) {
        var hasLongPressHandler = !!_this.props.onLongPress;
        var pressIsLongButStillCallOnPress = IsLongPressingIn[curState] && !hasLongPressHandler; // We *are* long pressing.. // But has no long handler

        var shouldInvokePress = !IsLongPressingIn[curState] || pressIsLongButStillCallOnPress;

        if (shouldInvokePress) {
          _this._handlePress();
        }
      }
    };

    _this._receiveSignal = function (signal, event) {
      var responderID = _this.state.touchable.responderID;
      var curState = _this.state.touchable.touchState;
      var nextState = Transitions[curState] && Transitions[curState][signal];

      if (!responderID && signal === Signals.RESPONDER_RELEASE) {
        return;
      }

      if (!nextState) {
        throw new Error("Unrecognized signal ".concat(signal, " or state ").concat(curState || 'unknown', " for responder ").concat(responderID));
      }

      if (nextState === States.ERROR) {
        throw new Error("Touchable cannot transition from ".concat(curState || 'unknown', " to ").concat(signal, " for responder ").concat(responderID));
      }

      if (curState !== nextState) {
        _this._performSideEffectsForTransition(curState, nextState, signal, event);

        _this.state.touchable.touchState = nextState;
      }
    };

    _this._remeasureMetricsOnActivation = function () {
      var tag = _this.state.touchable.responderID;

      if (tag == null) {
        return;
      }

      _UIManager["default"].measure(tag, _this._handleQueryLayout);
    };

    _this._savePressInLocation = function (event) {
      var touch = _TouchEventUtils["default"].extractSingleTouch(event.nativeEvent);

      var _ref = touch || {},
          pageX = _ref.pageX,
          pageY = _ref.pageY;

      _this._pressInLocation = {
        pageX: pageX,
        pageY: pageY
      };
    };

    _this._startHighlight = function (event) {
      if (event) {
        _this._savePressInLocation(event);
      } // $FlowFixMe


      if (event && event.dispatchConfig.registrationName === 'onResponderGrant') {
        _this._setOpacityTo(_this.props.activeOpacity, 0);
      } else {
        _this._setOpacityTo(_this.props.activeOpacity, 150);
      }

      _this._handlePressIn();
    };

    _this._endHighlight = function () {
      _this._setOpacityTo(1, 250);

      _this._handlePressOut();
    };

    return _this;
  }

  (0, _createClass2["default"])(TouchableView, [{
    key: "componentWillUnmount",

    /**
     * Clear all timeouts on unmount
     */
    value: function componentWillUnmount() {
      this._longPressDelayTimeout && clearTimeout(this._longPressDelayTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          accessibilityLabel = _this$props.accessibilityLabel,
          children = _this$props.children,
          className = _this$props.className,
          disabled = _this$props.disabled,
          style = _this$props.style,
          testID = _this$props.testID;
      var styleProps = {
        className: className,
        disabled: disabled,
        style: style
      };
      return /*#__PURE__*/React.createElement(_TouchableViewBase.DivTouchableViewBase, Object.assign({}, styleProps, {
        accessibilityLabel: accessibilityLabel,
        onKeyDown: this._onKeyDownUp,
        onKeyUp: this._onKeyDownUp,
        onResponderGrant: this._onResponderGrant,
        onResponderMove: this._onResponderMove,
        onResponderRelease: this._onResponderRelease,
        onResponderTerminate: this._onResponderTerminate,
        onResponderTerminationRequest: this._onResponderTerminationRequest,
        onStartShouldSetResponder: this._onStartShouldSetResponder,
        role: "button",
        tabIndex: disabled ? undefined : 0,
        testID: testID,
        tooltip: this.props.tooltip
      }), children);
    }
  }, {
    key: "_setOpacityTo",
    value: function _setOpacityTo(opacity, duration) {
      var containerRef = _reactDom["default"].findDOMNode(this);

      if (containerRef) {
        // $FlowFixMe
        containerRef.style.transitionDuration = duration ? "".concat(duration / 1000, "s") : '0s'; // $FlowFixMe

        containerRef.style.opacity = String(opacity);
      }
    }
  }]);
  return TouchableView;
}(React.Component);

TouchableView.defaultProps = {
  activeOpacity: 0.2,
  delayLongPress: LONG_PRESS_THRESHOLD,
  disabled: false
};
TouchableView.displayName = 'TouchableView';
var _default = TouchableView;
exports["default"] = _default;