"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var View = React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      onLayout = _ref.onLayout,
      pointerEvents = _ref.pointerEvents,
      style = _ref.style,
      testID = _ref.testID;
  var nativeViewRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      // To be able to use View inside TouchableHighlight/TouchableOpacity
      setNativeProps: function setNativeProps(props) {
        return nativeViewRef.current && nativeViewRef.current.setNativeProps(props);
      }
    };
  });
  var props = {
    accessibilityLabel: accessibilityLabel,
    onLayout: onLayout,
    pointerEvents: pointerEvents,
    style: style,
    testID: testID
  };
  return /*#__PURE__*/React.createElement(_reactNative["default"].View, Object.assign({}, props, {
    ref: nativeViewRef
  }), children);
});
var _default = View;
exports["default"] = _default;