"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = View;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ViewBase = require("../../../internals/web/ViewBase");

function View(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      onLayout = _ref.onLayout,
      pointerEvents = _ref.pointerEvents,
      style = _ref.style,
      testID = _ref.testID;
  var styleProps = {
    className: className,
    $pointerEvents: pointerEvents,
    style: style
  };
  return /*#__PURE__*/React.createElement(StyledViewBase, Object.assign({}, styleProps, {
    accessibilityLabel: accessibilityLabel,
    onLayout: onLayout,
    testID: testID
  }), children);
}

var pointerEventsAuto = "\n  pointer-events: auto;\n";
var pointerEventsBoxNone = "\n  pointer-events: none;\n  * {\n    pointer-events: all;\n  }\n";
var pointerEventsBoxOnly = "\n  pointer-events: all;\n  * {\n    pointer-events: none;\n  }\n";
var pointerEventsNone = "\n  pointer-events: none;\n  * {\n    pointer-events: none;\n  }\n";
var StyledViewBase = (0, _styledComponents["default"])(_ViewBase.DivViewBase).withConfig({
  displayName: "Viewweb__StyledViewBase",
  componentId: "sc-1fltyrz-0"
})(["", ";"], function (_ref2) {
  var $pointerEvents = _ref2.$pointerEvents;

  if ($pointerEvents === 'auto') {
    return pointerEventsAuto;
  } else if ($pointerEvents === 'none') {
    return pointerEventsNone;
  } else if ($pointerEvents === 'box-none') {
    return pointerEventsBoxNone;
  } else if ($pointerEvents === 'box-only') {
    return pointerEventsBoxOnly;
  }

  return '';
});